                                                         -*- coding: utf-8 -*-
Changes with IBM HTTP Server 9.0.5.28

  *) SECURITY: CVE-2026-44119 (cve.mitre.org)
     PH71061

  *) SECURITY: CVE-2026-33523 (cve.mitre.org)
     HTTP response splitting via multiple CGI and proxy-like
     modules. PH71061

  *) SECURITY: CVE-2026-41080 (cve.mitre.org)
     Update bundled expat to 2.8.0. PH71061

  *) SECURITY: CVE-2026-24072 (cve.mitre.org)
     Restrict expression syntax for mod_rewrite and mod_setenvif in htaccess.
     mod_proxy_fcgi is not affected on IHS. PH71061

  *) SECURITY: CVE-2026-32776 (cve.mitre.org)
     Update bundled expat to 2.7.5. PH70572

  *) SECURITY: CVE-2026-32777 (cve.mitre.org)
     Update bundled expat to 2.7.5. PH70572

  *) SECURITY: CVE-2026-32778 (cve.mitre.org)
     Update bundled expat to 2.7.5. PH70572

  *) postinstallation scripts meant to run from conf/postinst.d
     run with an unpredictable single-entry PATH or run-parts itself
     fails to find basic commands such as "basename". This is a 
     recently added feature that is essentially Linux-only via
     PH67714. PH70112

  *) Update zlib to 1.3.2 (Windows, AIX, linux). PH70248

  *) Update GSKit to 8.0.60.5. PH69738

Changes with IBM HTTP Server 9.0.5.27

  *) SECURITY: CVE-2025-66200 (cve.mitre.org)
     Changing internal "request notes" may confuse mod_userdir
     when suexec is enabled. Note: suexec is not provided with
     IBM HTTP Server.  PH68462

  *) SECURITY: CVE-2025-58098 (cve.mitre.org)
     Server Side Includes (SSI) enabled with mod_cgid (but not mod_cgi) passes
     the shell-escaped query string to #exec cmd="..." directives.
     IBM HTTP Server note: Only Linux and AIX include mod_cgid.  PH68462

  *) SECURITY: CVE-2025-65082 (cve.mitre.org)
     Environment variables set via the Apache configuration, including those
     set via .htaccess files, may unexpectedly supersede variables calculated
     by the server for CGI programs. PH68462

  *) SECURITY: CVE-2025-59775 (cve.mitre.org)
     Windows: NTLM leakage when the following non-default settings are both
     enabled: "AllowEncodedSlashes On" and "MergeSlashes Off". PH68462

  *) SECURITY: CVE-2025-59375 (cve.mitre.org)
     Update bundled libexpat to 2.7.3, removing IHS customizations.
     PH68462

  *) SECURITY: CVE-2026-24515 (cve.mitre.org)
     Vulnerability in bundled expat. Vulnerable function
     XML_ExternalEntityParserCreate is not used by IHS on
     any platform. PH69843

  *) SECURITY: CVE-2026-25210 (cve.mitre.org)
     Vulnerability in bundled expat, IHS is not vulnerable due
     to conservative upper limits on LimitXMLRequestbody. PH69843

  *) Linux, AIX, and Windows: Update bundled expat to expat-2.7.4.
     PH69843

  *) Linux and zOS: Fix possible crash in process_socket in event.c
     after PH66956. PH69947.

  *) Linux and AIX: add ihsdiag collector and bin/ihsdiag.sh to invoke
     it.

  *) mod_so: add IgnoreModule directive to ignore later LoadModule by
     module name. PH69649.

  *) Upgrade miscellaneous dependencies, replacing older patched levels.
     PH69769

       zlib 1.3.1 (Linux, AIX, and Windows only)
       PCRE 10.47
       Lua 5.4.8

  *) mod_deflate: Revert dependencies on /lib/libzz64.so which caused program 
     control errors with mod_authnz_saf. PH69573.

Changes with IBM HTTP Server 9.0.5.26

  *) mod_ibm_ssl: Add support for running SSL initialization during a config
     test (apachectl -t) when -DTEST_SSL_CONFIG is explicitly passed on the
     command line. This is primarily used to validate the configured key store.
     PH67897

  *) If /usr/bin/run-parts is present, run compatible scripts
     in $IHSROOT/conf/postinst.d/ when updates are applied.  PH67714
     Note: This is effectively linux-only due to the check for
     /usr/bin/run-parts

  *) mod_ibm_ssl: Replace SSLRevocationLibCurlEnable with 
     SSLRevocationIHSInternalClientEnable now that the the default GSKit
     client will not try to use libCURL.  Distributed only. PH67623.

  *) zOS: Fix an unlikely reason for PH61590 to be ineffective and log the 
     message sent to the operator console to the IHS error_log too. PH67551

  *) Remove AH02031/AH02032 and associated HTTP 400 errors. These SNI related
     checks ported from Apache do not make sense in the SSL implementation in
     IHS. PH68132

Changes with IBM HTTP Server 9.0.5.25

  *) SECURITY: CVE-2025-54090 (cve.mitre.org)
     mod_rewrite: 'RewriteCond expr' always evaluates to true after PH67153.
     PH67414

  *) SECURITY: CVE-2024-43394  (cve.mitre.org)
     Windows: SSRF via UNC and mod_rewrite / expressions.  PH67153

  *) SECURITY: CVE-2024-42516 (cve.mitre.org)
     core: Fix Content-Type response splitting.  PH67153

  *) SECURITY: CVE-2024-43204 (cve.mitre.org)
     SSRF via Header directive setting malicious Content-Type. PH67153

  *) core: Allow SetEnv to override native environment variables like
     LD_LIBRARY_PATH, which allows hiding IHS bundled libraries like
     libexpat and libpcre from CGI-like programs launched by the server. 
     PH67529

  *) mod_ibm_ssl: Remove CBC based TLS ciphers from the TLSv12 defaults. 
     On zOS, this change only affects the defaults when ICSF is being used and affects
     SSLV3, TLSv10, and TLSv11 as well as TLSv12 although protocols older than TLSv12 are
     already disabled by default.
     The removed TLSv12 ciphers are:
        TLS_ECDHE_{RSA,ECDSA}_WITH_AES_256_CBC_SHA384
        TLS_ECDHE_{RSA,ECDSA}_WITH_AES_128_CBC_SHA256
        TLS_ECDHE_{RSA,ECDSA}_WITH_AES_256_CBC_SHA
        TLS_ECDHE_{RSA,ECDSA}_WITH_AES_128_CBC_SHA
     PH66648


  *) mpm_event: Improve behavior and logging around the condition of a
     process with no idle worker threads.  Adds directives
     IHSKeepaliveCloseOnActivity and IHSKeepaliveCloseAll.  PH66956

Changes with IBM HTTP Server 9.0.5.24

  *) Ensure the embedded libexpat is always used with an entity handler.
     PH65829

  *) Remove support for the obscure DUPNAMES option in the embedded PCRE.
     PH65827

  *) mod_ibm_ssl: When TLS if offloaded in front of IBM HTTP Server,
     and the per-request internal environment variable "ihs-force-https"
     is set to any value, this module will tell the core of the server that
     the current requests scheme (protocol) is https. 
     In addition to the scheme used in self-referential redirect URLs, this
     affects the port and protocol passed between the WebSphere WebServer 
     Plug-in and the application server.  PH64800

Changes with IBM HTTP Server 9.0.5.23

  *) SECURITY: CVE-2024-50602 (cve.mitre.org)
     Backport from libexpat 2.6.4. IHS is affected, not vulnerable.  PH64037

  *) mod_ibm_ssl: Under GSKit 8.0.60.0 and later, use an IHS HTTP client
     for OCSP and CRL outbound requests rather than GSKits HTTP client which
     now depends on libcurl. Revert to GSKit+libcurl via IHS directive
     SSLRevocationLibCurlEnable. Distributed only. PH64942

Changes with IBM HTTP Server 9.0.5.22

  *) SECURITY: CVE-2023-49582 (cve.mitre.org)
     Lax permissions in APR named shared memory.
     Note: Did not affect IBM HTTP Server.  Mentioned here only to record
     CVE-2023-49582 in `apachectl -V`. 

  *) APR: Restrict read permissions on files used to establish SysV
     shared memory. PH62717

  *) Event MPM: Improve and add diagnostics around a rare issue where
     far more threads than are configured are created during startup
     in every child process. PH63406

  *) Port some libexpat 2.6.3 fixes to IHS. PH63077

  *) Instrument the map_to_storage hook with %{RH}e. Timing available in
     %{TMS}e.  PH62889

  *) mod_ldap: Upgrade IBM LDAP SDK to 10.0.3 on Linux (all but PPC big-endian)
     and AIX.

  *) ikeyman: pass arguments through to Ikeyman, such as -D system properties.

  *) mod_deflate: Add DeflateMinLength. PH63338


Changes with IBM HTTP Server 9.0.5.21

  *) SECURITY: CVE-2024-40898 (cve.mitre.org)
     Potential SSRF with mod_rewrite on Windows. PH62263

  *) SECURITY: CVE-2024-40725 (cve.mitre.org)
     Source code disclosure with handlers configured via AddType.
     PH62263

  *) SECURITY: CVE-2024-39884 (cve.mitre.org)
     Apache HTTP Server configurations that configure handlers
     with AddType may be served as static files.
     Note: Did not affect IBM HTTP Server.  PH61893.

  *) SECURITY: CVE-2024-38472 (cve.mitre.org)
     Apache HTTP Server on WIndows UNC SSRF. UNC hosts intentionally
     accessed must be listed in `UNCList` directive.
     PH61893.

  *) SECURITY: CVE-2024-38473 (cve.mitre.org)
     Apache HTTP Server proxy encoding problem may result in
     authentication bypass.  PH61893.

  *) SECURITY: CVE-2024-38474 (cve.mitre.org)
     Apache HTTP Server mod_rewrite weakness with substitued variables
     and backreferences containing decoded %3f.  Some rules may need to
     add flag UnsafeAllow3F.  PH61893.

  *) SECURITY: CVE-2024-38475 (cve.mitre.org)
     Apache HTTP Server weakness when RewriteRule is used in server context
     and a backreference or variable in the substitution exists in the first
     segment of the substituted path.  PH61893.

  *) SECURITY: CVE-2024-38476 (cve.mitre.org)
     Apache HTTP Server weakness with an exploitable or malicious backend
     CGI/proxy application could internally redirect to any registered handler.
     PH61893.

  *) SECURITY: CVE-2024-38477 (cve.mitre.org)
     Crash with mod_proxy loaded.  PH61893.

  *) SECURITY: CVE-2024-39573 (cve.mitre.org)
     Rewrite SSRF with mod_proxy loaded.  PH61893.

  *) zOS: Add support for environment variable IHS_CHILD_NOEXIT_ACTION which
     controls how the server reacts when a process does not terminate during
     shutdown.  PH61590.
     The value "operconsole" causes a message to be written to the
     operator console. The message will include the text 'CRIHS0007I'
     The value "ceedump" causes a SIGUSR2 to be sent to the
     process which will call the cdump() routine to write a CEEDUMP. A CEEDUMP
     can be delayed and incomplete  on modern zOS releases if
     _CEE_CONDWAIT_PAUSE=NO is not also set in the environment.

  *) Stop linking with libcrypt.so.1 on Linux. Instead, move crypt dependencies
     into APR and dlopen libcrypt.so.

  *) Update bin/quickssl.{bat,sh} in the IHS archive install to set a
     SAN DNS name.  PH61821

Changes with IBM HTTP Server 9.0.5.20

  *) SECURITY: CVE-2024-24795 (cve.mitre.org)
     HTTP Response splitting in multiple modules. PH60619

  *) SECURITY: CVE-2023-38709 (cve.mitre.org)
     HTTP response splitting via malicious or exploitable backend/content
     generators. PH60619

  *) sidd: Add logging and timeouts related to communication between
     mod_ibm_ssl and sidd. PH60777

  *) mod_mpmstats: Potential crash on Windows at shutdown or
     MaxRequestsPerChild. PH60863

  *) mod_ibm_ssl: Stop reporting a generic SSL0212E for some obscure cases where
     SSLHandhsakeTimeout was explicitly triggered. PH60645

  *) worker, event: Avoid possible hangs and crashes during shutdown of
     child processes that fail to start their configured threads.
     [Yann Ylavic, Eric Covener]. PH60306

  *) Backport some post-2.6.0 libexpat changes. PH60402

  *) event: Improve the bookkeeping of processes that are gracefully
     exiting, including across graceful restarts. Adds some details to
     existing AH03490 message. PH60185

Changes with IBM HTTP Server 9.0.5.19

  *) SECURITY: CVE-2023-52425 (cve.mitre.org)
     Vulnerability in included libexpat. PH59697

  *) z/OS: bin/envvars in newly created IHS instances now enables
     HEAPPOOLS and HP64 by default. PH59165

  *) z/OS: For the error_log entry that logs the z/OS release, display
     friendly alternative to the large numbers returned by uname(), e.g.
     release "29" is z/OS "3.1". Also increase the level to NOTICE.

  *) zOS: Fix possible crashes at the end of `apachectl -t`.
     PH59012

  *) event: Log consecutive failing accept() calls and give the option
     to gracefully exit. z/OS only. PH57408.

Changes with IBM HTTP Server 9.0.5.18

  *) SECURITY: CVE-2023-31122 (cve.mitre.org)
     Out-of-bounds Read vulnerability in mod_macro
     PH57715

  *) mod_ibm_ssl: Port PH31409 to z/OS.

  *) core: Close the connection after responding to a request with both
     Content-Length and chunked encoding. PH56383

  *) mod_rewrite: Fix a regression with both a trailing ? and [QSA]. PR66672

  *) apachectl: Report on some potential problems when invoking httpd fails.
     PH56340

  *) core: 'ExtendedStatus' now defaults to ON even when mod_status is not loaded.
     PH56308

  *) mod_mpmstats: The 'AlwaysReport' directive causes a report to be issued once
     per second rather than once per report interval.  PH56097

  *) zOS: When a child process crashes due to a fatal signal, remove the
     message queue it was using. PH56093

  *) mod_ldap: Upgrade IBM LDAP SDK to 10.0.1 on Linux (all but PPC big-endian)
     Windows, and AIX. This enables TLS1.3 by default for LDAP SSL connections. PH55900

  *) mod_ldap: Add server scope `LDAPSSLProtocol` directive. Values are comma-separated
     selection from range SSLV3,TLS10,TLS11,TLS12,TLS13. SDK default is "TLS12,TLS13" on
     Linux (all but PPC big-endian) Windows, and AIX. PH55900

Changes with IBM HTTP Server 9.0.5.17

  *) postinst: Be tolerant of missing files that are edited post installation,
     primarily for interim fix installations.  PH55613

  *) mod_ibm_ssl:  On zOS, improve the ICSF detection in bin/envvars.  This change
     is picked up on new instances only, see bin/envvars-std. PH55434

  *) mod_ibm_ssl: Add SSLOCSPCacheSize to enable/control the OCSP cache size.
     PH54894

Changes with IBM HTTP Server 9.0.5.16

  *) SECURITY: CVE-2023-25690 (cve.mitre.org)
     mod_proxy: HTTP request smuggling via mod_rewrite and mod_proxy
     PH53014

  *) mod_log_config: Add %{tzoff}t as an alternativce to %{%z}t on Windows. PH53848

  *) Update GSKit to 8.0.55.31. PH44893

  *) mod_rewrite: Add [BPCTLS] and [BNE] rule flags. Slight change to default escaping
     with the [NE] flag.  PH53014

  *) event MPM: Possible high CPU when at or near MaxClients. PH52860

  *) mod_rewrite: Fix regression in PH53014 interim fixes for RewriteRule with trailing '?'
     PH54015

  *) rotatelogs: Add -R flag to truncate rotated files, but not the initial
     opened log file.

  *) rotatelogs: With -n and without -f, the very first write could have been
     sent to the initial "logfile" even if if "logfile" was already at its
     limit

  *) core: Improve error_log entry for invalid HTTP header name or value
     by identifying the first bad character.  PH52642

  *) mod_ibm_ssl: SSLMinimumRSAKeySize on distributed platforms with
     "SSLClientAuth REQUIRED_RESET" does not have a specific
     "Certificate validation error during handshake..." error logged when
     SSLMinimumRSAKeySize is the cause of the invalid certificate.

  *) mod_ibm_ssl: Add SSLSupportedCurves directive to allow customization
     of the curves offered during ECDHE key exchange. PH51678

  *) mod_ibm_ssl: On z/OS, secp192r1 and secp224r1 are no longer enabled by
     default for ECDHE key exchange over TLSv12. PH51678

Changes with IBM HTTP Server 9.0.5.15

  *) SECURITY: CVE-2022-25147 (cve.mitre.org)
     apr-util: Integer Overflow or Wraparound vulnerability in apr_base64
     functions of Apache Portable Runtime Utility (APR-util) allows an
     attacker to write beyond bounds of a buffer. PH51982

  *) SECURITY: CVE-2022-28331 (cve.mitre.org)
     apr: APR may write beyond the end of a stack based
     buffer in apr_socket_sendv(). This is a result of integer overflow
     PH51982

  *) SECURITY: CVE-2022-37436 (cve.mitre.org)
     mod_proxy: Prior to Apache HTTP Server 2.4.55, a malicious backend can
     cause the response headers to be truncated early, resulting in
     some headers being incorporated into the response body. If the
     later headers have any security purpose, they will not be
     interpreted by the client. PH51982

  *) SECURITY: CVE-2006-20001 (cve.mitre.org)
     mod_dav: A carefully crafted If: request header can cause a memory read,
     or write of a single zero byte, in a pool (heap) memory location
     beyond the header value sent. This could cause the process to
     crash. PH51982

  *) SECURITY: CVE-2022-43680 (cve.mitre.org)
     Update bundled expat. PH50316

  *) SECURITY: CVE-2017-9233 (cve.mitre.org)
     Update bundled expat. PH50316

  *) SECURITY: CVE-2013-0340 (cve.mitre.org)
     Update bundled expat. PH50316

  *) mod_ibm_ssl: Add SSLMinimumRSAKeySize directive to reject client
     certificates with RSA keys smaller than specified. On distributed,
     this directive additionally checks the servers own certificate
     and all RSA keys in both full certificate chains. PH51709

  *) z/OS: 'Upgrading from ...' message may be output as unreadable characters
     if `sed` is an ascii-ized port. PH54411

  *) mod_ibm_ssl: Add environment variables SSL_CLIENT_KEY_ALG and
     SSL_CLIENT_KEY_SIZE to allow logging and expressions based on the
     client certificate key details. Distributed only. PH51709

  *) mod_ibm_ssl: Remove RSA key exchange ciphers from defaults.
     On z/OS, defaults are only changed when ECDHE ciphers are selected
     for the defaults, which is the result of probing ICSF at startup.
     PH51473.

Changes with IBM HTTP Server 9.0.5.14

  *) SECURITY: CVE-2022-40674 (cve.mitre.org)
     Update bundled expat.  PH49572

  *) Update GSKit to 8.0.55.29. PH49311

  *) mod_ibm_ssl: Add SSLServerCertEnvDynamic directive. By default, SSL_SERVER_*
     variables as used in logging are only set once per virtual host. When set to
     ON, the data is set on each connection. A different result only occurs if
     these variables are used in the configuration file and either SNI is enabled
     or SSLServerCert has two arguments.  PH48807

  *) core: Add KeepAliveTimeoutSend408 directive to allow the server to respond with
     a HTTP 408 response instead of closing keepalive connections. This may help
     POST-heavy environments that are not retryable that encounter HTTP keepalive
     close races.  PH48206

  *) mod_authnz_saf: Passwords with a single forward slash were not accepted
     by this module. PH48168.

  *) mod_ibm_ssl: The second certificate in the case of two-argument
     "SSLServerCert" could not be used unless TLS Server Name Indication (SNI)
     processing was used to select the server certificate. PH47941

  *) mod_ibm_ssl: TLS Server Name Indication (SNI) was unintentionally enabled for
     the default (first-listed) TLS virtual host in each set of addr:port virtual
     hosts. PH47941

  *) Track WAS Plugin specific request states, adding loggable
     variables below (all units in milliseconds)
     - TPCN: Time spent establishing a connection, including SSL.
     - TPSB: Time spent forwarding a HTTP request body
     - TPWR: Time spent waiting on the first line of the HTTP response
     - TPRB: Time spent reading and forwarding the body.
     PH47518

  *) mod_mpmstats: Report the average response time of active requests in the
     WAS Plugin along with WAS Plugin specific request states. PH47518

Changes with IBM HTTP Server 9.0.5.13

  *) SECURITY: CVE-2022-28615 (cve.mitre.org)
     ap_strcmp_match() buffer overread. PH46897

  *) SECURITY: CVE-2022-29404 (cve.mitre.org)
     mod_lua: r:parsebody denial of service. PH46897

  *) SECURITY: CVE-2022-30556 (cve.mitre.org)
     mod_lua: information disclosure. PH46897

  *) SECURITY: CVE-2022-31813 (cve.mitre.org)
     mod_proxy: mod_proxy may fail to send X-Forwarded-For where it's expected
     PH46897

  *) SECURITY: CVE-2022-28614 (cve.mitre.org)
     ap_rwrite overrread. PH46897

  *) core: Add KeepAliveTimeoutDelay with a default value of 200ms to
     help avoid keepalive races. If KeepAliveTimeout already is configured
     with millisecond precision, the default value is 0. PH47348

  *) mod_log_config: When logging %h as used in the default log formats,
     respect changes made by mod_remoteip processing. PH47286

  *) core: Change the default of LimitRequestBody to 1GB to protect
     unsuspecting modules/configurations from extremely large request
     bodies. PH46897

  *) mod_so: If asked to load mod_authz_default, silently load mod_authz_core
     instead.  The former is used on IHS 8.5.5 and earlier, the latter is new
     to IHS 9.0.

  *) mod_mpmstats: Add "TrackHooksOptions notice" to log slow requests at
     NOTICE level instead of info.  PH46094

Changes with IBM HTTP Server 9.0.5.12

  *) SECURITY: CVE-2022-22720 (cve.mitre.org)
     core: HTTP request smuggling when errors are encountered
     discarding the request body. PH44829

  *) SECURITY: CVE-2022-22719 (cve.mitre.org)
     mod_lua: Use of uninitialized value in r:parsebody. PH44829

  *) SECURITY: CVE-2022-22721 (cve.mitre.org)
     core: ap_escape_html2 buffer overflow. PH44829

  *) SECURITY: CVE-2022-25313 (cve.mitre.org)
     Update bundled expat. PH44271

  *) SECURITY: CVE-2022-25315 (cve.mitre.org)
     Update bundled expat. PH44271

  *) SECURITY: CVE-2022-25235 (cve.mitre.org)
     Update bundled expat. PH44271

  *) SECURITY: CVE-2022-25236 (cve.mitre.org)
     Update bundled expat. PH44271

  *) z/OS: Set extattr +p not +ap on IHS binaries at install time. PH44330

  *) mod_mpmstats: On Windows, provide a backup mechanism for recognizing a
     that the parent process is restarting. If the primary mechanism doesn't
     work, the parent process will be blocked during reload. PH44114
    
  *) mod_ibm_ssl: With SSLFIPSEnable and SSLProxyEngine ON, handshakes may
     fail with GSK_ERROR_UNSUPPORTED.  PH43696

Changes with IBM HTTP Server 9.0.5.11

  *) SECURITY: CVE-2022-23990 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-23852 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22822 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22823 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22824 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22825 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22826 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2022-22827 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2021-45960 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2021-46143 (cve.mitre.org)
     Update bundled expat.  PH43122

  *) SECURITY: CVE-2021-44224 (cve.mitre.org)
     Possible NULL dereference or SSRF in forward proxy configurations. PH42862

  *) SECURITY: CVE-2021-44790 (cve.mitre.org)
     mod_lua: Prevent a buffer overflow when parsing invalid multipart/form-data
     request bodies. [Ruediger Pluem]. PH42862

  *) mod_ldap: Upgrade embdded ISDS LDAP library from 6.4.0.6 to 6.4.0.24.
     PH42072

  *) mod_ibm_ssl: Remove use of thread-local storage for SSL Session Caching
     on Linux/AIX/Solaris/HP-UX. Fixes a potential crash in sidDelete. PH42030.

  *) event mpm: Correctly count active child processes in parent process if
     child process dies due to MaxConnectionsPerChild.
     PR 65592 [Ruediger Pluem]. PH41945

  *) AIX: Add -g to compiler flags to improve gdb/truss output.

  *) Windows: Update Product and Version strings embedded in executables to
     avoid confusion with upsream Apache HTTP Server.

  *) Update conf/mime.types.default with latest from Apache HTTP Server
     2.4.51. New installs copy conf/mime.types.default to conf/mime.types

  *) z/OS: Cleanup a stale pidfile if it points to an inaccessible process
     or a process that does not have "httpd" in its command line. PH41413

  *) default conf: In new installs, don't load/enable mod_cgi[d] by default.
     Use Alias instead of ScriptAlias.

  *) mod_ibm_ssl: Allow %{SSL_HANDSHAKE_TIME}e to work with LogLevel info or
     higher instead of requiring SSLTrace / trace8.

  *) rotatelogs: Don't terminate under error conditions where a restart of the
     process will not help, such as linking a file with the -L argument. PH41075

  *) z/OS: Add directive "IHSTerminateChildrenOnParentCrash" defaulting to OFF.
     If set to ON in global context of httpd.conf, crashes of the IHS parent
     process (which cause an IHS job to exit) will cause a graceful shutdown of
     remaining IHS child processes. PH41075

  *) z/OS: If an assertion is hit that terminates a process, send the assertion
     messages to the z/OS operator console with message IHS00023. PH41075

  *) logresolve: bin/logresolve.exe fails/crashes on Windows. PH41074

Changes with IBM HTTP Server 9.0.5.10

  *) SECURITY: CVE-2021-40438 (cve.mitre.org)
     mod_proxy: Server Side Request Forgery (SSRF) vulnerability [Yann Ylavic]
     PH40343

  *) SECURITY: CVE-2021-34798 (cve.mitre.org)
     core: null pointer dereference on malformed request
     PH40343

  *) SECURITY: CVE-2021-39275 (cve.mitre.org)
     core: ap_escape_quotes buffer overflow
     PH40343

  *) mod_mpmstats: Resolve potential delayed server shutdowns on Windows.

  *) Update GSKit to 8.0.55.25. PH40832

  *) mod_rewrite: Fix UDS ("unix:") scheme for [P] rules.  PR 57691 + 65590.
     [Janne Peltonen <janne.peltonen sange.fi>]

  *) mod_proxy: Handle UDS URIs with empty hostname ("unix:///...") as if they
     had no hostname ("unix:/...").  [Yann Ylavic]

  *) mod_unique_id: Shrink window where mod_unique_id may produce duplicates.
     PH40691

  *) core: Avoid possible crashes when graceful restarts are requested
     rapidly / during startup. PH40725.

  *) postinst: Clear the properties/state/ifixes directory during update.

  *) mpm_event: Fix children processes possibly not stopped on graceful
     restart.  PR 63169.  [Joel Self <joelself gmail.com>]

  *) mod_ibm_ssl: Disable x25519 and x448 curves on z/Linux under TLS1.3
     to work around failures.  PH39992

  *) mod_ibm_ssl: Trace improvements under the event MPM.

  *) Fix rare potential startup crashes with "sigaction" in the backtrace.
     PH39660

Changes with IBM HTTP Server 9.0.5.9

  *) core: On z/OS, ErrorDocuments that specify literal strings were not
     translated correctly. PH38515

  *) simplepct.sh: Fix a bug that resulted in an unexpected
     variable in the path to plugin-cfg.xml

  *) setupadm: Fix chmod g+s of plugin-cfg.xml

  *) mod_whatkilledus: If mod_backtrace is not loaded, dump a backtrace during
     what whatkilledus report. Linux only. PH37899
     
  *) mod_ibm_ssl: Conditionally reduce severity of SSL0405E message for sockets
     that are already in lingering close. PH38112

  *) mod_ibm_ssl: Reduce severity of SSL0282E to INFO.

  *) mod_ibm_ssl: Remove TLSv10 and TLSv11 from defaults. PH36870

  *) mod_ibm_ssl: Remove TLSv13 CCM ciphers from defaults. IHS V9 only. PH36870

Changes with IBM HTTP Server 9.0.5.8

  *) SECURITY: CVE-2020-13938 (cve.mitre.org)
     Windows: Prevent local users from stopping the httpd process [Ivan Zhakov]
     PH35771

  *) SECURITY: CVE-2021-30641 (cve.mitre.org)
     Unexpected <Location> section matching with 'MergeSlashes OFF'
     PH35771

  *) Upgrade GSKit to 8.0.55.21. PH35915

  *) mod_authnz_saf: Add AuthSAFSetErrorReason.  PH35356

  *) Fix possible crash with StrictHostCheck.  PH35107

  *) mod_authnz_ldap: Fail early on missing password.

  *) z/OS: Update compiler to V2R2 and enable -qSTACKPROTECT.

  *) mod_ibm_ssl: Restore the ability to specify cipher "30"
    (SSL_NULL_WITH_NULL_NULL). PH34420

  *) core: "ErrorLogFormat" may not apply to some startup messages. PH34246.

  *) mod_ibm_ssl: "SSLClientAuth optional" with both "noverify" and "crl" option does
     not check CRL. PH33679

  *) mpm_event: Warn at startup if it looks like the hard-coded defaults are being used
     for MaxClients/MaxRequestWorkers et al.  This could be due to  <ifModule worker.c>
     when using event, or <ifModule event.c> specified before the LoadModule for mpm_event.

Changes with IBM HTTP Server 9.0.5.7

  *) default conf: Comment out prior default of "ServerSignature ON" to make it opt-in
     for new installations.

  *) default conf: Add a commented out ServerName directive to the sample SSL virtual host.

  *) mod_ibm_ssl: Add "SSLFatalErrorLimit" directive to gracefully terminate a process
     reporting too many SSL0209E/SSL0212E/SSL0203E handshake errors. Graceful shutdown
     message has ID IHS00019.  PH32229

  *) mod_ibm_ssl: Tolerate "SSLV3Timeout 0" when TLSv13 is enabled. PH31409.

  *) mod_net_trace: add a connection ID for proxy connections so they don't
     always show as 0.

  *) mod_ibm_ssl: Split out "GSK_ERROR_PROTOCOL_MISMATCH" from SSL0200E generic handshake message into
     a new SSL0286I, logged at information level.  n/a on z/OS. PH31169

  *) mod_ibm_ssl: Replace some SSL0226I (general handshake I/O error) with SSL0285I if handshake
     I/O timed out.

  *) mod_ibm_ssl: Add "SSLSkipCloseNotify" flag to disable sending the TLS close_notify alert during
     Apache socket shutdown.  The value of "ON" matches the 9.0.5.1 and earlier behavior. PH30841

  *) mod_rewrite: Add the internal map type "escape2" which acts like the [B] flag
     but can be selectively applied to individual backreferences. PH30854

  *) Windows: Remove MSVCRT dll for 32-bit Windows installs. MSVCRT is now installed during
     IHS installation. PH30660

  *) mod_ibm_ssl: Support 'SSLCipherSpec ALL|TLSv10|TLSv11|TLSv12|TLSv13 -RSA'
     to remove ciphers that use RSA key exchange. Similar for "-CBC". PH30598

  *) Update GSKit to 8.0.55.19. (Delays with large PKCS11 key stores) PH30795

  *) mod_ibm_ssl: Obey new environment variable 'IHS_NO_SSL_SEND_MERGE' to prevent
     the merging of small writes. PH30270

  *) mod_ibm_ssl: Support 'SSLCipherSpec TLSv10|TLSv11|TLSv12|TLSv13 NONE' to remove all ciphers
     from the given protocol. Previously 'NONE' was only valid when combined with the special
     pseudo-protocol 'ALL'

  *) resolve a rare mod_lua startup error with message id AH02665.

  *) mod_authn_cert: Set the internal r->user / REMOTE_USER even if no other
     authentication is configured. PH29569

Changes with IBM HTTP Server 9.0.5.6

  *) z/OS: IHS 9.0 install fails when trying to install plugin with WAS 8.5.5. Install failure
     due to plugin install script unable to find old Java path used in WAS 8.5.5. PH30541

  *) setupadm / PCT Admin Server Configuration: Fix for an existing user
     to be specifid during IHS Admin Server configuration when the target
     user is not in /etc/passwd (/etc/nsswitch.conf specifies something
     like winbind or sssd) PH29026.

  *) z/OS: Fix an issue where the install_ihs script may fail if an alias for ls is used.
     The script also no longer copies plugin directory unless plugin is enabled. PH28389.

  *) mod_ibm_ssl: In cases where existing message SSL0227E: would print "Label='(null)'",
     instead directly warn the user that there is no SSLServerCert specified and no
     default certificate.

  *) Fix a rare startup crash on Windows when LoadModule has an absolute path
     that contains some stray characters that resemble a drive letter and
     volume separator. PH28073

  *) During a normal shutdown, issue 'caught SIGTERM, shutting down' as soon as
     shutdown begins. In earlier levels, this message could be delayed, causing
     confusion when reconstructing a timeline of events.  n/a on Windows. PH27739

  *) mod_ibm_ssl: During a non-graceful shutdown, client sockets are closed long
     before threads are terminated even though those threads can no longer read or
     write to the client.  When this state is encountered, mod_ibm_ssl may
     have previously reported "bad file descriptor" or "invalid state" errors.
     After PH27739, some cases will report no error at all (such as closure)
     while others will more consistently report "broken pipe". 
     n/a on Windows. PH27739

  *) Windows: add/fix some included *.pdb files.

  *) archive: Ship swidtags. Distributed platforms only. PH27406.

  *) Add URL to AH0128 messages to diagnose problems with hostnames/ports.

  *) Add support for strict content-length parsing through addition of
     ap_parse_strict_length() [Yann Ylavic]

Changes with IBM HTTP Server 9.0.5.5

  *) mod_ibm_ssl: Some error messages that attempt to print the servers signature
     algorithm during handshake errors were unable to log it if the failing
     handshake was the first handshake. Distributed only.

  *) mod_cgi: On z/OS, append the CGI PID to the SSL01220 message that
     indicates the CGI has timed out, and add an explicit warning that
     the process will be killed.  PH26048.
 
  *) mod_ibm_ssl: Set ICC_FATAL=stderr by default.

  *) mod_ibm_ssl: Drop severity of SSL0284E and SSL0279E from "error" to "info"
     when the TLS alert is "certificate_unknown".

  *) mod_lua: Preload liblua.so to avoid ABEND=S422
     REASON=000001A0. z/OS only.

  *) mod_ibm_ssl: Fail startup if ciphers TLS_AES_128_CCM_SHA256 or TLS_AES_128_CCM_8_SHA256
     are configured on z/OS.  These are not yet implemented in System SSL and if they are
     manually added to the configuration every handshake will fail.

  *) mod_ibm_ssl: Add Key Share 0029 on z/OS.

  *) mod_ibm_ssl: A specific set of "SSLCipherSpec ALL -..." results in
     defaults being used instead of modified. "SSLCipherSpec ALL +|-" might
     fail trying to load TLS13 ciphers on z/OS prior to 2.4. z/OS only.
     PH24557.

  *) archive: Post Installer for IHS archive will now fail if postinst fails
     (IBM for PH24402)

  *) default conf: On Windows, removed a superceded LogFormat.

  *) mod_reqtimeout: Use name-based vhosts body timeouts.

  *) mod_mpmstats: For each "approaching MaxClients" message issued, log a similar
     message when the condition is cleared.  PH24265

  *) mod_mpmstats: Add MPMStatsBusyThreshold to allow the "approaching MaxClients"
     message to be issued at thresholds other than the default of 90%. PH24265

  *) mod_mpmstats: Add 'MPMStatsSystemLog ON' (z/OS only) to duplicate the "approaching MaxClients"
     message to the z/OS system log.  PH24265

     The message has the following format:
    
        BPXM023I ($USERID) CRIHS0004W $JOBNAME mpmstats: approaching MaxClients ($THREADSUSED/$MAXCLIENTS)                                                                 
        BPXM023I ($USERID) CRIHS0005W $JOBNAME mpmstats: reached MaxClients ($THREADSUSED/$MAXCLIENTS)                                                                 

     When the condition is cleared, a similar message with CRIHS0006I is issued.

  *) upgrades: Installations using non-default ports log a message including
     PORT=80 instead of the custom port. PH24262

Changes with IBM HTTP Server 9.0.5.4

  *) SECURITY: CVE-2020-1927 (cve.mitre.org)
     rewrite, core: Set PCRE_DOTALL flag by default to avoid unpredictable
     matches and substitutions with encoded line break characters.
     The fix for CVE-2019-10098 was not effective.  [Ruediger Pluem]
     PH21992, PH22279 (z/OS SMPE)

  *) SECURITY: CVE-2020-1934 (cve.mitre.org)
     mod_proxy_ftp: Use of uninitialized value with malicious backend FTP
     server. [Eric Covener] PH21992, PH22279 (z/OS SMPE)
    
  *) Update GSKit to 8.0.55.15. (SSL0209E with IHS 9.0.5.2 and later)
     PH24493

  *) z/OS: Mark bin/rotatelogs as program controlled so if it is spawned it will
     not mark the parent address space dirty. PH23596.
    
  *) core: Print the z/OS release at startup.

  *) mod_cgi: Log a warning (IHS00018) when a client reading CGI output disconnects
     before the CGI has completed.  By default, the CGI is sent a SIGTERM signal when
     the request ends which may be recorded in the z/OS system log if the CGI
     does not handle the SIGTERM itself.

     To reduce the warning to a trace message, set per-request environment variable
     ihs-cgi-brokenpipe to "trace":  SetEnvIf Request_URI .* ihs-cgi-brokenpipe=trace
    
     To have the server continue reading from the CGI after the client has
     disconnected, giving it a chance to exit gracefully, set
     ihs-cgi-brokenpipe to "soak": SetEnvIf Request_URI .* ihs-cgi-brokenpipe=soak

     z/OS and Windows (mod_cgi) only.

     PH23551. 

  *) core: Add ap_is_chunked to check if final transfer-encoding is chunked
     or not. PH21992, PH22279 (z/OS SMPE)
 
  *) mod_ibm_ssl: Extend 'SSLCLientAuth optional noverify' with optional
     additional parameters noverify_allow_expired and noverify_record_expired.

     * noverify_allow_expired allows certificates or certificate chains with expired
     certificates to be accepted as valid. 

     * noverify_record_expired adds all certificate details to internal variables
     referenced by other parts of the server, but still subjects requests on this
     connection to SSLClientAuthVerify checks.

     PH23397

  *) Update GSKit to 8.0.55.13. PH21804

  *) mpm_event: Avoid possible KeepAlveTimeout off by -100 ms.
     PH22727

  *) mod_usertrack: Add CookieSameSite, CookieSecure, and CookieHttpOnly
     to control mod_usertracks cookie. [Prashant Keshvani]

  *) mod_usertrack: If per-request environment variable 'usertrack-force-setcookie'
     is set, force the cookie to be sent even when it was present in the request.
     This allows forcing e.g. SameSite=None. [Eric Covener]

  *) mod_ibm_ssl: Add SHA1 back to supported signature algorithms for
     SSLProxyEngine.

  *) mod_ibm_ssl: Add 'NULL' attribute type to SSLAttributeSet.

  *) mod_mpmstats: Add %{TTN}e to instrument the translate_name hook with
     the `TrackHooks` extended timings.

  *) core: Allow Host: header values where the final component begins with a
     digit. PH21717

  *) mod_ldap: Fix a case where a full LDAP cache would continually fail to
     purge old entries and log AH01323. PR61891. 
     [Hendrik Harms <hendrik.harms gmail.com>]

  *) mod_ibm_ssl: Allow TLS client certificate SAN extensions to be logged
     or queried.  SSL_CLIENT_SAN_DNSNAME, SSL_CLIENT_SAN_DIRECTORYNAME,
     SSL_CLIENT_SAN_IPADDRESS, SSL_CLIENT_SAN_RFC822NAME (email), and
     SSL_CLIENT_SAN_URI environment variables are added. Their value is a
     comma-separated list of values based on the client certificate. 
    
     The n-th individual value is also available by appending _n to the variable name.  

     The Apache expression parser is updated to allow evaluating these values in
     list context such as the following:
     > Require expr "'example.com' -in SSL_CLIENT_SAN('DNSNAME')".

     SSLCLientAuthRequire is updated to allows tokens with the following syntax
     to be used for comparison: SAN<type>{0-3} e.g. SANDNSNAME0 or SANURI3.

     The SAN names are also added to the internal per-request environment
     variables in two forms, a comma-separated list such as SSL_CLIENT_SAN_DNSNAME
     and indexed such as SSL_CLIENT_SAN_DNSNAME_0.  Unlike SSLCLientAuthRequire
     tokens, the indexes in environment variables can go beyond 3.

     Distributed only. PH20989

Changes with IBM HTTP Server 9.0.5.3
 
  *) mod_headers: Allow "early" to mixed with env= by beginning an environment
     clause with "early;" as in "early;env=some-var". PH20970

  *) mod_setenvif: Allow SetEnvIf directives to run before mod_headers in early
     mode by specifying an env-variable clause of "--early". PH20970

  *) mod_ibm_ssl: With SSLFIPSEnable, disable X22519 and X448 curves in TLS13
     which do not currently have a FIPS certified implementation in GSKit. 
     This change can be disabled by changing "SSLFIPSEnable" to
     "SSLFIPSEnable uncertified" which uses FIPS-approved protocols but allows
     non FIPS-certified implementations.  PH20613.

  *) mod_proxy: Additional detail and debug messages around HTTP request
     body forwarding

  *) mod_ibm_ssl: If SSL0279E is printed with an alert type of 'certificate_unknown',
     provide more details in new message SSL0284E. PH19074
     Distributed only.

  *) mod_ibm_ssl: Add new SSL I/O error identifier SSL0414I to display TLS
     alerts receiveed after the handshake has completed. Previously generic
     SSL0400I was used without alert details and an error code of 446.
     Distributed only.

Changes with IBM HTTP Server 9.0.5.2
 
  *) mod_ibm_ssl: Revert minimum RSA key size increase from 2048 to 1024 bits.
     (distributed only)

  *) core: Improve the message AH03448.

  *) mod_ibm_ssl: Expand SSL0223E ("No certificate") to call
     out MD5 and SHA224 signature algorithms.

  *) mod_ibm_ssl: On z/OS V2R3 and later, allow two-argument SSLServerCert to allow
     simultaneous configuration of an RSA and ECDSA certificate.  Can also be used by
     multiple SSLSNIMap. PH18102

  *) mod_ibm_ssl: Multiple certificates + SNI + ServerAlias did not use the second
     listed certificate when a request for the ServerAlias hostname arrived. PH18102

  *) mod_ibm_ssl: Expand SSL0230I error message when it occurs on an SNI enabled
     virtual host. PH18102

  *) mod_ibm_ssl: Fix a rare cause for truncated responses that are logged w/
     SSLTrace as "SSL secure_write nbytes=0 ... GSK_INVALID_BUFFER_SIZE"
     (IBM for PH17652)

  *) mod_authnz_saf: With SAFRunAsEarly, decode the URL as the core would before
     running an early location-walk.  This fixes a bug with mod_mvsds and URL-encoded
     characters. PH17056

  *) mod_ibm_ssl: Don't report TLSv12 in SSL0222W/SSL0240I since it could be
     TLSv13.

  *) sidd: Update entries in place.

  *) mod_ibm_ssl: Send close_notify alerts when sockets are shutdown for
     writing.

  *) mod_ibm_ssl: Add TLS1.3 support.
     (IBM for PH17128)

  *) mod_ibm_ssl: The delta time reported in the `SSL Handshake complete`
     message only showed the millisecond remainder if the handshake took
     longer than 1 second.

  *) Upgrade GSKit to 8.0.55.11
     (IBM for PH13105)

Changes with IBM HTTP Server 9.0.5.1
 
  *) SECURITY: CVE-2018-20843 (cve.mitre.org)
     Resolve CVE-2018-20843 in included libexpat, used by mod_dav and
     potentially third-party modules.
     (Backport for PH14974)

  *) SECURITY: CVE-2019-10092 (cve.mitre.org)
     Remove HTML-escaped URLs from canned error responses to prevent misleading
     text/links being displayed via crafted links. [Eric Covener]

  *) mod_ibm_ssl: On z/OS, replace likely misleading SSL0234W message with new
     SSL0283E message when TLS Client Authentication is not enabled.

  *) mod_ibm_ssl: On z/OS, replace generis SSL0200E handshake error referencing
     return code "541" on z/OS 2.4 with existing TLS alert-related message
     SSL0282E
 
  *) mod_alias: If the redirect target of the `Redirect` or `RedirectMatch`
     directives begins with a slash, new directive `RedirectRelative ON`
     prevents the server from adding the servers scheme, host, and port as
     a prefix.  Enabling this directive restores the redirect behavior from
     earlier IHS releases.
     (IBM for PH13615)

  *) ldap: Add `AuthLDAPDNFromBindAsUser ON` directive to allow skipping
     the retrieval of the HTTP users DN from a configured LDAP server.
     This requires AuthLDAPInitialBindAsUser and AuthLDAPInitialBindPattern
     to determine the users DN.  Used in environments where no dedicated
     AuthLDAPBindDN is specified but users cannot lookup their own
     distinguished names (SDBM with RACF SEARCH limitations)
     (IBM for PH12421)

  *) core: Add INFO level message with more details when AH00566
     is triggered due to what seems like SSL on a non-SSL virtual host.

  *) z/OS: Resolve permission errors during server start after applying
     fixpacks in environments where the user who runs install_ihs differs
     from the user who starts IHS.
    
     The following directories will now use the shared group ID specified
     by the `-group` parameter passed into install_ihs:
     bin, build, include, icons, lib, and modules

     See PI76918 for more information regarding the `-group` parameter.
     (IBM for PH10089)

  *) mod_ibm_ssl: Allow TLS protocols to be enabled/disabled when FIPS is
     enabled.
     (IBM for PH10382)
 
  *) mod_cgi: Pass RLimitCPU and RLimitMem through to CGI processes executed with
     __spawn2() on z/OS. Requires OA57179.
     (IBM for PH10103)

Changes with IBM HTTP Server 9.0.5.0
 
  *) SECURITY: CVE-2019-0220 (cve.mitre.org)
     Merge consecutive slashes in URL's. Opt-out with
     `MergeSlashes OFF`. [Eric Covener]
     (Backport of r1855737 r1855751 r1855853 for PH09869)

  *) SECURITY: CVE-2019-0211 (cve.mitre.org)
     MPMs unix: Fix a local priviledge escalation vulnerability by not
     maintaining each child's listener bucket number in the scoreboard,
     preventing unprivileged code like scripts run by/on the server (e.g. via
     mod_php) from modifying it persistently to abuse the priviledged main
     process.  [Charles Fol <folcharles gmail.com>, Yann Ylavic]
     (Backport of r1855378 for PH09869)

  *) SECURITY: CVE-2019-10098 (cve.mitre.org)
     rewrite, core: Set PCRE_DOTALL flag by default to avoid unpredictable
     matches and substitutions with encoded line break characters.
     [Yann Ylavic]

  *) z/OS: Added the mod_request module.
     (IBM for PH12690)

  *) mod_mime: Add `MimeOptions` directive to allow Content-Type or all metadata
     detection to use only the last (right-most) file extension.
    (IBM for PH09519)

  *) mod_a2e: The name of configuration directive "A2ESourceEnc" was corrected
     from "A2ESourceEnc2".

  *) z/OS: Log installation details such as installation type (SMP/E or IIM),
     architecture, and version of IHS. The same information is also printed for
     `apachectl -V` and `apachectl -v`.
     (IBM for PH08035)

  *) default conf: quote %{WAS}e

  *) windows: Added the directive ServiceDescription that allows users to append
     to the description of the Windows service for IHS.
     (IBM for PH07275)

  *) windows: Load mod_backtrace in the default configuration. This takes
     affect only for full installs at this level or later, otherwise see
     conf/httpd.conf.default.

  *) mod_whatkilledus: Change the default of WKUDisableWindowsErrorBox to ON.

  *) mod_include: Added the SSIOption DefaultEchoEncoding option to change the
     default encoding used for echo commands in SSI documents.
     (IBM for PH07089)
 
  *) mod_include: Updated the DGW-style variable expansion parser for SSI
     documents to only do variable expansions if they exactly match the
     syntax `&var;`. z/OS only.
     (IBM for PH07089)

  *) mod_include: On z/OS, SSI documents may be rendered with duplicate
     characters shortly after instances of `&`. For example, an SSI document
     containing `cou&ntry.` may render as `cou&ntry..`. This was a regression
     introduced with PI98705.
     (IBM for PH07089)
 
  *) mod_include: Added the SSIOption DollarSignExpansion option for
     compatibility with DGW SSI documents. DollarSignExpansion can be used to
     disable the expansion of `$var` variables in SSI documents to behave like
     DGW that uses only `&var;` for variable expansions. z/OS only.
     (IBM for PH07089)

Changes with IBM HTTP Server 9.0.0.11

  *) SECURITY: CVE-2018-17199 (cve.mitre.org)
     mod_session: Removed mod_session, mod_session_cookie, and mod_session_dbd.
     (IBM for PH06010)

  *) mod_headers: Allow request and response headers to be removed using
     regex with RequestHeader unset* and Header unset*, respectively.
     (IBM for PH05852)

  *) postinstall: Suppress harmless error messages when the server's fully
     qualified domain name could not be determined when configuring the
     administration server manually.
     (IBM for PH05575)

  *) core: Incorrect values for environment variables are substituted when
     multiple environment variables are specified in a directive.
     (IBM for PH05560)

  *) mod_ibm_ssl: Extend SSL0280E with details of the server certificates
     signature algorithm. Note: the signature incompatibility can appear
     anywhere in the servers certificate chain.

  *) mpm_event: Stop issuing AH00484 "server reached MaxRequestWorkers..." when
     there are still idle threads available. When there are less idle threads than
     MinSpareThreads, issue new one-time message AH10159. Matches worker MPM.
     (IBM for PH03953)

  *) Ignore SIGTERM when launching rotatelogs.  z/OS only.
     (IBM for PH03059)

  *) mod_status: various event MPM improvements to mod_status output.
     (Backport of several trunk revisions for PH02448)

  *) core: Add StrictHostCheck to allow the server to reject requests to
     unspecified hostnames.
     (IBM for PH02406)

Changes with IBM HTTP Server 9.0.0.10

  *) mod_ldap: Accept SHA2 cert chains for ldaps:// connections over TLS1.2
     by sending the signature_algorithms extension.
     (IBM for PH01302)

  *) mod_ibm_ssl: OCSP connection establishment did not specify any timeout.
     Use a 10 second timeout by default, overridden by new directive
     SSLOCSPConnectionTimeout. Distributed platforms only.
     (IBM for PH01222)

Changes with IBM HTTP Server 9.0.0.9

  *) SECURITY: PH00888
     mod_authnz_saf: Authentication bypass when server has surrogate access
     to local users.
     (IBM for PH00888)

  *) mod_wlm: Disable async write completion to avoid 'LeaveWorkUnit'
     failures.
     (IBM for PH00889)

  *) logging: When the main ErrorLog is configured to log to syslog, some early
     messages related to failed startup may be lost.
     (IBM for PI99394)

  *) core: Tolerate headers with trailing whitespace. The setting can
     be enabled and disabled via the HTTPProtocolOptions options
     'AllowHeaderWhitespace' and 'DenyHeaderWhitespace', respectively.
     (IBM for PI99685)

  *) rotatelogs: Add description for -n flag to usage.
     (IBM for PI99680)

  *) core: Re-allow '_' (underscore) in hostnames.  [Eric Covener]
     (Backport of r1834318 for PI99567)

  *) mod_authz_core: If several parameters are used in a AuthzProviderAlias
     directive, if these parameters are not enclosed in quotation mark, only
     the first one is handled. The other ones are silently ignored.
     Add a message to warn about such a spurious configuration.
     PR 62469 [Hank Ibell <hwibell gmail.com>, Christophe Jaillet]
     (IBM for PI99271)

  *) http: Reduce memory use of persistent connections. 
     [Ruediger Pluem, Joe Orton]
     (Backport of r1833014 for PI99262)

  *) mod_include: HTML entities are being confused as variables on z/OS only.
     This was a regression in PI48695 that allowed DGW style variable
     expansion syntax in SSI documents.
     (IBM for PI98705)

  *) mod_include: The SSI set element no longer entity decodes variables
     by default. The following directive was added to allow users to
     configure the decoding scheme used by the set element:
     SSIOptions DefaultSetDecoding=<none|base64|entity|url|urlencoded>.
     (IBM for PI98705)

  *) mod_ibm_ssl: Some SSL0234W are now issued as SSL0282E instead.
     (IBM for PI99032)

  *) mod_ibm_ssl: Alerts were not showing up as expected in SSL handshake
     messages since 9.0.0.8.
     (IBM for PI99032)

  *) mod_rewrite: Create rewrite map lock only if an external rewriting
     program is used to provide the mapping behavior.
     (IBM for PI98146)

  *) core: Improve the error message displayed when the URI contains an
     incorrectly encoded character to show the unparsed URI.
     (IBM for PI98147)

  *) archive: Ship PDB files for plugin and odrlib. Windows only.
     (IBM for PI98116)

  *) mod_ibm_ssl: Avoid SSL initialization errors for some virtual hosts
     that specify multiple addresses.
     (IBM for PI96156)

  *) Windows: add mod_backtrace and mod_whatkilledus for diagnosis of
     crashes. Must be manually loaded.
     (IBM for PI97314)

  *) EBCDIC: Add new module mod_a2e to facilitate translating ASCII content
     into EBCDIC so it can be manipulated by modules such as mod_substitute.
     (IBM for PI96955)

  *) mod_autoindex: Use the date-time format "dd-mmm-YYYY HH:MM" if the
     UseOldDateFormat IndexOptions option is set.
     (IBM for PI96949)

  *) mod_ldap: Update the embedded LDAP client to 6.4.0.6-IF006 from
     6.3.1.15-IF015 for most platforms. Exceptions are:
     HP (remains at 6.3), Windows 64-bit archive (already at 6.4)
     and linux/ppc64le (already at 6.4).
     (IBM for PI96321)
  
  *) mod_charset_lite: Flush buffered data during read errors such as
     CGI timeouts.
     (IBM for PI95964)

  *) mod_cgi: Add the directive CGIScriptTimeout to allow users to configure
     timeouts for CGI applications instead of using the Timeout
     directive which changes the general server timeout.
     (IBM for PI95964)

Changes with IBM HTTP Server 9.0.0.8

  *) SECURITY: CVE-2017-15710 (cve.mitre.org)
     Out of bound write in mod_authnz_ldap with AuthLDAPCharsetConfig enabled
     [Eric Covener, Luca Toscano, Yann Ylavic]
     (backport for PI95670)

  *) SECURITY: CVE-2017-15715 (cve.mitre.org)
     core: Configure the regular expression engine to match '$' to the end of
     the input string only, excluding matching the end of any embedded
     newline characters. Behavior can be changed with new directive
     'RegexDefaultOptions'. [Yann Ylavic]
     (backport for PI95670)

  *) SECURITY: CVE-2018-1301 (cve.mitre.org)
     core: Possible crash with excessively long HTTP request headers.
     Impractical to exploit with a production build and production LogLevel.
     [Yann Ylavic]
     (backport for PI95670)

  *) Upgrade GSKit to 8.0.50.88
     (IBM for PI94222)

  *) mod_ibm_ssl: Make 'syntaxError' static to avoid crashes when odrlib
     is loaded.
     (IBM for PI95610)

  *) mod_ibm_ssl: Clearly mark SSL handshake errors that are related
     to outbound SSLProxyEngine ON calls.

  *) mod_proxy_http: Make the proxy response buffer size configurable via the
     worker parameter 'ResponseFieldSize'. This is useful for responses that
     contain headers larger than 8192 bytes.
     (IBM for PI94539)

  *) default conf: Correct internal/default value of AddServerHeader.

  *) default conf: Stop adding the port selected at install-time to the
     ServerName directive. Including it causes IHS behind NAT to generate
     redirects with the listening port rather than the one in the Host: header.

  *) mod_status: When invoked without ?showmodulestate in the URL, provide a
     link to the server-status output with ?showmodulestate added.

  *) mod_status: Fix output when "notable" (no html tables) output is
     requested.

  *) mod_ldap: Potential hangs, crashes, and high CPU when using mod_ldap with
     virtual hosts. 
     (IBM for PI94050)

  *) mod_ibm_ssl: Some instances of SSL0600E were at loglevel CRIT despite not
     being critical, these were normalized to be WARN.  Further, after the first
     1000 messages are logged, the severity is dropped to DEBUG.  A counter is
     added to each SSL0600E message that shows the total number of occurrences.
     (IBM for PI93212)

  *) Add text to apachectl -v/-V  if the server appears to be installed via
     SMP/E.  z/OS only.

  *) mod_ibm_ssl: If a fatal SSL startup error occurs, and the SSL virtual host
     logs to a separate file from the "main" ErrorLog, issue a similar message
     to the "main" ErrorLog.

  *) add "aprerrno" util to the bin/ directory to format numeric error codes
     from Apache Portable Runtime into English text. 

  *) z/OS: Issue a warning when the 64-bit MEMLIMIT is under
     (ThreadsPerChild+3 * 12MB). Historical advice approximated a minimum
     of (ThreadsPerChild+3 * 6MB), but MEMLIMIT acts as a ceiling.
     (IBM for PI92407)

  *) z/OS: Fix process termination when MEMLIMIT is exhausted while allocating memory
     for a new request in the listener thread. These errors are reported as
     AH03097: Failed to create transaction pool. 
     (IBM for PI92407)

  *) core: Add "AcceptErrorsNonFatal" to allow ECONNREFUSED, ECONNABORTED, and
     ECONNRESET during the client accept() to not trigger graceful shutdown of
     the child process.  [Eric Covener]
     (IBM for PI92053)

  *) z/OS postinstall: Suppress harmless error messages when bin/ihs_install
     was invoked through a symlink and IHS is subsequently updated.
     (IBM for PI92092)

  *) mod_headers: Unset Content-Type properly when 'Header unset Content-Type'
     is set.
     (IBM for PI91975)

  *) mod_mvsds: When generating a directory index of a PDS, the links to the
     member datasets will be generated incorrectly if the PDS is a member
     of a GDG  dataset.
     (IBM for PI91850)

Changes with IBM HTTP Server 9.0.0.7

  *) SECURITY: CVE-2017-12613 (cve.mitre.org)
     apr: Bounds-check human-readable date fields.  [Stefan Sperling]
     (backport for PI90598)

  *) mod_ibm_ssl: Add "SSLAllowNonCriticalInhibitAnyPolicy ON" directive to
     enable toleration of non-critical "InhibitAnyPolicy" extensions in
     certificates.
     (IBM for PI91351)

  *) mod_ibm_ssl: When "SSLVersion" returns a 403 error, also set internal environment
     variable "ssl-version-check-failed" so a dynamic 403 ErrorDocument can produce an
     SSL-specific message.
     (IBM for PI91075)

  *) mod_ibm_ssl: Relatively rare SSL error SSL0223E (No Certificate) is
     mistakenly issued instead of SSL0222W (no shared protocols or ciphers).
     An intermittent SSL0223E prior to 9.0.0.7 is likely a case of SSL0222W.
     (IBM for PI91038)

  *) If a piped logger is given with a relative path, check under the ServerRoot
     and ServerRoot's bin/ subdirectory for a match instead of failing. 
     Unix platforms only.
     (IBM for PI90811)

  *) On Linux, allow bin/apachectl -V to work when no configuration file is
     present.
     (IBM for PI90688)

  *) On Linux, allow bin/gskcapicmd to work when conf/httpd.conf is not present.
     (IBM for PI90688)

  *) Add the header name in the 'Request header value is malformed...' message,
     and promote the severity from DEBUG to ERROR.

Changes with IBM HTTP Server 9.0.0.6

  *) SECURITY: CVE-2017-9798 (cve.mitre.org)
     core: Disallow Methods' registration at runtime (.htaccess), they may be
     used only if registered at init time (httpd.conf).  [Yann Ylavic]
     (backport for PI87445)

  *) SECURITY: CVE-2017-12618 (cve.mitre.org)
     apr-util: SDBM fixes
     (backport for PI87663)

  *) Upgrade GSKit to 8.0.50.84
     (IBM for PI90141)

  *) mod_authnz_saf: Resolve an ABEND0C4 in apr_pstrcat when accessing a SAF
     protected page with an expired password. The error occurs only when using
     the form-based SAF password update utility via the AuthSAFExpiredForm
     directive.
     (IBM for PI90834)

  *) mod_authnz_saf: Write an error message that includes the errno and
     errno2 values if getgrnam() fails to find a specified saf-group.
     (IBM for PI88553)

  *) mod_ibm_ssl: On z/OS with "SSLFIPSEnable", System SSL default ciphers
     instead of IHS default ciphers were unintentionally used.
     (IBM for PI88356)

  *) core: Allow request messages containing obsolete folds containing only
     spaces and/or tabs to be accepted by the server after PI73984. It can
     be enabled and disabled by specifying the AllowEmptyFoldedLines and
     DenyEmptyFoldedLines (default) options, respectively, with the
     HttpProtocolOptions directive.
     (IBM for PI88232)
 
  *) build: Stop setting STEPLIB on production builds (9.0 only)

  *) mod_speling: HTML escape the referer and don't put it in a hyperlink.
   
  *) httpd: Build httpd with the /LARGEADDRESSAWARE flag to allow IBM
     HTTP Server on 64-bit Windows to have more threads. This fixes a
     regression introduced in 9.0.0.4 where configurations with a high
     number of threads per child (~1500 or more) that worked previously
     now fail to start up. The failure is due to the server not being
     able to create all of the requested worker threads.
     (IBM for PI87046)

  *) mod_authnz_saf: Improve error messages to reflect underlying API and
     errno/errnojr values. Adds a new message about program control related
     failures.
     (IBM for PI85804)

  *) mod_authnz_saf:  Suppress unnecessary HTTP Basic Authentication
     prompts in configurations with "SAFRunAs %%CERTIF%%" and local
     files being accessed via features that create sub-requests like
     "DirectoryIndex" or Server Side Includes.
     (IBM for PI85702)

  *) mod_ibm_ssl: Resolve "SSLProxyEngine ON" failures related to
     TLS Fallback Prevention.
     (IBM for PI85561)

  *) mod_ibm_ssl: Disable 3DES cipher suites by default.
     (IBM for PI84868)

Changes with IBM HTTP Server 9.0.0.5

  *) SECURITY: CVE-2017-7679 (cve.mitre.org)
     mod_mime: Buffer overread on malicious Content-Type response header.
     (backport for PI82481)

  *) SECURITY: CVE-2017-7668 (cve.mitre.org)
     core: Potential DoS or header tampering in ap_find_token()
     [Jacob Champion]
     (backport for PI82263)

  *) SECURITY: CVE-2017-3167 (cve.mitre.org)
     core: Authentication bypass in third-party modules using
     ap_get_basic_auth_pw() prior to the authentication phase
     [Emmanuel Dreyfus <manu netbsd.org>, Jacob Champion, Eric Covener]
     (backport for PI82260)

  *) SECURITY: CVE-2017-3169 (cve.mitre.org)
     mod_ssl: Consistently pass the expected bio_filter_in_ctx_t
     to ssl_io_filter_error(). [Yann Ylavic]
     (n/a to IHS)

  *) mod_smf: Add a two-byte ASID to the end of 103.14 SMF records.
     The current version is 3.

  *) setupadm: Modify -plgfile's parent directory if -plgfile doesn't exist.

  *) mod_rewrite: Add RewriteOption LongURLOptimization as an improved version
     of IHS proprietary "NoCopy" option.
     (IBM for PI83257)

  *) mod_smf: Append a version, jobname, and jobid to the 103.14 SMF records.
     The current version is 2.
     (IBM for PI83350)

  *) postinst: Native environment variable 'IHS_SKIP_POSTINST' may be set prior
     to installation to perform a binary installation suitable for moving
     to another system for final post-installation.
     (IBM for PI83167)

  *) add bin/simplepct{.bat|.sh} to allow basic configuration of IHS with
     the WAS Plug-in in Liberty environments.
     (IBM for PI82834)

  *) core: Allow quotes for <IfFile> arguments.
     (IBM for PI82834)

  *) ikeyman: On Windows, setup JAVA_HOME for certificate management
    to point to the jre/ subdirectory when present.
    (IBM for PI82760)

  *) core: Log a DEBUG level message when ap_rflush() fails.
     (IBM)

  *) mod_authnz_saf: Add a form-based SAF password update utility which
     is enabled with the AuthSAFExpiredForm directive. Also, mitigate
     the Firefox expired password looping issue by limiting the number of
     password update attempts before terminating with a 403 error.

     Other changes made:
        * Environment variable SAF_AUTH_LIMIT added to control the number
          of failed password update requests before terminating with a 403
          error. To disable this feature, SAF_AUTH_LIMIT should be set to -1.
          The default value for SAF_AUTH_LIMIT is 2.

        * Added the directive AuthSAFUpdateFailedMessage to display a custom
          error message to the 403 error page if too many password update
          requests failed.

     (IBM for PI81602)

  *) mod_ibm_ssl: In directives such as SSLCipherSpec, Accept "SSL_"
     prefix for cipher long names that begin with "TLS_", and vice versa. In
     IHS, this first segment of the cipher long name never differentiates
     between two supported ciphers.
     (IBM for PI81360)

  *) mod_ibm_ssl: Substitute SSL0282E for a special case of SSL02422E where
     the client has sent an actual alert, rather than the server itself
     detecting a certificate problem. 
     (IBM for PI81360)

  *) GSKit: Update GSKit to 8.0.50.79 to resolve Dual-Mode ECDSA/RSA fails
     with 'SSLV2 open'.
     (IBM for PI80356)

Changes with IBM HTTP Server 9.0.0.4

  *) default conf: Remove uselsss <IfModule> that selects the LogFormats based
     on whether the WAS Plug-in is loaded. It doesn't work when the Plug-in is
     loaded later in the file.

  *) default conf: On z/OS, do not interpret a .Z "extension" in a data set
     name as a content encoding.
     (IBM for PI78716)

  *) core: Disable MMAP for static files by default on z/OS. Can be re-enabled
     with "EnableMMAP ON"
     (IBM for PI80447)

  *) mod_mvsds: On some systems, configuring mod_mvsds for a location prevented
     directives such as Alias and Redirect from taking effect.
     (IBM for PI80187)

  *) mod_substitute: On z/OS, mod_substitute did not treat newlines properly,
     resulting some non non-intuitive captures/substitutions and "AH01328: Line
     too long" errors.
     (IBM for PI80106)

  *) event MPM: On z/OS, add a singal handler for SIGUSR2 that calls
     cdump() to generate a CEEDUMP for all threads.
     (IBM for PI78967)

  *) core: Add ihs-getclientblock-error request note to give a human readable
     explanation for ap_get_client_block() failures.

  *) mod_ibm_ssl: Outbound SSLProxyEngine connections did not obey the
     default value of 'SSLAllowLegacyCerts ON' that was originally
     introduced in PI69979.
     (IBM for PI78696)

  *) mod_include: Add environment variable "ssi-preserve-relative" to allow
     a relative #include virtual= inside a file already being included
     via #include file=.
     (IBM for PI78442)

  *) apr-util/mod_ldap: Using the LDAPTrustedClientCert causes LDAP
     connections to fail with a HTTP 500. This happens because APR LDAP
     was incorrectly reporting that SSL was disabled when built with the
     Tivoli LDAP SDK.
     (IBM for PI77337)

  *) install: Resolve permission errors during server start after applying
     fixpacks in environments where the user who runs install_ihs differs
     from the user who starts IHS.
     Adds a "-group" parameter to the bin/install_ihs script to allow a
     group shared between the install userid and [protected] task userid
     to be specified.
     (IBM for PI76918)
 
  *) mod_ibm_ssl: Add 'BUFFNULL' option to SSLAttributeSet.
     (IBM for PI76874)

  *) mod_ibm_ssl: Improve the high CPU circumventions in PI50937 by moving
     configuration to httpd.conf,  separating loop avoidance from the
     termination of affected threads, and allowing graceful restart of
     affected processes.  Must enable with "SSLRecvLoopMitigation ON".

     Users who had opted in to PI50937 should take special note:

       * Environment variable IHS_USE_RECVLOOP_PTHREAD_EXIT, which had enabled
         both the loop avoidance and the killing of threads, is deprecated. If
         used, it enables "SSLRecvLoopMitigation ON" which does not include thread
         termination.  "SSLRecvLoopMitigationUseThreadExit ON" may be specified
         to restore thread termination but it is not recommended.

       * IHS_USE_RECVLOOP_PROC_EXIT is now ignored.  Prior to PI76874,
         This exit was a non-graceful termination. Instead, a graceful
         termination is always triggered when too many affected sockets
         (default) or threads (SSLRecvLoopMitigationUseThreadExit ON)
         have experienced the abnormal condition.

     (IBM for PI76874)

  *) mod_ibm_ssl: Add "SSLHandshakeTranscript" directive to disable the
     enhanced handshake failure diagnostic messages.
     (IBM for PI76757)

  *) rotatelogs: Using -v (produce verbose output on STDERR) without supplying
     -p (program executed when a new log file is opened) may cause rotatelogs to
     crash repeatedly due to undefined behavior. This particular issue is known
     to happen on z/OS.
     (IBM for PI75835)

  *) mod_nettrace: Change connection ID column to be prefixed with a process
     ID.
    
  *) mod_ibm_ssl: Add startup trace improvements.

  *) default conf: Remove never-working conditional that uses
     "<ifModule was_ap24_module>" at the top of httpd.conf to modify
     default log formats.  New instances will use a default log format
     that includes %{WAS}e, even if the Websphere Web Server Plugin is
     not loaded.

  *) GSKit: Update GSKit to 8.0.50.77 to resolve gskcapicmd
     -ca_label param overrides -sigalg param
     (IBM for PI73043)

Changes with IBM HTTP Server 9.0.0.3

  *) SECURITY: CVE-2016-8743 (cve.mitre.org)
     Enforce HTTP request grammar corresponding to RFC7230 for request lines
     and request headers, to prevent response splitting and cache pollution by
     malicious clients or downstream proxies. [William Rowe, Stefan Fritsch]
     (Backport from 2.4.25 for PI73984)

  *) Don't set SO_REUSEPORT unless ListenCoresBucketsRatio is greater
     than zero.  [Eric Covener]
     (Backport from trunk for PI73984)

  *) core: Unfold HTTP response headers with obsolete folding.
     (Backport from trunk for PI73984)

  *) Validate HTTP response header grammar defined by RFC7230, resulting
     in a 500 error in the event that invalid response header contents are
     detected when serving the response, to avoid response splitting and cache
     pollution by malicious clients, upstream servers or faulty modules.
     [Stefan Fritsch, Eric Covener, Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) default conf: On z/OS and Linux, set MaxSpareThreads closer to MaxClients.
     Only applies to new instances.
     (IBM for PI74200)

  *) mod_net_trace: Use an alternate connection ID to make tracking requests across
     a keepalive connection possible on the event MPM. 

  *) mod_zos_cmds: mod_zos_cmds incorrectly reports the number of lingering
     close connections as zero. This is because mod_zos_cmds counts the number of
     threads in the lingering close state instead of counting the number of
     connections in the lingering close state.
     (IBM for PI73951)

  *) mod_rewrite: Limit runaway memory use by short circuiting some kinds of
     looping RewriteRules when the local path significantly exceeds
     LimitRequestLine.  PR 60478. [Jeff Wheelhouse <apache wheelhouse.org>]
     (Backport from 2.4.25 for PI73984)

  *) core: Drop Content-Length header and message-body from HTTP 204 responses.
     PR 51350 [Luca Toscano]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy: Honor a server scoped ProxyPass exception when ProxyPass is
     configured in <Location>, like in 2.2. PR 60458.
     [Eric Covener]
     (Backport from 2.4.25 for PI73984)

  *) mod_lua: Fix default value of LuaInherit directive. It should be
     'parent-first' instead of 'none', as per documentation.  PR 60419
     [Christophe Jaillet]
     (Backport from 2.4.25 for PI73984)

  *) core: New directive HttpProtocolOptions to control httpd enforcement
     of various RFC7230 requirements. [Stefan Fritsch, William Rowe]
     (Backport from 2.4.25 for PI73984)

  *) core: Permit unencoded ';' characters to appear in proxy requests and
     Location: response headers. Corresponds to modern browser behavior.
     [William Rowe]
     (Backport from 2.4.25 for PI73984)

  *) core: ap_rgetline_core now pulls from r->proto_input_filters.

  *) core: Correctly parse an IPv6 literal host specification in an absolute
     URL in the request line. [Stefan Fritsch]

  *) core: New directive RegisterHttpMethod for registering non-standard
     HTTP methods. [Stefan Fritsch]

  *) mod_cache: Use the actual URI path and query-string for identifying the
     cached entity (key), such that rewrites are taken into account when
     running afterwards (CacheQuickHandler off).  PR 21935.  [Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) event: Allow to use the whole allocated scoreboard (up to ServerLimit
     slots) to avoid scoreboard full errors when some processes are finishing
     gracefully. Also, make gracefully finishing processes close all
     keep-alive connections. PR 53555. [Stefan Fritsch]
     (Backport from 2.4.25 for PI73984)

  *) mpm_event: Don't take over scoreboard slots from gracefully finishing
     threads. [Stefan Fritsch]
     (Backport from 2.4.25 for PI73984)

  *) mpm_event: Free memory earlier when shutting down processes.
     [Stefan Fritsch]
     (Backport from 2.4.25 for PI73984)

  *) mod_status: Display the process slot number in the async connection
     overview. [Stefan Fritsch]
     (Backport from 2.4.25 for PI73984)

  *) mod_dir: Responses that go through "FallbackResource" might appear to
     hang due to unterminated chunked encoding. PR58292. [Eric Covener]
     (Backport from 2.4.25 for PI73984)

  *) mod_dav: Fix a potential cause of unbounded memory usage or incorrect
     behavior in a routine that sends <DAV:response>'s to the output filters.
     [Evgeny Kotkov]
     (Backport from 2.4.25 for PI73984)

  *) mpm_unix: Apache fails to start if previously crashed then restarted with
     the same PID (e.g. in container).  PR 60261.
     [Val <valentin.bremond gmail.com>, Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) mod_remoteip: Pick up where we left off during a subrequest rather
     than running with the modified XFF but original TCP address.
     PR 49839/PR 60251
     (Backport from 2.4.25 for PI73984)

  *) http: Respond with "408 Request Timeout" when a timeout occurs while
     reading the request body.  [Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) mod_reqtimeout: Fix body timeout disabling for CONNECT requests to avoid
     triggering mod_proxy_connect's AH01018 once the tunnel is established.
     [Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy_fcgi: avoid loops when ProxyErrorOverride is enabled
     and the error documents are proxied. PR 55415. [Luca Toscano]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy_fcgi: read the whole FCGI response even when the content
     has not been modified (HTTP 304) or in case of a precondition failure
     (HTTP 412) to avoid subsequent bogus reads and confusing
     error messages logged. [Luca Toscano]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy_{http,ajp,fcgi}: don't reuse backend connections with data
     available before the request is sent.  PR 57832.  [Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy: Correctly consider error response codes by the backend when
     processing failonstatus. PR 59869 [Ruediger Pluem]
     (Backport from 2.4.25 for PI73984)

  *) mod_dav: Add dav_get_provider_name() function to obtain the name
     of the provider from mod_dav.  [Graham Leggett]
     (Backport from 2.4.25 for PI73984)

  *) mod_dav: Add support for childtags to dav_error.
     [Jari Urpalainen <jari.urpalainen nokia.com>]
     (Backport from 2.4.25 for PI73984)

  *) mod_include: Fix a potential memory misuse while evaluating expressions.
     PR59844. [Eric Covener]
     (Backport from 2.4.25 for PI73984)

  *) mod_ibm_ssl: On z/OS, allow an extended syntax for SSLCipherSpec
     so individual ciphers may be added or removed from the configuration
     without specifying every other cipher.  The new syntax is used when the
     first parameter supplied is "ALL" instead of a cipher name.
     For example "SSLCipherSpec ALL -SSL_RSA_WITH_3DES_EDE_CBC_SHA"
     (IBM for PI73819)

  *) mpm_event, mpm_worker: Fix computation of MinSpareThreads' lower bound
     according the number of listeners buckets.  [Yann Ylavic]
     (Backport from 2.4.25 for PI73984)

  *) mod_cache: Fix (max-stale with no '=') and enforce (check
     integers after '=') Cache-Control header parsing.
     [Christophe Jaillet]
     (Backport from 2.4.25 for PI73984)

  *) mod_proxy_fcgi: Avoid passing a filename of proxy:fcgi:// as
     SCRIPT_FILENAME to a FastCGI server. PR59618.
     [Jacob Champion <champion.pxi gmail.com>]
     (Backport from 2.4.25 for PI73984)

  *) mod_dav: Add dav_get_provider_name() function to obtain the name
     of the provider from mod_dav.
     [Jari Urpalainen <jari.urpalainen nokia.com>]
     (Backport from 2.4.25 for PI73984)

  *) mod_include: add the <!--#comment ...> syntax in order to include comments
     in a SSI file. [Christophe Jaillet based on a suggestion from Rob]
     (Backport from 2.4.25 for PI73984)

  *) core: New CGIVar directive can configure REQUEST_URI to represent the
     current URI being processed instead of always the original request.
     [Jeff Trawick]
     (Backport from 2.4.25 for PI73984)

  *) mod_ibm_ssl: Resolve additional memory leaks in sidd.
     (IBM for PI73661)

  *) core: EnableSendfile ON fails to return a response over SSL, may
     cause high CPU.
     (IBM PI73165)

  *) mod_net_trace: When enabled, this module may cause a crash if
     "EnableSendfile ON" has been specified.
     (IBM for PI73027)

  *) mod_backtrace, mod_whatkilledus, core: Don't print a timestamp when logging
     crash details, as the functions used for this may cause a hang if invoked
     from a signal handler.
     (IBM for PI72989)

  *) ikeyman/gskcmd: Pass -DADD_CMS_SERVICE_PROVIDER_ENABLED=true to java
     certificate management tools to ensure CMS keystores are available
     without manual configuration under Java 8.0.   Required by Java 8.0 SR3 FP20
     and later. Also fixes further problems with these scripts on Windows that
     might lead to a non-bundled java being used.
     (IBM for PI71340)

  *) mod_ibm_ssl: Check the requested TLS client hello version
     during SSL0240I and SSL0222W and append to existing message
     text if the protocol is disabled.
     (IBM for PI70829)

  *) mod_ibm_ssl: In some handshake failure cases, the "handshake transcript"
     trace messages were not being printed.
     (IBM for PI70829)

  *) mod_ibm_ssl: If "SSLTrace" is specified without at least
     "LogLevel ibm_ssl:trace1", automatically enable ibm_ssl:trace8.
     Conversely, if ibm_ssl:trace1 or higher is set, automatically
     enable "SSLTrace".
     (IBM for PI70825)

  *) mod_ibm_ssl: Improve the formatting of the SSL handshake transcript
     trace messages to conserve screen width.
     (IBM for PI70825)

  *) mod_ibm_ssl: Avoid startup failures when "SSLEnable" is
     specified globally in httpd.conf and one or more Virtual Hosts
     with no mod_ibm_ssl directives is present.
     (IBM for PI70496)

  *) mod_mvsds: Text files containing a pair of angle brackets are
     incorrectly sniffed as text/html instead of text/plain. The
     directive MvsdsAlternateHtmlSniff was added to use a different
     HTML sniffing strategy to better detect HTML and text files.
     (IBM for PI70372)

Changes with IBM HTTP Server 9.0.0.2

  *) SECURITY: CVE-2016-4472 (cve.mitre.org)
     expat/apr-util: Update bundled expat for CVE-2016-4472.
     Also resolves: CVE-2012-0876, CVE-2012-1147, and CVE-2012-1148.
     (Backport from expat 2.2.0 for PI66849, n/a on z/OS)
 
  *) core: If the current soft limit for RLIMIT_NPROC looks to be less
     than MaxClients (MaxRequestWorkers), raise it to the corresponding
     hard limit at startup. This resolves one cause of "apr_thread_create"
     errors.
     (IBM for PI70022, Linux only)

  *) mod_ibm_ssl: Restore compatibility with behavior of previous releases
     by accepting certificates that do not strictly conform with RFC 5280
     (PKIX).  Distributed platforms only.
     (IBM for PI69979)

  *) mod_ibm_ssl: On z/OS, in the absence of any SSLCipherSpec directives,
     the default ciphers for TLSv1.2 may display an inaccurate value under
     the "apachectl -t -DDUMP_SSL_CONFIG" command.
     (IBM for PI69182)

  *) event: On z/OS, long-lived child processes could expereince elevated CPU
     usage during routine BPXVRCAN (async I/O cancel) and BPX4AIO (async I/O
     poll) operations.
     (IBM for PI68803, z/OS only)

  *) Speed up the z/os-specific bin/new_install_root script by avoiding
     creation of temporary files by the shell.

  *) mod_cgid: Resolve a case where a short CGI response causes a subsequent
     CGI to be killed prematurely, resulting in a truncated subsequent
     response. [Eric Covener]
     (Backport from Apache 2.4.24-dev)

  *) mod_zos_cmds: Allow server to gracefully shutdown when
      z/OS STOP command is received.
     (IBM for PI68001)

  *) mod_authnz_saf: The AuthSAFExpiration and AuthSAFReenter
     messages are not included in the the WWW-Authenticate
     header when a 401 ErrorDocument is defined.
     (IBM for PI67595)

  *) GSKit: Update GSKit to 8.0.50.69 to resolve TLS 1.3 negotiation
     intolerance.
     (IBM for PI66931)

  *) sidd: Fix slow memory leak in sidd process.
     (IBM for PI66787)

  *) ikeyman/gskcmd: Scripts failed to add CMS support on Windows, and caused
     syntax errors when IHS was installed to a path with spaces.
     (IBM for PI66468)

Changes with IBM HTTP Server 9.0.0.1

  *) SECURITY: CVE-2016-5387 (cve.mitre.org)
     core: Don't copy a "Proxy" request header to an environment
     variable named HTTP_PROXY, as an HTTP library in a CGI could
     be fooled into using the value as a forward proxy.
     (Backport from ASF httpd advisory for PI65855)

  *) SECURITY: CVE-2016-0718 (cve.mitre.org)
     apr-util: Patch the budled expat XML parsing library for
     CVE-2016-0718.  Affects mod_dav and third-party modules that
     use the apr_xml_* routines. Distributed platforms only.
     (Backport from Debian fix for CVE-2016-0718 for PI63098)

  *) mod_authnz_saf: Resolve "EDC5111I Permission denied" with
     errno2=0x0BE80000 when using IBM Multi-Factor Authentication
     for z/OS.  Requires BPX.DAEMON UPDATE access for IHS.
     (IBM for PI66183)

  *) mod_mvsds: XML files are correctly sniffed, but a garbage
     value is returned instead of an OK. This results in a 500
     error and the following message being written to the error log:
     "Handler for (null) returned invalid result code".
     (IBM for PI66153)


  *) mod_authnz_saf: Variables set by SetEnvIf were being indirectly
     hidden from later modules, such as the WebSphere WebServer Plugins
     "skipwas" variable.
     (IBM for PI64346)

  *) mod_authnz_saf:  Add the AuthSAFStatusHeader directive to allow
     details of SAF authentication to be added to a custom response header
     and in the body of 401 responses. The additional details are informational
     messages that DGW generated by default in 401 responses.
     (IBM for PI63482)

  *) apr: On z/OS, the server may try to delete message queues used
     by other address spaces.  If not permitted, this will trigger
     ICH408I in the system log.
     (IBM for PI64628)

  *) Scoreboard: Fix a regression in 2.4.20 that causes wrong request data
     to be displayed on the status page. PR 59333. [Yann Ylavic, William Rowe]
     (Backport for PI63682)

  *) mod_charset_lite:  Allow the default configuration to translate
     files included with "#include file=..." when the including SHTML
     is translated. Also, resolve obscure errors where a file may only
     be partially translated after processing an #include.
     (IBM for PI62663)

  *) mod_ibm_ssl: Fix potential crash with SSLCipherBan
     and SSLCipherRequire in an environment with GSKit
     trace enabled. Distributed only.
     (IBM for PI60784)

  *) mod_mvsds: Add MvsdsNoBinarySniff MVSDS directive to be able to
     disable binary detection code.
     (IBM for PI60251 z/OS only)

Changes with IBM HTTP Server 9.0.0.0-PI56034 (9.0)

  *) GSKit: Update GSKit to 8.0.50.61
     (IBM for PI60207)

  *) mod_authnz_saf: saf_pre_passwd() and saf_post_passwd() hooks
     for extending mod_authnz_saf.
     (IBM for PI59561)

  *) mod_autoindex: Add the KeepNoTrailingSlash directive to control
     if the trailing slash is added to the directory name when listing a
     directory without a slash. Also fix directory links when using
     DirectorySlash off.
     (IBM for PI56034)

  *) default conf: Add HSTS example directive and enable mod_headers
     by default.

  *) mod_mvsds: Add support to open.c to handle GDG data sets in mod_mvsds.
     (IBM for PI53754 z/OS only)

  *) event.c: Add debug message for apr_pollset_create failure. z/OS only.

  *) mod_ldap: Update the IBM Security Directory Server LDAP client
     library SDK to 6.3.1.15.

  *) mod_disk_cache: Fix one potential cause for 'error renaming tmpfile to
     datafile'.
     (IBM for PI58218)

  *) mod_zos_cmds: Initial ip text with "unspecified" and display a * for IPV6
     inaddrany instead of ::. 
     (IBM for PI57596 z/OS only)

  *) core: Do not read .htaccess if AllowOverride and AllowOverrideList
     are "None". PR 58528.
     [Michael Schlenker <msc contact.de, Ruediger Pluem, Daniel Ruggeri]

  *) core/util_script: relax alphanumeric filter of enviroment variable names
     on Windows to allow '(' and ')' for passing PROGRAMFILES(X86) et.al.
     unadulterated in 64 bit versions of Windows. PR 46751. 
     [John <john leineweb de>]

  *) mod_include: Add variable DOCUMENT_ARGS, with the arguments to the
     request for the SSI document.  [Jeff Trawick]

  *) mod_authz_host: Add a new "forward-dns" authorization type, not relying on
     reverse DNS lookups.  [Fabien]

  *) mod_rewrite: Don't implicitly URL-escape the original query string
     when no substitution has changed it (like PR50447 but server context)
     [Evgeny Kotkov <evgeny.kotkov visualsvn.com>]

  *) mod_reqtimeout: Prevent long response times from triggering a timeout once
     the request has been fully read.  PR 59045.  [Yann Ylavic]

  *) ap_expr: expression support for variable HTTP2=on|off. [Stefan Eissing]

  *) mod_rewrite: Add QSL|qslast flag to allow rewrites to files with
     literal question marks in their names. PR 58777. [Eric Covener]

  *) event: use pre_connection hook to properly initialize connection state for
     slave connections. use protocol_switch hook to initialize server config
     early based on SNI selected vhost.
     [Stefan Eissing]

  *) hostname: Test and log useragent_host per-request across various modules,
     including the scoreboard, expression and rewrite engines, setenvif,
     authz_host, access_compat, custom logging, ssl and REMOTE_HOST variables.
     PR55348  [William Rowe]

  *) core: Track the useragent_host per-request when mod_remoteip or similar
     modules track a per-request useragent_ip.  Modules should be updated
     to inquire for ap_get_useragent_host() in place of ap_get_remote_host().
     [William Rowe]

  *) core: fix a bug in <UnDefine ...> directive processing. When used, the last
     <Define...>'ed variable was also withdrawn. PR 59019
     [Christophe Jaillet]

  *) core: Ensure that httpd exits with an error status when the MPM fails
     to run.  [Yann Ylavic]

  *) mod_proxy: Play/restore the TLS-SNI on new backend connections which
     had to be issued because the remote closed the previous/reusable one
     during idle (keep-alive) time.  [Yann Ylavic]

  *) core: Add expression support to SetHandler.
     [Eric Covener]

  *) mod_remoteip: Prevent an external proxy from presenting an internal
     proxy. PR 55962. [Mike Rumph]

  *) core: Prevent a server crash in case of an invalid CONNECT request with
     a custom error page for status code 400 that uses server side includes.
     PR 58929 [Ruediger Pluem]

  *) mod_proxy_fcgi: Suppress HTTP error 503 and message 01075,
     "Error dispatching request", when the cause appears to be
     due to the client closing the connection.
     PR58118.  [Tobias Adolph <adolph lrz.de>]

  *) mod_cgid: Message AH02550, failure to flush a response to the client,
     is now logged at TRACE1 level to match the underlying core output filter
     severity.  [Eric Covener]

  *) mime.types: add common extension "m4a" for MPEG 4 Audio.
     PR 57895 [Dylan Millikin <dylan.millikin gmail.com>]

  *) Added many log numbers to log statements that had none.
     [Rainer Jung]

  *) mod_log_config: Add GlobalLog to allow a globally defined log to
     be inherited by virtual hosts that define a CustomLog.
     [Edward Lu]

  *) core: new hook "pre_close_connection" which is run before the lingering
     close of connections is started. This gives protocol handlers one last
     chance to use a connection before it goes down.
     [Stefan Eissing]

  *) mod_status/scoreboard: showing connection protocol in new column, new
     ap_update_child_status methods for updating server/description. mod_ssl
     sets vhost negotiated by servername directly.
     [Stefan Eissing]

  *) core: if the first HTTP/1.1 request on a connection goes to a server that
     prefers different protocols, these protocols are announced in a Upgrade:
     header on the response, mentioning the preferred protocols.
     [Stefan Eissing]

  *) core: add ap_get_protocol_upgrades() to retrieve the list of protocols
     that a client could possibly upgrade to. Use in first request on a
     connection to announce protocol choices. [Stefan Eissing]

  *) core: Fix scoreboard crash (SIGBUS) on hardware requiring strict 64bit
     alignment (SPARC64, PPC64).  [Yann Ylavic]

  *) mod_cache: Accept HT (Horizontal Tab) when parsing cache related header
     fields as described in RFC7230. [Christophe Jaillet]

  *) core/util_script: making REDIRECT_URL a full URL is now opt-in
     via new 'QualifyRedirectURL' directive.

  *) core: Limit to ten the number of tolerated empty lines between request,
     and consume them before the pipelining check to avoid possible response
     delay when reading the next request without flushing.  [Yann Ylavic]

Changes with IBM HTTP Server 9.0.0.0-PI57543

  *) rotatelogs: Add -T flag to ignore SIGTERM. Without native environment
     variable IHS_PIPED_LOGGER_NO_SHELL, SIGTERM is not sent to rotatelogs.
     With IHS_PIPED_LOGGER_NO_SHELL, SIGTERM will be seen during
     shutdown and trigger a warning: CEE5205S.
     (IBM for PI57543)

  *) welcome page: Fix CSS reference to avoid 404 errors when the welcome
     page is accessed.  Note: On z/OS, updates to the welcome page are only
     applied to new instances of the server. 
     (PI56576)

  *) bin/envvars: If System SSL reports that ICSF ECC Secure key is not
     supported, try to read 1 byte from /dev/random to see if advanced
     ciphers should still be enabled by default.  z/OS only. 
     This change will only be present on newly configured instances.

  *) mod_ibm_ssl: Make SSL0400I more informative by calling
     ssl_strerror() on un-enumerated System SSL error codes.

  *) mod_ibm_ssl: Add a unique message (SSL0413E) for
     GSK_ERR_ICSF_SERVICE_FAILURE returned during non-handshake I/O.

  *) AIX 64-bit: Try to boost data segment size limit (ulimit -d)
     if the hard limit is unlimited.

Changes with IBM HTTP Server 9.0.0.0-PI54808 (z/OS V2R2 update 3, UI35362)

  *) SECURITY: CVE-2016-0201 (cve.mitre.org)
     GSKit: Update GSKit to 8.0.50.57 (8.0 and 8.5 only)
     (IBM for PI54962)

  *) SECURITY: CVE-2015-7420 (cve.mitre.org)
     GSKit: Update GSKit to 8.0.50.55 (8.0 and 8.5 only)
     (IBM for PI52395)
    
  *) mod_charset_lite: Trace downstream errors as APLOG_DEBUG.

  *) mod_ibm_ssl: Add the SSLCheckCertificateExpiration directive to allow
     reporting of TLS certificates that will expire within a specified
     number of days.
     (distributed only)

  *) mod_authnz_saf: Stop calling ap_run_translate_name() while
     checking for SAFRunAsEarly, as it leads to mod_rewrite running
     earlier than expected and seeing un-decoded URLs. This was a
     regression in PI45005 that did not ship in 9.0.
     (IBM for PI54808)
 
  *) mod_zos_cmds: Change some APLOG_NOTICE traces to APLOG_DEBUG.
     (z/OS only)
    
  *) core: Avoid many 8-byte reads from /dev/random at startup by reading
     the required random data all at once. On z/OS, this reduces the number
     of CSFSERV CSFRNG audit events.
     (IBM for PI52301)
 
  *) mod_authnz_saf: Allow use of SAFRunAsEarly for certificate switching.
     (IBM for PI51185)

  *) htpasswd: Disable bcrypt/blowfish algorithm on z/OS.  It has numerous
     ascii-isms.

  *) mod_ibm_ssl: Provide countermeasures for looping between SSL and GSKit
     with native environment variables IHS_USE_RECVLOOP_PTHREAD_EXIT
     IHS_USE_RECVLOOP_PROC_EXIT. 8.0 and later on Linux, AIX,
     Solaris, and z/OS only.
     (IBM for PI50937)

  *) mod_ibm_ssl: SSLReverseCipherOrder caused startup error on z/OS.

  *) mod_authnz_saf: Add an error_log entry when a user is rejected with a 403
     under "SAFRunAs %%CERTIF_REQ%%".  Also increases the severity of existing
     messages for this same configuration when certificate mapping failures
     trigger a 403 response.
     (IBM for PI50397)

  *) mod_ibm_ssl: Change how the SSLSessionCache daemon (sidd) handles
     duplicate session ID insertion requests to save time/space.
     (IBM for PI50514)

  *) mod_ibm_ssl: Allow KeyFile to be specified as a ServerRoot relative
     path.

  *) core: Added CGIDocumentURIIgnoreDirIndex directive; when on, DOCUMENT_URI
     returns the original URI even after mod_dir modifies it
     (IBM for PI50376)

  *) core: Added CGISetDocumentVars directive; when on, DOCUMENT_ROOT and
     DOCUMENT_NAME is set in CGIs. Normally, they are only set in SSIs.
     (IBM for PI50376)

  *) core: Added CGISetDocumentRootToDirname directive; when on, DOCUMENT_ROOT
     is set to the dirname of the requested file. Normally, DOCUMENT_ROOT is
     equal to the value of DocumentRoot.
     (IBM for PI50376)

  *) core: Added CGISetDocumentNameToFullPath directive; when on, DOCUMENT_NAME
     is set to the full path of the requested file. Normally, DOCUMENT_NAME
     contains only the basename.
     (IBM for PI50376)

  *) core: Added the DGWScriptCompat directive, which sets all four
     compatibility directives listed above. In the future, it may toggle
     more options for compatibility.
     (IBM for PI50376)

  *) mod_proxy: don't recyle backend announced "Connection: close" connections
     to avoid reusing it should the close be effective after some new request
     is ready to be sent.  [Yann Ylavic]

  *) mod_substitute: Allow to configure the patterns merge order with the new
     SubstituteInheritBefore on|off directive.  PR 57641
     [Marc.Stern <Marc.Stern approach.be>, Yann Ylavic, William Rowe]

  *) mod_proxy: Fix ProxySourceAddress binding failure with AH00938.
     PR 56687.  [Arne de Bruijn <apache arbruijn.dds.nl>

  *) mod_logio: Fix logging of %^FB (time to first byte) on the first request on
     an SSL connection.  PR 58454. 
     [Konstantin J. Chernov <k.j.chernov gmail.com>]

  *) mod_cache: r->err_headers_out is not merged into
     r->headers when mod_cache is enabled and the response
     is cached for the first time. (for PI48857)
     [Edward Lu]

  *) mod_slotmem_shm: Fix slots/SHM files names on restart for systems that
     can't create new (clear) slots while previous children gracefully stopping
     still use the old ones (e.g. Windows, OS2). mod_proxy_balancer failed to
     restart whenever the number of configured balancers/members changed during
     restart.  PR 58024.  [Yann Ylavic]

  *) core/util_script: make REDIRECT_URL a full URL.  PR 57785. [Nick Kew]

  *) MPMs: Support SO_REUSEPORT to create multiple duplicated listener
     records for scalability. [Yingqi Lu <yingqi.lu@intel.com>,
     Jeff Trawick, Jim Jagielski, Yann Ylavic]

  *) mod_proxy: Fix a race condition that caused a failed worker to be retried
     before the retry period is over. [Ruediger Pluem]

  *) mod_autoindex: Allow autoindexes when neither mod_dir nor mod_mime are
     loaded. [Eric Covener]

  *) mod_rewrite:  Allow cookies set by mod_rewrite to contain ':' by accepting
     ';' as an alternate separator.  PR47241.
     [<bugzilla schermesser com>, Eric Covener]

  *) apxs: Add HTTPD_VERSION and HTTPD_MMN to the variables available with
     apxs -q. PR58202. [Daniel Shahaf <danielsh apache.org>]

  *) mod_rewrite: Avoid a crash when lacking correct DB access permissions
     when using RewriteMap with MapType dbd or fastdbd.  [Christophe Jaillet]

  *) mod_socache_memcache: Add the 'MemcacheConnTTL' directive to control how
     long to keep idle connections with the memcache server(s).
     Change default value from 600 usec (!) to 15 sec. PR 58091
     [Christophe Jaillet]

  *) mod_dir: Prevent the internal identifier "httpd/unix-directory" from
     appearing as a Content-Type response header when requests for a directory
     are rewritten by mod_rewrite. [Eric Covener]

Changes with IBM HTTP Server 9.0.0.0-PI49954 (z/OS V2R2 update 2 UI32111)

  *) mod_mvsds: Newlines are lost from a MVSDS dataset when the
     content type is not set to text/* or application/x-javascript.
     Allow a custom envvar 'mvsds-force-fread-text' to force
     mod_mvsds to open a file as text even if the content-type is not
     text/* or javascript.

  *) mod_mvsds: Prevent ENQ leaks when serving MVS datasets by preventing
     "async write completion" when datasets are being served.
     (IBM for PI49954)

  *) mod_ibm_ssl: Improve error_log reporting of SSL Proxy (SSLProxyEngine ON)
     handshake failures.
     (IBM for PI49718)

  *) mod_ibm_ssl: Enable the TLS_FALLBACK_SCSV extension for inbound
     and outbound SSL.  Distributed platforms only.
    
  *) default conf: remove mod_mime_magic sample from the default
     configuration.

  *) bin/new_install_root: Missing libdir symlink and postinst -t pupdate
     not called successfully.

  *) mod_authnz_saf: Add Applid support to the __passwd() call.
    
  *) mod_authnz_saf: REMOTE_USER is not set with SAFRunAs %%CERTIF%% when
     no other user-based Require directives are configured but a certificate
     was mapped by RACF.
     (IBM for PI48141)
    
  *) mod_ibm_ssl: SSLProxyEngine ON now starts with GSKit "GSK_VACCINATE"
     reasonable defaults before applying frontend SSL configuration.
     Distributed platforms only.

  *) mod_zos_cmds: Add message id and upgrade content for start/stop console
     messages. 
     (IBM for PI45562)

  *) mod_authnz_saf: SAFRunAs %%CERTIF%% could return a 403 instead
     of a 401 when no certificate was provided.

  *) mod_ibm_ssl: Enable OCSP support on z/OS. Only available on
     z/OS V2R2 and later.
     (IBM for PI46822)

  *) mod_include:  Convert a mime type of text/x-ssi-html to text/html
     as SSI is processed, for compatibility with CGI scripts written for
     DGW / IHS 5.3.
     (IBM for PI46868)

  *) mod_charset_lite: Perform translation on responses after most content
     oriented filters (mod_include, mod_deflate) have had a chance to run,
     so that EBCDIC-compiled modules see EBCDIC data.  Previously
     the order was not deterministic and mod_include could periodically
     fail to find SSI tags because they had already been converted to
     ASCII.
     (IBM for PI46868)

  *) mod_rewrite: Allow the [CO=] flag to use an alternate separator of
     ';' to allow cookie names and values with the default ':' separator.
     (IBM for PI46616)

  *) setupadm / PCT Admin Server Configuration: Fix for an existing group
     to be specifid during IHS Admin Server configuration when the target
     group is not in /etc/group (/etc/nsswitch.conf specifies something
     like winbind or sssd)
     (IBM for PI46559)

  *) mod_authnz_saf: Add SAFRunAsEarly directive to allow SAF to switch users
     before IHS attempts to read any directories. This allows %%CLIENT%% to
     to serve files and directories the servers own ID cannot access.
     Note: The shipped version of this CHANGES entry had incorrect info.
     (IBM for PI45005)

  *) mod_authnz_saf: Re-add deprecated AuthSAFAuthoritative as a dummy
     directive.

  *) mod_mem_cache: Prevent caching when the client closes the connection
     before the entire response is sent.
     (IBM for PI47198)

  *) mod_include: Allow DGW-style variable expansion syntax. z/OS only.
     (IBM for PI48695)

  *) mod_include: Tolerate query strings in the cgi argument of the exec tag.
     (IBM for PI48695)

Changes with IBM HTTP Server 9.0.0.0-PI45596 (z/OS V2R2 update 1 UI30372)

  *) SECURITY: CVE-2015-1283 (cve.mitre.org)
     apr-util: Update bundled expat for CVE-2015-1283. Distributed
     platforms only.  Only used by mod_dav and potentially third-party modules.
     (Backport from chrome security bulletin for PI45596)

  *) SECURITY:
     mod_authnz_saf: %%CLIENT%% problems
     (IBM for PI46076)
    
  *) SECURITY: CVE-2015-4947 (cve.mitre.org)
     mod_ibm_admin: Resolve vulnerability to malicious authenticated
     requests.
     (IBM for PI44793)

  *) mod_authnz_saf: Disable Event MPM write completion for requests that switch userids.

  *) mod_ibm_ssl: Use LDAP V3 protocol by default for CRL.  Distribued platforms only.

  *) mod_ibm_ssl: Stop enabling symmetric cipher offload for PKCS11, as a number
     of accelerators support RSA only. This returns to the V7 default.

  *) mod_ibm_ssl: Disable the SSLv2-compatible open by default

  *) event_mpm: Remove TRACE6 message issued once per second per process

  *) mod_charset_lite: Fix failures with chunked HTTP requests.

  *) bin/envvars: Add the modules/ dirctory to the end of the shared library
     path instead of the front.

  *) default conf: Remove DefaultType for mod_mvsds (z/OS only).

  *) mod_authnz_saf: Add SAFAPPLID directive to allow SAFRunAs to use
     a specified application ID instead of "OMVSAPPL".
     See pthread_security_applid_np().
     (IBM for PI40885)

  *) mod_ibm_ssl: SSLServerCert did not respect quoted
     arguments, causing problmems with certificate labels
     containing spaces.
     (IBM for PI40952)

  *) mod_cgid: Within the first minute of a server start or restart,
     allow mod_cgid to retry connecting to its daemon process. Previously,
     'No such file or directory: unable to connect to cgi daemon...' could
     be logged without an actual retry.
     (Backport of r1667385 for PI38562)

  *) mod_ibm_ssl: Add SSLDGWEnv directive. When turned on, SSL-related
     envvars are copied to the corresponding DGW-style names.

  *) event_mpm, mod_ibm_ssl: Disable async write completion for SSL connections.
     They are not compatible with the way mod_ibm_ssl interacts wth GKSit.
    
Changes with IBM HTTP Server 9.0.0.0 (z/OS V2R2)

  *) SECURITY: CVE-2015-0228 (cve.mitre.org)
     mod_lua: A maliciously crafted websockets PING after a script
     calls r:wsupgrade() can cause a child process crash.
     [Edward Lu <Chaosed0 gmail.com>]

  *) SECURITY: CVE-2014-8730 (cve.mitre.org)
     mod_ibm_ssl: Turn on strict CBC padding check in GSKit by
     default to mitigate CVE-2014-8730; add SSLStrictCBCPaddingCheck
     directive to opt out of the check.
     (IBM for PI31516, strict checking already present for z/OS)

  *) SECURITY: CVE-2015-1829 (cve.mitre.org)
     APR applications using APR named pipe support on Windows can be
     vulnerable to a pipe squatting attack from a local process; the extent
     of the vulnerability, when present, depends on the application.
     Initial analysis and report was provided by John Hernandez of Casaba
     Security via HP SSRT Security Alert.
     [Yann Ylavic] (PI39833)

  *) mod_logio: Add LogIOTrackTTFB and %^FB logformat to log the time
     taken to start writing response headers. [Eric Covener]

  *) core: Add "PreserveDateHeader" directive to suppress
     replacement of the Date header issued by non-mod_proxy
     handlers, such as the WAS WebServer Plug-in.
     (IBM for PI35073)

  *) Disable mod_lua websockets support which is not yet ready
     for primetime (IBM)

  *) core: Initialize r->protocol in error paths.
     (IBM)

  *) mod_lua: After a r:wsupgrade(), mod_lua was not properly
     responding to a websockets PING but instead invoking the specified
     script. PR57524. [Edward Lu <Chaosed0 gmail.com>]

  *) config: For directives that do not expect any arguments, enforce
     that none are specified in the configuration file.
     [Joachim Zobel <jzobel heute-morgen.de>, Eric Covener]

  *) mod_authnz_saf: Do case insensitive compare with saf-user
     value. z/OS only. (IBM for PI32452)

  *) mod_wlm mod_cgi: Suppress enclave delete error message when
     running cgi. There is a race condition where we attempt to delete
     the enclave before the cgi porcess is completely cleaned up.
     (IBM for PI33039, z/OS 8.5.5 only)

  *) mod_ibm_ssl: Default ciphers for TLS1.2 now prefer ECDHE over RSA.

  *) mod_mpmstats: Add "AlwaysReport" directive (ON/OFF, default OFF)
     to allow interval based reports to write an entry even when there
     are no busy threads.

  *) mod_mpmstats: Make the interval-based reports less likely to be a
     second off even under low load.

  *) mod_net_trace: Properly label log entries associated with
     outbound body connections properly to assist in parsing.  The
     "flags" column of each proxy-related net trace entry is
     now OR'ed with 0x80.

  *) mod_macro: Add mod_macro

  *) mod_ibm_ssl: Allow SSLPrototoclDisable and SSLProtocolEnable
     in the global configuration, without any merging into
     virtual hosts. This is meant for customers with SSLEnable in
     global scope.
     (IBM for PI30093)

  *) mod_deflate_z: Record whether HW offload was used in per-request
     note %{zEDC}n.
     (IBM for PI30041)

  *) mod_ibm_ssl: Fix logging of ECDHE cipher parameters in
     environment variables.
     (IBM for PI32841)

  *) cgiparse: Fix mishandling of POST request bodies.
     (IBM for PI35519)

  *) core: Add the IfFile directive. (IBM)

Changes with IBM HTTP Server 9.0.0.0-beta3
Changes with IBM HTTP Server 9.0.0.0-beta2

  *) Rename default welcome page and update default configuration
     accordingly

  *) Fix startup problems on z/OS related to RNG initialization
 
  *) Fix occasional crashes with the event MPM under load
     (IBM)

  *) mod_zos_cmds: Change trace with jobname from debug to notice.
     (z/OS 8.5.5 only)

  *) mod_cache: Prevent a 304 response to a non-conditional request
     when the cache lock is busy.

  *) z_asio.c: Async i/o updates on z/OS.
     (z/OS only)

  *) mod_unixd: Update error message when starting as root on z/OS.
     (IBM for PI25783, z/OS only)

  *) mod_proxy: EBCDIC fixes for ProxyRemote + https origin server URLs.

  *) mod_ibm_ssl: Enable TLS1.1, TLS1.2, and ECC ciphers by default on z/OS.

  *) mod_zos_cmds: Add stats display to z/OS console modify command.
     (IBM for PI24990, z/OS 8.5.5 only)
    
  *) mod_smf: SMF records only being written when SMFLogDebug ON.
     (IBM for PI24782, 8.5.5 z/OS only)
 
  *) mod_deflate: Add mod_deflate_z which can use zEDC compression offload
     on z/OS.  [IBM]

  *) mod_log_config: Add GlobalLog to allow a globally defined log to
     be inherited by virtual hosts that define a CustomLog.
     [Edward Lu <Chaosed0 gmail.com>]

  *) core: Add IHS proprietary API to identify a thread as tied up being
     a websockets tunnel.

  *) sidd: SSL cache fails when unable to unlink the SSLCachePortFilename file.
     (IBM for PI17434, z/OS only)

  *) mod_alias: remove ap_set_context_info() from AliasMatch path.

  *) mod_charset_lite: Skip translation if "no-xlate" is set as a
     per-request environment variable.

  *) mod_mvsds: Free enq's on MVS datasets.
     (IBM for PI13949)

  *) Ensure mod_ibm_ssl always initializes before the WAS Plug-in, to avoid
     SSLFIPSEnable problems.  Previously, the relative startup order was
     undefined.
     (IBM for PI14451)

  *) mod_ibm_ssl: Changed default certificate validation from basic to standard
     validation (Distributed Only)

  *) mod_ibm_ssl: Added 10 second end-to-end timeout and 5 second IO timeout
     on SSL handshakes by default.

  *) mod_ibm_ssl: Added elliptic-curve ciphers to the list of default TLSv12
     ciphers.

  *) worker & event: Added warning on startup if full core dumps are not
     enabled on the AIX platform (or if the server can't tell if they're
     enabled or not)

  *) disk_cache: Fix hangs on Windows. PR55833 

  *) core: Extended error reporting during apr_thread_create() failures
     in the worker and event  MPM to highlight problems with the default stack
     size or limits on user processes. Linux only.
     (IBM for PI06366)

  *) mod_charset_lite: Don't try to translate responses with a non-identity
     Content-Encoding, such as pre-compressed static text documents.
     [Eric Covener]

  *) mod_proxy_connect: Fix ASCII/EBCDIC issue. (IBM for PM94602)

  *) IHS only: revert http://svn.apache.org/viewvc?view=rev&revision=608849
     (IBM for PR45023)

  *) mod_wlm: Use JobID instead of Jobname for WLM subsystem name.
     (8.5.5 on z/OS only, IBM for PM92105)

  *) mod_mpmstats: Added support for the event MPM.

  *) mod_mvsds: Escape URLs generated from MVSDSIndexes using ap_os_escape_path
     (IBM for PI21655)
    
  *) mod_mvsds: Fix binary detection check(when no content-type) and fix merge
     (IBM for PI21655)

Changes with Apache 2.4.20

  *) core: Do not read .htaccess if AllowOverride and AllowOverrideList
     are "None". PR 58528.
     [Michael Schlenker <msc contact.de, Ruediger Pluem, Daniel Ruggeri]

  *) mod_proxy_express: Fix possible use of DB handle after close.  PR 59230.
     [Petr <pgajdos suse.cz>]

  *) core/util_script: relax alphanumeric filter of environment variable names
     on Windows to allow '(' and ')' for passing PROGRAMFILES(X86) et.al.
     unadulterated in 64 bit versions of Windows. PR 46751.
     [John <john leineweb de>]

Changes with Apache 2.4.19

  *) mod_include: Add variable DOCUMENT_ARGS, with the arguments to the
     request for the SSI document.  [Jeff Trawick]

  *) mod_authz_host: Add a new "forward-dns" authorization type, not relying on
     reverse DNS lookups.  [Fabien]

  *) mod_ssl: Add hooks to allow other modules to perform processing at
     several stages of initialization and connection handling.  See
     mod_ssl_openssl.h.  [Jeff Trawick]

  *) mod_rewrite: Don't implicitly URL-escape the original query string
     when no substitution has changed it (like PR50447 but server context)
     [Evgeny Kotkov <evgeny.kotkov visualsvn.com>]

  *) mod_reqtimeout: Prevent long response times from triggering a timeout once
     the request has been fully read.  PR 59045.  [Yann Ylavic]

  *) ap_expr: expression support for variable HTTP2=on|off. [Stefan Eissing]

  *) mod_ssl: Don't lose track of the SSL context if an unlikely failure occurs
     in ssl_init_ssl_connection().  [Graham Leggett]

  *) mod_rewrite: Add QSL|qslast flag to allow rewrites to files with
     literal question marks in their names. PR 58777. [Eric Covener]

  *) event: use pre_connection hook to properly initialize connection state for
     slave connections. use protocol_switch hook to initialize server config
     early based on SNI selected vhost.
     [Stefan Eissing]

  *) hostname: Test and log useragent_host per-request across various modules,
     including the scoreboard, expression and rewrite engines, setenvif,
     authz_host, access_compat, custom logging, ssl and REMOTE_HOST variables.
     PR55348  [William Rowe]

  *) core: Track the useragent_host per-request when mod_remoteip or similar
     modules track a per-request useragent_ip.  Modules should be updated
     to inquire for ap_get_useragent_host() in place of ap_get_remote_host().
     [William Rowe]

  *) core: fix a bug in <UnDefine ...> directive processing. When used, the last
     <Define...>'ed variable was also withdrawn. PR 59019
     [Christophe Jaillet]

  *) prefork: Initialize the POD when running in ONE_PROCESS (or -X) mode to
     avoid a crash.  [Jan Kaluza, Yann Ylavic]

  *) mod_ssl: When SSLVerify is disabled (NONE), don't force a renegotiation if
     the SSLVerifyDepth applied with the default/handshaken vhost differs from
     the one applicable with the finally selected vhost.  [Yann Ylavic]

  *) core: Ensure that httpd exits with an error status when the MPM fails
     to run.  [Yann Ylavic]

  *) mod_ssl: Fix a possible memory leak on restart for custom [EC]DH params.
     [Jan Kaluza, Yann Ylavic]

  *) mod_ssl: Add SSLOCSPProxyURL to add the possibility to do all queries
     to OCSP responders through a HTTP proxy. [Ruediger Pluem]

  *) mod_proxy: Play/restore the TLS-SNI on new backend connections which
     had to be issued because the remote closed the previous/reusable one
     during idle (keep-alive) time.  [Yann Ylavic]

  *) mod_cache_socache: Fix a possible cached entity body corruption when it
     is received from an origin server in multiple batches and forwarded by
     mod_proxy.  [Yann Ylavic]

  *) core: Add expression support to SetHandler.
     [Eric Covener]

  *) mod_remoteip: Prevent an external proxy from presenting an internal
     proxy. PR 55962. [Mike Rumph]

  *) core: Prevent a server crash in case of an invalid CONNECT request with
     a custom error page for status code 400 that uses server side includes.
     PR 58929 [Ruediger Pluem]

  *) mod_ssl: handle TIMEOUT on empty SSL input as non-fatal, returning
     APR_TIMEUP and preserving connection state for later retry.
     [Stefan Eissing]

  *) mod_ssl: Save some TLS record (application data) fragmentations by
     including the last and subsequent suitable buckets when coalescing.
     [Yann Ylavic]

  *) mod_proxy_fcgi: Suppress HTTP error 503 and message 01075,
     "Error dispatching request", when the cause appears to be
     due to the client closing the connection.
     PR58118.  [Tobias Adolph <adolph lrz.de>]

  *) mod_cgid: Message AH02550, failure to flush a response to the client,
     is now logged at TRACE1 level to match the underlying core output filter
     severity.  [Eric Covener]

  *) mime.types: add common extension "m4a" for MPEG 4 Audio.
     PR 57895 [Dylan Millikin <dylan.millikin gmail.com>]

  *) Added many log numbers to log statements that had none.
     [Rainer Jung]

  *) mod_log_config: Add GlobalLog to allow a globally defined log to
     be inherited by virtual hosts that define a CustomLog.
     [Edward Lu]

  *) core: new hook "pre_close_connection" which is run before the lingering
     close of connections is started. This gives protocol handlers one last
     chance to use a connection before it goes down.
     [Stefan Eissing]

  *) mod_status/scoreboard: showing connection protocol in new column, new
     ap_update_child_status methods for updating server/description. mod_ssl
     sets vhost negotiated by servername directly.
     [Stefan Eissing]

Changes with Apache 2.4.18

  *) mod_ssl: for all ssl_engine_vars.c lookups, fall back to master connection
     if conn_rec itself holds no valid SSLConnRec*. Fixes PR58666.
     [Stefan Eissing]

  *) mod_proxy_fdpass: Fix AH01153 error when using the default configuration.
     In earlier version of httpd, you can explicitelly set the 'flusher' parameter
     to 'flush' as a workaround. (i.e. flusher=flush)
     Add documentation for the 'flusher' parameter when defining a proxy worker.
     [Christophe Jaillet]

  *) mod_ssl: For the "SSLStaplingReturnResponderErrors off" case, make sure
     to only staple responses with certificate status "good". [Kaspar Brand]
    
  *) core: if the first HTTP/1.1 request on a connection goes to a server that
     prefers different protocols, these protocols are announced in a Upgrade:
     header on the response, mentioning the preferred protocols.
     [Stefan Eissing]
    
  *) core: add ap_get_protocol_upgrades() to retrieve the list of protocols
     that a client could possibly upgrade to. Use in first request on a
     connection to announce protocol choices. [Stefan Eissing]

  *) mod_ssl: when receiving requests for other virtual hosts than the handshake
     server, the SSL parameters are checked for equality. With equal
     configuration, requests are passed for processing. Any change will trigger
     the old behaviour of "421 Misdirected Request".
     SSL now remembers the cipher suite that was used for the last handshake.
     This is compared against for any vhost/directory cipher specification.
     Detailed examination of renegotiation is only done when these do not
     match.
     Renegotiation is 403ed when a master connection is present. Exact reason
     is given additionally in a request note. [Stefan Eissing]

  *) mod_ssl: Make the output filter more friendly with deferred write and
     response pipelining. [Yann Ylavic, Joe Orton]

  *) core: Fix scoreboard crash (SIGBUS) on hardware requiring strict 64bit
     alignment (SPARC64, PPC64).  [Yann Ylavic]

  *) mod_cache: Accept HT (Horizontal Tab) when parsing cache related header
     fields as described in RFC7230. [Christophe Jaillet]

  *) core/util_script: making REDIRECT_URL a full URL is now opt-in
     via new 'QualifyRedirectURL' directive.

  *) core: Limit to ten the number of tolerated empty lines between request,
     and consume them before the pipelining check to avoid possible response
     delay when reading the next request without flushing.  [Yann Ylavic]

  *) mod_ssl: Extend expression parser registration to support ssl variables
     in any expression using mod_rewrite syntax "%{SSL:VARNAME}" or function
     syntax "ssl(VARNAME)". [Rainer Jung]

Changes with Apache 2.4.17

  *) mod_proxy: don't recyle backend announced "Connection: close" connections
     to avoid reusing it should the close be effective after some new request
     is ready to be sent.  [Yann Ylavic]

  *) mod_substitute: Allow to configure the patterns merge order with the new
     SubstituteInheritBefore on|off directive.  PR 57641
     [Marc.Stern <Marc.Stern approach.be>, Yann Ylavic, William Rowe]

  *) mod_proxy: Fix ProxySourceAddress binding failure with AH00938.
     PR 56687.  [Arne de Bruijn <apache arbruijn.dds.nl>

  *) mod_ssl: Support compilation against libssl built with OPENSSL_NO_SSL3,
     and change the compiled-in default for SSL[Proxy]Protocol to "all -SSLv3",
     in accordance with RFC 7568. PR 58349, PR 57120. [Kaspar Brand]

  *) mod_ssl: append :!aNULL:!eNULL:!EXP to the cipher string settings,
     instead of prepending !aNULL:!eNULL:!EXP: (as was the case in 2.4.7
     and later). Enables support for configuring the SUITEB* cipher
     strings introduced in OpenSSL 1.0.2. PR 58213. [Kaspar Brand]

  *) mod_ssl: Add support for extracting the msUPN and dnsSRV forms
     of subjectAltName entries of type "otherName" into
     SSL_{CLIENT,SERVER}_SAN_OTHER_{msUPN,dnsSRV}_n environment
     variables. Addresses PR 58020. [Jan Pazdziora <jpazdziora redhat.com>,
     Kaspar Brand]

  *) mod_logio: Fix logging of %^FB (time to first byte) on the first request on
     an SSL connection.  PR 58454. 
     [Konstantin J. Chernov <k.j.chernov gmail.com>]

  *) mod_cache: r->err_headers_out is not merged into
     r->headers when mod_cache is enabled and the response
     is cached for the first time. [Edward Lu]

  *) mod_slotmem_shm: Fix slots/SHM files names on restart for systems that
     can't create new (clear) slots while previous children gracefully stopping
     still use the old ones (e.g. Windows, OS2). mod_proxy_balancer failed to
     restart whenever the number of configured balancers/members changed during
     restart.  PR 58024.  [Yann Ylavic]

  *) core/util_script: make REDIRECT_URL a full URL.  PR 57785. [Nick Kew]

  *) MPMs: Support SO_REUSEPORT to create multiple duplicated listener
     records for scalability. [Yingqi Lu <yingqi.lu@intel.com>,
     Jeff Trawick, Jim Jagielski, Yann Ylavic]

  *) mod_alias: Introduce expression parser support for Alias, ScriptAlias
     and Redirect. Limit Redirect expressions to directory (Location) context
     and redirect statuses (implicit or explicit).
     [Graham Leggett, Yann Ylavic, Ruediger Pluem]

  *) mod_proxy: Fix a race condition that caused a failed worker to be retried
     before the retry period is over. [Ruediger Pluem]

  *) mod_autoindex: Allow autoindexes when neither mod_dir nor mod_mime are
     loaded. [Eric Covener]

  *) mod_rewrite:  Allow cookies set by mod_rewrite to contain ':' by accepting
     ';' as an alternate separator.  PR47241.
     [<bugzilla schermesser com>, Eric Covener]

  *) apxs: Add HTTPD_VERSION and HTTPD_MMN to the variables available with
     apxs -q. PR58202. [Daniel Shahaf <danielsh apache.org>]

  *) mod_rewrite: Avoid a crash when lacking correct DB access permissions
     when using RewriteMap with MapType dbd or fastdbd.  [Christophe Jaillet]

  *) mod_authz_dbd: Avoid a crash when lacking correct DB access permissions.
     PR 57868. [Jose Kahan <jose w3.org>, Yann Ylavic]

  *) mod_socache_memcache: Add the 'MemcacheConnTTL' directive to control how
     long to keep idle connections with the memcache server(s).
     Change default value from 600 usec (!) to 15 sec. PR 58091
     [Christophe Jaillet]

  *) mod_dir: Prevent the internal identifier "httpd/unix-directory" from
     appearing as a Content-Type response header when requests for a directory
     are rewritten by mod_rewrite. [Eric Covener]

Changes with Apache 2.4.16

  *) http: Fix LimitRequestBody checks when there is no more bytes to read.
     [Michael Kaufmann <mail michael-kaufmann.ch>]

  *) mod_alias: Revert expression parser support for Alias, ScriptAlias
     and Redirect due to a regression (introduced in 2.4.13, not released).

  *) mod_reqtimeout: Don't let pipelining checks and keep-alive times interfere
     with the timeouts computed for subsequent requests.  PR 56729.
     [Eric Covener, Yann Ylavic]

  *) core: Avoid a possible truncation of the faulty header included in the
     HTML response when LimitRequestFieldSize is reached.  [Yann Ylavic]

  *) mod_ldap: In some case, LDAP_NO_SUCH_ATTRIBUTE could be returned instead
     of an error during a compare operation. [Eric Covener]

Changes with Apache 2.4.15 (not released)

  *) mod_ext_filter, mod_charset_lite: Avoid inadvertent filtering of protocol
     data during read of chunked request bodies. PR 58049.
     [Edward Lu <Chaosed0 gmail.com>]

  *) mod_ldap: Stop leaking LDAP connections when 'LDAPConnectionPoolTTL 0'
     is configured.  PR 58037.  [Ted Phelps <phelps gnusto.com>]

  *) core: Allow spaces after chunk-size for compatibility with implementations
     using a pre-filled buffer.  [Yann Ylavic, Jeff Trawick]

  *) mod_ssl: Remove deprecated SSLCertificateChainFile warning.
     [Yann Ylavic]

Changes with Apache 2.4.14 (not released)

  *) SECURITY: CVE-2015-3183 (cve.mitre.org)
     core: Fix chunk header parsing defect.
     Remove apr_brigade_flatten(), buffering and duplicated code from
     the HTTP_IN filter, parse chunks in a single pass with zero copy.
     Limit accepted chunk-size to 2^63-1 and be strict about chunk-ext
     authorized characters.  [Graham Leggett, Yann Ylavic]

  *) SECURITY: CVE-2015-3185 (cve.mitre.org)
     Replacement of ap_some_auth_required (unusable in Apache httpd 2.4)
     with new ap_some_authn_required and ap_force_authn hook.  [Ben Reser]

Changes with Apache 2.4.13 (not released)

  *) SECURITY: CVE-2015-0253 (cve.mitre.org)
     core: Fix a crash with ErrorDocument 400 pointing to a local URL-path
     with the INCLUDES filter active, introduced in 2.4.11. PR 57531.
     [Yann Ylavic]

  *) SECURITY: CVE-2015-0228 (cve.mitre.org)
     mod_lua: A maliciously crafted websockets PING after a script
     calls r:wsupgrade() can cause a child process crash.
     [Edward Lu <Chaosed0 gmail.com>]

  *) mod_proxy: Don't put the worker in error state for 500 or 503 errors
     returned by the backend unless failonstatus is configured to.  PR 56925.
     [Yann Ylavic]

  *) core: Don't lowercase the argument to SetHandler if it begins with
     "proxy:unix". PR 57968. [Eric Covener]

  *) mod_ssl OCSP Stapling: Don't block initial handshakes while refreshing
     the OCSP response for a different certificate.  mod_ssl has an additional
     global mutex, "ssl-stapling-refresh".  PR 57131 (partial fix).
     [Jeff Trawick]

  *) mod_authz_dbm: Fix crashes when "dbm-file-group" is used and
     authz modules were loaded in the "wrong" order.  [Joe Orton]

  *) mod_authn_dbd, mod_authz_dbd, mod_session_dbd, mod_rewrite: Fix lifetime
     of DB lookup entries independently of the selected DB engine.  PR 46421.
     [Steven whitson <steven.whitson gmail com>, Jan Kaluza, Yann Ylavic].

  *) In alignment with RFC 7525, the default recommended SSLCipherSuite
     and SSLProxyCipherSuite now exclude RC4 as well as MD5. Also, the
     default recommended SSLProtocol and SSLProxyProtocol directives now
     exclude SSLv3. Existing configurations must be adjusted by the
     administrator. [William Rowe]

  *) mod_ssl: Add support for extracting subjectAltName entries of type
     rfc822Name and dNSName into SSL_{CLIENT,SERVER}_SAN_{Email,DNS}_n
     environment variables. Also addresses PR 57207. [Kaspar Brand]

  *) dav_validate_request: avoid validating locks and ETags when there are
     no If headers providing them on a resource we aren't modifying.
     [Ben Reser]

  *) mod_proxy_scgi: ProxySCGIInternalRedirect now allows an alternate
     response header to be used by the application, for when the application
     or framework is unable to return Location in the internal-redirect
     form.  [Jeff Trawick]

  *) core: Cleanup the request soon/even if some output filter fails to
     handle the EOR bucket.  [Yann Ylavic]

  *) mpm_event: Allow for timer events duplicates. [Jim Jagielski, Yann Ylavic]

  *) mod_proxy, mod_ssl, mod_cache_socache, mod_socache_*: Support machine
     readable server-status produced when using the "?auto" query string.
     [Rainer Jung]

  *) mod_status: Add more data to machine readable server-status produced
     when using the "?auto" query string.  [Rainer Jung]

  *) mod_ssl: Check for the Entropy Gathering Daemon (EGD) availability at
     configure time (RAND_egd), and complain if SSLRandomSeed requires using
     it otherwise.  [Bernard Spil <pil.oss gmail com>, Stefan Sperling,
     Kaspar Brand]

  *) mod_ssl: make sure to consistently output SSLCertificateChainFile
     deprecation warnings, when encountered in a VirtualHost block.
     [Falco Schwarz <hiding falco.me>]

  *) mod_log_config: Add "%{UNIT}T" format to output request duration in
     seconds, milliseconds or microseconds depending on UNIT ("s", "ms", "us").
     [Ben Reser, Rainer Jung]

  *) Allow FallbackResource to work when a directory is requested and
     there is no autoindex nor DirectoryIndex.
     [Jack <tjerk.meesters gmail.com>, Eric Covener]

  *) mod_proxy_wstunnel: Bypass the handler while the connection is not
     upgraded to WebSocket, so that other modules can possibly take over
     the leading HTTP requests.  [Yann Ylavic]

  *) mod_http: Fix incorrect If-Match handling. PR 57358
     [Kunihiko Sakamoto <ksakamoto google.com>]

  *) mod_ssl: Add a warning if protocol given in SSLProtocol or SSLProxyProtocol
     will override other parameters given in the same directive. This could be
     a missing + or - prefix.  PR 52820 [Christophe Jaillet]

  *) core, modules: Avoid error response/document handling by the core if some
     handler or input filter already did it while reading the request (causing
     a double response body).  [Yann Ylavic]

  *) mod_proxy_ajp: Fix client connection errors handling and logged status
     when it occurs.  PR 56823.  [Yann Ylavic]

  *) mod_proxy: Use the correct server name for SNI in case the backend
     SSL connection itself is established via a proxy server.
     PR 57139 [Szabolcs Gyurko <szabolcs gyurko.org>]

  *) mod_ssl: Fix possible crash when loading server certificate constraints.
     PR 57694. [Paul Spangler <paul.spangler ni com>, Yann Ylavic]

  *) build: Don't load both mod_cgi and mod_cgid in the default configuration
     if they're both built.  [olli hauer <ohauer gmx.de>]

  *) mod_logio: Add LogIOTrackTTFB and %^FB logformat to log the time
     taken to start writing response headers. [Eric Covener]

  *) mod_ssl: Avoid compilation errors with LibreSSL related to
     the use of ENGINE_CTRL_CHIL_SET_FORKCHECK.
     [Stuart Henderson <sthen openbsd.org>]

  *) mod_proxy_http: Use the "Connection: close" header for requests to
     backends not recycling connections (disablereuse), including the default
     reverse and forward proxies.  [Yann Ylavic]

  *) mod_proxy: Add ap_connection_reusable() for checking if a connection
     is reusable as of this point in processing.  [Jeff Trawick]

  *) mod_proxy_wstunnel: Avoid an empty response by failing with 502 (Bad
     Gateway) when no response is ever received from the backend.
     [Jan Kaluza]

  *) core_filters: Restore/disable TCP_NOPUSH option after non-blocking
     sendfile.  [Yann Ylavic]

  *) mod_buffer: Forward flushed input data immediately and avoid (unlikely)
     access to freed memory. [Yann Ylavic, Christophe Jaillet]

  *) core: Add CGIPassAuth directive to control whether HTTP authorization
     headers are passed to scripts as CGI variables.  PR 56855.  [Jeff
     Trawick]

  *) core: Initialize scoreboard's used optional functions on graceful restarts
     to avoid a crash when relocation occurs.  PR 57177.  [Yann Ylavic]

  *) mod_dav: Avoid a potential integer underflow in the lock timeout value sent
     back to a client. The answer to a LOCK request could be an extremly large
     integer if the time needed to lock the resource was longer that the
     requested timeout given in the LOCK request. In such a case, we now answer
     "Second-0".  PR55420
     [Christophe Jaillet]

  *) mod_cgid: Within the first minute of a server start or restart,
     allow mod_cgid to retry connecting to its daemon process. Previously,
     'No such file or directory: unable to connect to cgi daemon...' could
     be logged without an actual retry. PR57685.
     [Edward Lu <Chaosed0 gmail.com>]
    
  *) mod_proxy: Use the original (non absolute) form of the request-line's URI
     for requests embedded in CONNECT payloads used to connect SSL backends via
     a ProxyRemote forward-proxy.  PR 55892.  [Hendrik Harms <hendrik.harms
     gmail com>, William Rowe, Yann Ylavic]

  *) http: Make ap_die() robust against any HTTP error code and not modify
     response status (finally logged) when nothing is to be done. PR 56035.
     [Yann Ylavic]

  *) mod_proxy_connect/wstunnel: If both client and backend sides get readable
     at the same time, don't lose errors occurring while forwarding on the first
     side when none occurs next on the other side, and abort.  [Yann Ylavic]

  *) mod_rewrite: Improve relative substitutions in per-directory/htaccess
     context for directories found by mod_userdir and mod_alias.  These no
     longer require RewriteBase to be specified. [Eric Covener]

  *) mod_proxy_http: Don't expect the backend to ack the "Connection: close" to
     finally close those not meant to be kept alive by SetEnv proxy-nokeepalive
     or force-proxy-request-1.0.  [Yann Ylavic]

  *) core: If explicitly configured, use the KeepaliveTimeout value of the
     virtual host which handled the latest request on the connection, or by
     default the one of the first virtual host bound to the same IP:port.
     PR56226.  [Yann Ylavic]

  *) mod_lua: After a r:wsupgrade(), mod_lua was not properly
     responding to a websockets PING but instead invoking the specified
     script. PR57524. [Edward Lu <Chaosed0 gmail.com>]

  *) mod_ssl: Add the SSL_CLIENT_CERT_RFC4523_CEA variable, which provides
     a combination of certificate serialNumber and issuer as defined by
     CertificateExactMatch in RFC4523. [Graham Leggett]

  *) core: Add expression support to ErrorDocument. Switch from a fixed
     sized 664 byte array per merge to a hash table. [Graham Leggett]

  *) ab: Add missing longest request (100%) to CSV export.
     [Marcin Fabrykowski <bugzilla fabrykowski.pl>]

  *) mod_macro: Clear macros before initialization to avoid use-after-free
     on startup or restart when the module is linked statically. PR 57525
     [apache.org tech.futurequest.net, Yann Ylavic]

  *) mod_alias: Introduce expression parser support for Alias, ScriptAlias
     and Redirect. [Graham Leggett]

  *) mod_ssl: 'SSLProtocol ALL' was being ignored in virtual host context.
     PR 57100.  [Michael Kaufmann <apache-bugzilla michael-kaufmann.ch>,
     Yann Ylavic]

  *) mpm_event: Avoid access to the scoreboard from the connection while
     it is suspended (waiting for events).  [Eric Covener, Jeff Trawick]

  *) mod_ssl: Fix renegotiation failures redirected to an ErrorDocument.
     PR 57334.  [Yann Ylavic].

  *) mod_deflate: A misplaced check prevents limiting small bodies with the
     new inflate limits. PR56872. [Edward Lu, Eric Covener, Yann Ylavic]

  *) mod_proxy_ajp: Forward SSL protocol name (SSLv3, TLSv1.1 etc.) as a
     request attribute to the backend. Recent Tomcat versions will extract
     it and provide it as a servlet request attribute named
     "org.apache.tomcat.util.net.secure_protocol_version". [Rainer Jung]

  *) core: Optimize string concatenation in expression parser when evaluating
     a string expression. [Rainer Jung]

  *) acinclude.m4: Generate #LoadModule directive in default httpd.conf for
     every --enable-mpms-shared. PR 53882.  [olli hauer <ohauer gmx.de>,
     Yann Ylavic]

  *) mod_authn_dbd: Fix the error message logged in case of error while querying
     the database. This is associated to AH01656 and AH01661. [Christophe Jaillet]

  *) mod_authz_groupfile: Reduce the severity of AH01667 from ERROR to DEBUG,
     because it may be evaluated inside <RequireAny>. PR55523. [Eric Covener]

  *) mod_ssl: Fix small memory leak during initialization when ECDH is used.
     [Jan Kaluza]

Changes with Apache 2.4.12
 
  *) SECURITY: CVE-2014-3583 (cve.mitre.org)
     mod_proxy_fcgi: Fix a potential crash due to buffer over-read, with
     response headers' size above 8K.  [Yann Ylavic, Jeff Trawick]

  *) SECURITY: CVE-2014-3581 (cve.mitre.org)
     mod_cache: Avoid a crash when Content-Type has an empty value.
     PR 56924.  [Mark Montague <mark catseye.org>, Jan Kaluza]

  *) SECURITY: CVE-2014-8109 (cve.mitre.org)
     mod_lua: Fix handling of the Require line when a LuaAuthzProvider is
     used in multiple Require directives with different arguments.
     PR57204 [Edward Lu <Chaosed0 gmail.com>]

  *) SECURITY: CVE-2013-5704 (cve.mitre.org)
     core: HTTP trailers could be used to replace HTTP headers
     late during request processing, potentially undoing or
     otherwise confusing modules that examined or modified
     request headers earlier.  Adds "MergeTrailers" directive to restore
     legacy behavior.  [Edward Lu, Yann Ylavic, Joe Orton, Eric Covener]

  *) mod_ssl: New directive SSLSessionTickets (On|Off).
     The directive controls the use of TLS session tickets (RFC 5077),
     default value is "On" (unchanged behavior).
     Session ticket creation uses a random key created during web
     server startup and recreated during restarts. No other key
     recreation mechanism is available currently. Therefore using session
     tickets without restarting the web server with an appropriate frequency
     (e.g. daily) compromises perfect forward secrecy. [Rainer Jung]

  *) mod_proxy_fcgi: Provide some basic alternate options for specifying
     how PATH_INFO is passed to FastCGI backends by adding significance to
     the value of proxy-fcgi-pathinfo. PR 55329. [Eric Covener]

  *) mod_proxy_fcgi: Enable UDS backends configured with SetHandler/RewriteRule
     to opt-in to connection reuse and other Proxy options via explicitly
     declared "proxy workers" (<Proxy unix:... enablereuse=on max=...)
     [Eric Covener]

  *) mod_proxy: Add "enablereuse" option as the inverse of "disablereuse".
     [Eric Covener]

  *) mod_proxy_fcgi: Enable opt-in to TCP connection reuse by explicitly
     setting proxy option disablereuse=off. [Eric Covener] PR 57378.

  *) event: Update the internal "connection id" when requests
     move from thread to thread. Reuse can confuse modules like
     mod_cgid. PR 57435. [Michael Thorpe <mike gistnet.com>]

  *) mod_proxy_fcgi: Remove proxy:balancer:// prefix from SCRIPT_FILENAME
     passed to fastcgi backends. [Eric Covener]

  *) core: Configuration files with long lines and continuation characters
     are not read properly. PR 55910. [Manuel Mausz <manuel-as mausz.at>]

  *) mod_include: the 'env' function was incorrectly handled as 'getenv' if the
     leading 'e' was written in upper case in <!--#if expr="..." -->
     statements. [Christophe Jaillet]

  *) split-logfile: Fix perl error:  'Can't use string ("example.org:80")
     as a symbol ref while "strict refs"'. PR 56329.
     [Holger Mauermann <mauermann gmail.com>]

  *) mod_proxy: Prevent ProxyPassReverse from doing a substitution when
     the URL parameter interpolates to an empty string. PR 56603.
     [<ajprout hotmail.com>]

  *) core: Fix -D[efined] or <Define>[d] variables lifetime across restarts.
     PR 57328.  [Armin Abfalterer <a.abfalterer gmail.com>, Yann Ylavic].

  *) mod_proxy: Preserve original request headers even if they differ
     from the ones to be forwarded to the backend. PR 45387.
     [Yann Ylavic]

  *) mod_ssl: dump SSL IO/state for the write side of the connection(s),
     like reads (level TRACE4). [Yann Ylavic]

  *) mod_proxy_fcgi: Ignore body data from backend for 304 responses. PR 57198.
     [Jan Kaluza]

  *) mod_ssl: Do not crash when looking up SSL related variables during
     expression evaluation on non SSL connections. PR 57070  [Ruediger Pluem]

  *) mod_proxy_ajp: Fix handling of the default port (8009) in the
     ProxyPass and <Proxy> configurations.  PR 57259.  [Yann Ylavic]

  *) mpm_event: Avoid a possible use after free when notifying the end of
     connection during lingering close.  PR 57268.  [Eric Covener, Yann Ylavic]

  *) mod_ssl: Fix recognition of OCSP stapling responses that are encoded
     improperly or too large.  [Jeff Trawick]

  *) core: Add ap_log_data(), ap_log_rdata(), etc. for logging buffers.
     [Jeff Trawick]

  *) mod_proxy_fcgi, mod_authnz_fcgi: stop reading the response and issue an
     error when parsing or forwarding the response fails. [Yann Ylavic]

  *) mod_ssl: Fix a memory leak in case of graceful restarts with OpenSSL >= 0.9.8e
     PR 53435 [tadanori <tadanori2007 yahoo.com>, Sebastian Wiedenroth <wiedi frubar.net>]

  *) mod_proxy_connect: Don't issue AH02447 on sockets hangups, let the read
     determine whether it is a normal close or a real error. PR 57168. [Yann
     Ylavic]

  *) mod_proxy_wstunnel: abort backend connection on polling error to avoid
     further processing.  [Yann Ylavic]

  *) core: Support custom ErrorDocuments for HTTP 501 and 414 status codes.
     PR 57167 [Edward Lu <Chaosed0 gmail.com>]

  *) mod_proxy_connect: Fix ProxyRemote to https:// backends on EBCDIC
     systems. PR 57092 [Edward Lu <Chaosed0 gmail.com>]

  *) mod_cache: Avoid a 304 response to an unconditional requst when an AH00752
     CacheLock error occurs during cache revalidation. [Eric Covener]

  *) mod_ssl: Move OCSP stapling information from a per-certificate store to
     a per-server hash. PR 54357, PR 56919. [Alex Bligh <alex alex.org.uk>,
     Yann Ylavic, Kaspar Brand]

  *) mod_cache_socache: Change average object size hint from 32 bytes to
     2048 bytes.  [Rainer Jung]

  *) mod_cache_socache: Add cache status to server-status.  [Rainer Jung]

  *) event: Fix worker-listener deadlock in graceful restart.
     PR 56960.

  *) Concat strings at compile time when possible. PR 53741.

  *) mod_substitute: Restrict configuration in .htaccess to
     FileInfo as documented.  [Rainer Jung]

  *) mod_substitute: Make maximum line length configurable.  [Rainer Jung]

  *) mod_substitute: Fix line length limitation in case of regexp plus flatten.
     [Rainer Jung]
 
  *) mod_proxy: Truncated character worker names are no longer fatal
     errors. PR53218. [Jim Jagielski]

  *) mod_dav: Set r->status_line in dav_error_response. PR 55426.

  *) mod_proxy_http, mod_cache: Avoid (unlikely) accesses to freed memory.
     [Yann Ylavic, Christophe Jaillet]

  *) http_protocol: fix logic in ap_method_list_(add|remove) in order:
       - to correctly reset bits
       - not to modify the 'method_mask' bitfield unnecessarily
     [Christophe Jaillet]

  *) mod_slotmem_shm: Increase log level for some originally debug messages.
     [Jim Jagielski]

  *) mod_ldap: In 2.4.10, some LDAP searches or comparisons might be done with
     the wrong credentials when a backend connection is reused.
     [Eric Covener]

  *) mod_macro: Add missing APLOGNO for some Warning log messages.
     [Christophe Jaillet]

  *) mod_cache: Avoid sending 304 responses during failed revalidations
     PR56881. [Eric Covener]

  *) mod_status: Honor client IP address using mod_remoteip. PR 55886.
     [Jim Jagielski]

  *) cmake-based build for Windows: Fix incompatibility with cmake 2.8.12
     and later.  PR 56615.  [Chuck Liu <cliu81 gmail.com>, Jeff Trawick]

  *) mod_ratelimit: Drop severity of AH01455 and AH01457 (ap_pass_brigade
     failed) messages from ERROR to TRACE1.  Other filters do not bother
     re-reporting failures from lower level filters.  PR56832.  [Eric Covener]

  *) core: Avoid useless warning message when parsing a section guarded by
     <IfDefine foo> if $(foo) is used within the section.
     PR 56503 [Christophe Jaillet]

  *) mod_proxy_fcgi: Fix faulty logging of large amounts of stderr from the
     application.  PR 56858.  [Manuel Mausz <manuel-asf mausz.at>]

  *) mod_proxy_http: Proxy responses with error status and
     "ProxyErrorOverride On" hang until proxy timeout.
     PR53420 [Rainer Jung]

  *) mod_log_config: Allow three character log formats to be registered. For
     backwards compatibility, the first character of a three-character format
     must be the '^' (caret) character.  [Eric Covener]

  *) mod_lua: Don't quote Expires and Path values. PR 56734.
     [Keith Mashinter, <kmashint yahoo com>]

  *) mod_authz_core: Allow <AuthzProviderAlias>'es to be seen from auth
     stanzas under virtual hosts. PR 56870. [Eric Covener]

Changes with Apache 2.4.10

  *) SECURITY: CVE-2014-0117 (cve.mitre.org)
     mod_proxy: Fix crash in Connection header handling which allowed a denial
     of service attack against a reverse proxy with a threaded MPM.
     [Ben Reser]

  *) SECURITY: CVE-2014-3523 (cve.mitre.org)
     Fix a memory consumption denial of service in the WinNT MPM, used in all
     Windows installations. Workaround: AcceptFilter <protocol> {none|connect}
     [Jeff Trawick]

  *) SECURITY: CVE-2014-0226 (cve.mitre.org)
     Fix a race condition in scoreboard handling, which could lead to
     a heap buffer overflow.  [Joe Orton, Eric Covener]

  *) SECURITY: CVE-2014-0118 (cve.mitre.org)
     mod_deflate: The DEFLATE input filter (inflates request bodies) now
     limits the length and compression ratio of inflated request bodies to
     avoid denial of service via highly compressed bodies.  See directives
     DeflateInflateLimitRequestBody, DeflateInflateRatioLimit,
     and DeflateInflateRatioBurst. [Yann Ylavic, Eric Covener]

  *) SECURITY: CVE-2014-0231 (cve.mitre.org)
     mod_cgid: Fix a denial of service against CGI scripts that do
     not consume stdin that could lead to lingering HTTPD child processes
     filling up the scoreboard and eventually hanging the server.  By
     default, the client I/O timeout (Timeout directive) now applies to
     communication with scripts.  The CGIDScriptTimeout directive can be
     used to set a different timeout for communication with scripts.
     [Rainer Jung, Eric Covener, Yann Ylavic]

  *) SECURITY: CVE-2014-0963 (cve.mitre.org)
     mod_ibm_ssl: Avoid bounded hangs and bounded high CPU under some SSL
     error conditions in configurations with mod_reqtimeout.
     (IBM for PI17025)

  *) mod_ssl: Extend the scope of SSLSessionCacheTimeout to sessions
     resumed by TLS session resumption (RFC 5077). [Rainer Jung]

  *) mod_deflate: Don't fail when flushing inflated data to the user-agent
     and that coincides with the end of stream ("Zlib error flushing inflate
     buffer"). PR 56196. [Christoph Fausak <christoph fausak glueckkanja.com>]

  *) mod_proxy_ajp: Forward local IP address as a custom request attribute
     like we already do for the remote port. [Rainer Jung]

  *) core: Include any error notes set by modules in the canned error
     response for 403 errors.  [Jeff Trawick]

  *) mod_ssl: Set an error note for requests rejected due to
     SSLStrictSNIVHostCheck.  [Jeff Trawick]

  *) mod_ssl: Fix issue with redirects to error documents when handling
     SNI errors.  [Jeff Trawick]

  *) mod_ssl: Fix tmp DH parameter leak, adjust selection to prefer
     larger keys and support up to 8192-bit keys.  [Ruediger Pluem,
     Joe Orton]

  *) mod_dav: Fix improper encoding in PROPFIND responses.  PR 56480.
     [Ben Reser]

  *) WinNT MPM: Improve error handling for termination events in child.
     [Jeff Trawick]

  *) mod_proxy: When ping/pong is configured for a worker, don't send or
     forward "100 Continue" (interim) response to the client if it does
     not expect one. [Yann Ylavic]

  *) mod_ldap: Be more conservative with the last-used time for
     LDAPConnectionPoolTTL. PR54587 [Eric Covener]

  *) mod_ldap: LDAP connections used for authn were not respecting
     LDAPConnectionPoolTTL. PR54587 [Eric Covener]

  *) mod_proxy_fcgi: Fix occasional high CPU when handling request bodies.
     [Jeff Trawick]

  *) event MPM: Fix possible crashes (third-party modules accessing c->sbh)
     or occasional missed mod_status updates under load. PR 56639.
     [Edward Lu <Chaosed0 gmail com>]

  *) mod_authnz_ldap: Support primitive LDAP servers do not accept
     filters, such as "SDBM-backed LDAP" on z/OS, by allowing a special
     filter "none" to be specified in AuthLDAPURL. [Eric Covener]

  *) mod_deflate: Fix inflation of files larger than 4GB. PR 56062.
     [Lukas Bezdicka <social v3.sk>]

  *) mod_deflate: Handle Zlib header and validation bytes received in multiple
     chunks. PR 46146. [Yann Ylavic]

  *) mod_proxy: Allow reverse-proxy to be set via explicit handler.
     [ryo takatsuki <ryotakatsuki gmail com>]

  *) ab: support custom HTTP method with -m argument. PR 56604.
     [Roman Jurkov <winfinit gmail.com>]

  *) mod_proxy_balancer: Correctly encode user provided data in management
     interface. PR 56532 [Maksymilian, <max cert.cx>]

  *) mod_proxy: Don't limit the size of the connectable Unix Domain Socket
     paths. [Graham Dumpleton, Christophe Jaillet, Yann Ylavic]

  *) mod_proxy_fcgi: Support iobuffersize parameter.  [Jeff Trawick]

  *) event: Send the SSL close notify alert when the KeepAliveTimeout
     expires. PR54998. [Yann Ylavic]

  *) mod_ssl: Ensure that the SSL close notify alert is flushed to the client.
     PR54998. [Tim Kosse <tim.kosse filezilla-project.org>, Yann Ylavic]

  *) mod_proxy: Shutdown (eg. SSL close notify) the backend connection before
     closing. [Yann Ylavic]

  *) mod_auth_form: Add a debug message when the fields on a form are not
     recognised. [Graham Leggett]

  *) mod_cache: Preserve non-cacheable headers forwarded from an origin 304
     response. PR 55547.  [Yann Ylavic]

  *) mod_proxy_wstunnel: Fix the use of SSL connections with the "wss:"
     scheme. PR55320. [Alex Liu <alex.leo.ca gmail.com>]

  *) mod_socache_shmcb: Correct counting of expirations for status display.
     Expirations happening during retrieval were not counted. [Rainer Jung]

  *) mod_cache: Retry unconditional request with the full URL (including the
     query-string) when the origin server's 304 response does not match the
     conditions used to revalidate the stale entry.  [Yann Ylavic].

  *) mod_alias: Stop setting CONTEXT_PREFIX and CONTEXT_DOCUMENT environment
     variables as a result of AliasMatch. [Eric Covener]

  *) mod_cache: Don't add cached/revalidated entity headers to a 304 response.
     PR 55547.  [Yann Ylavic]

  *) mod_proxy_scgi: Support Unix sockets.  ap_proxy_port_of_scheme():
     Support default SCGI port (4000).  [Jeff Trawick]

  *) mod_cache: Fix AH00784 errors on Windows when the the CacheLock directive
     is enabled.  [Eric Covener]

  *) mod_expires: don't add Expires header to error responses (4xx/5xx),
     be they generated or forwarded. PR 55669.  [Yann Ylavic]

  *) mod_proxy_fcgi: Don't segfault when failing to connect to the backend.
     (regression in 2.4.9 release) [Jeff Trawick]

  *) mod_authn_socache: Fix crash at startup in certain configurations.
     PR 56371. (regression in 2.4.7) [Jan Kaluza]

  *) mod_ssl: restore argument structure for "exec"-type SSLPassPhraseDialog
     programs to the form used in releases up to 2.4.7, and emulate
     a backwards-compatible behavior for existing setups. [Kaspar Brand]

  *) mod_ssl: Add SSLOCSPUseRequestNonce directive to control whether or not
     OCSP requests should use a nonce to be checked against the responder's
     one. PR 56233. [Yann Ylavic, Kaspar Brand]

  *) mod_ssl: "SSLEngine off" will now override a Listen-based default
     and does disable mod_ssl for the vhost.  [Joe Orton]

  *) mod_lua: Enforce the max post size allowed via r:parsebody()
     [Daniel Gruno]

  *) mod_lua: Use binary comparison to find boundaries for multipart
     objects, as to not terminate our search prematurely when hitting
     a NULL byte. [Daniel Gruno]

  *) mod_ssl: add workaround for SSLCertificateFile when using OpenSSL
     versions before 0.9.8h and not specifying an SSLCertificateChainFile
     (regression introduced with 2.4.8). PR 56410. [Kaspar Brand]

  *) mod_ssl: bring SNI behavior into better conformance with RFC 6066:
     no longer send warning-level unrecognized_name(112) alerts,
     and limit startup warnings to cases where an OpenSSL version
     without TLS extension support is used. PR 56241. [Kaspar Brand]

  *) mod_proxy_html: Avoid some possible memory access violation in case of
     specially crafted files, when the ProxyHTMLMeta directive is turned on.
     Follow up of PR 56287 [Christophe Jaillet]

  *) mod_auth_form: Make sure the optional functions are loaded even when
     the AuthFormProvider isn't specified. [Graham Leggett]

  *) mod_ssl: avoid processing bogus SSLCertificateKeyFile values
     (and logging garbled file names). PR 56306. [Kaspar Brand]

  *) mod_ssl: fix merging of global and vhost-level settings with the
     SSLCertificateFile, SSLCertificateKeyFile, and SSLOpenSSLConfCmd
     directives. PR 56353. [Kaspar Brand]

  *) mod_headers: Allow the "value" parameter of Header and RequestHeader to
     contain an ap_expr expression if prefixed with "expr=". [Eric Covener]

  *) rotatelogs: Avoid creation of zombie processes when -p is used on
     Unix platforms.  [Joe Orton]

  *) mod_authnz_fcgi: New module to enable FastCGI authorizer
     applications to authenticate and/or authorize clients.
     [Jeff Trawick]

  *) mod_proxy: Do not try to parse the regular expressions passed by
     ProxyPassMatch as URL as they do not follow their syntax.
     PR 56074. [Ruediger Pluem]

  *) mod_reqtimeout: Resolve unexpected timeouts on keepalive requests
     under the Event MPM. PR56216.  [Frank Meier <frank meier ergon ch>]

  *) mod_proxy_fcgi: Fix sending of response without some HTTP headers
     that might be set by filters.  PR 55558. [Jim Riggs <jim riggs.me>]

  *) mod_proxy_html: Do not delete the wrong data from HTML code when a
     "http-equiv" meta tag specifies a Content-Type behind any other
     "http-equiv" meta tag. PR 56287 [Micha Lenk <micha lenk info>]

  *) mod_proxy: Don't reuse a SSL backend connection whose requested SNI
     differs. PR 55782.  [Yann Ylavic]

  *) Add suspend_connection and resume_connection hooks to notify modules
     when the thread/connection relationship changes.  (Should be implemented
     for any third-party async MPMs.)  [Jeff Trawick]

  *) mod_proxy_wstunnel: Don't issue AH02447 and log a 500 on routine
     hangups from websockets origin servers. PR 56299
     [Yann Ylavic, Edward Lu <Chaosed0 gmail com>, Eric Covener]

  *) mod_proxy_wstunnel: Don't pool backend websockets connections,
     because we need to handshake every time. PR 55890.
     [Eric Covener]

  *) mod_lua: Redesign how request record table access behaves,
     in order to utilize the request record from within these tables.
     [Daniel Gruno]

  *) mod_lua: Add r:wspeek for peeking at WebSocket frames. [Daniel Gruno]

  *) mod_lua: Log an error when the initial parsing of a Lua file fails.
     [Daniel Gruno, Felipe Daragon <filipe syhunt com>]

  *) mod_lua: Reformat and escape script error output.
     [Daniel Gruno, Felipe Daragon <filipe syhunt com>]

  *) mod_lua: URL-escape cookie keys/values to prevent tainted cookie data
     from causing response splitting.
     [Daniel Gruno, Felipe Daragon <filipe syhunt com>]

  *) mod_lua: Disallow newlines in table values inside the request_rec,
     to prevent HTTP Response Splitting via tainted headers.
     [Daniel Gruno, Felipe Daragon <filipe syhunt com>]

  *) mod_lua: Remove the non-working early/late arguments for
     LuaHookCheckUserID. [Daniel Gruno]

  *) mod_lua: Change IVM storage to use shm [Daniel Gruno]

  *) mod_lua: More verbose error logging when a handler function cannot be
     found. [Daniel Gruno]

Changes with Apache 2.4.9

  *) mod_ssl: Work around a bug in some older versions of OpenSSL that
     would cause a crash in SSL_get_certificate for servers where the
     certificate hadn't been sent. [Stephen Henson]

  *) mod_lua: Add a fixups hook that checks if the original request is intended
     for LuaMapHandler. This fixes a bug where FallbackResource invalidates the
     LuaMapHandler directive in certain cases by changing the URI before the map
     handler code executes [Daniel Gruno, Daniel Ferradal <dferradal gmail com>].

Changes with Apache 2.4.8 (not released)

  *) SECURITY: CVE-2014-0098 (cve.mitre.org)
     Clean up cookie logging with fewer redundant string parsing passes.
     Log only cookies with a value assignment. Prevents segfaults when
     logging truncated cookies.
     [William Rowe, Ruediger Pluem, Jim Jagielski]

  *) SECURITY: CVE-2013-6438 (cve.mitre.org)
     mod_dav: Keep track of length of cdata properly when removing
     leading spaces. Eliminates a potential denial of service from
     specifically crafted DAV WRITE requests
     [Amin Tora <Amin.Tora neustar.biz>]

  *) core: Support named groups and backreferences within the LocationMatch,
     DirectoryMatch, FilesMatch and ProxyMatch directives. (Requires
     non-ancient PCRE library) [Graham Leggett]

  *) core: draft-ietf-httpbis-p1-messaging-23 corrections regarding
     TE/CL conflicts. [Yann Ylavic, Jim Jagielski]

  *) core: Detect incomplete request and response bodies, log an error and
     forward it to the underlying filters. PR 55475 [Yann Ylavic]

  *) mod_dir: Add DirectoryCheckHandler to allow a 2.2-like behavior, skipping
     execution when a handler is already set. PR53929. [Eric Covener]

  *) mod_ssl: Do not perform SNI / Host header comparison in case of a
     forward proxy request. [Ruediger Pluem]

  *) mod_ssl: Remove the hardcoded algorithm-type dependency for the
     SSLCertificateFile and SSLCertificateKeyFile directives, to enable
     future algorithm agility, and deprecate the SSLCertificateChainFile
     directive (obsoleted by SSLCertificateFile). [Kaspar Brand]

  *) mod_rewrite: Add RewriteOptions InheritDown, InheritDownBefore,
     and IgnoreInherit to allow RewriteRules to be pushed from parent scopes
     to child scopes without explicitly configuring each child scope.
     PR56153.  [Edward Lu <Chaosed0 gmail com>]

  *) prefork: Fix long delays when doing a graceful restart.
     PR 54852 [Jim Jagielski, Arkadiusz Miskiewicz <arekm maven pl>]

  *) FreeBSD: Disable IPv4-mapped listening sockets by default for versions
     5+ instead of just for FreeBSD 5. PR 53824. [Jeff Trawick]

  *) mod_proxy_wstunnel: Avoid busy loop on client errors, drop message
     IDs 02445, 02446, and 02448 to TRACE1 from DEBUG. PR 56145.
     [Joffroy Christen <joffroy.christen solvaxis com>, Eric Covener]

  *) mod_remoteip: Correct the trusted proxy match test. PR 54651.
     [Yoshinori Ehara <yoshinori ehara gmail com>, Eugene L <eugenel amazon com>]

  *) mod_proxy_fcgi: Fix error message when an unexpected protocol version
     number is received from the application.  PR 56110.  [Jeff Trawick]

  *) mod_remoteip: Use the correct IP addresses to populate the proxy_ips field.
     PR 55972. [Mike Rumph]

  *) mod_lua: Update r:setcookie() to accept a table of options and add domain,
     path and httponly to the list of options available to set.
     PR 56128 [Edward Lu <Chaosed0 gmail com>, Daniel Gruno]
    
  *) mod_lua: Fix r:setcookie() to add, rather than replace,
     the Set-Cookie header. PR56105
     [Kevin J Walters <kjw ms com>, Edward Lu <Chaosed0 gmail com>]

  *) mod_lua: Allow for database results to be returned as a hash with
     row-name/value pairs instead of just row-number/value. [Daniel Gruno]

  *) mod_rewrite: Add %{CONN_REMOTE_ADDR} as the non-useragent counterpart to
     %{REMOTE_ADDR}. PR 56094. [Edward Lu <Chaosed0 gmail com>]

  *) WinNT MPM: If ap_run_pre_connection() fails or sets c->aborted, don't
     save the socket for reuse by the next worker as if it were an
     APR_SO_DISCONNECTED socket. Restores 2.2 behavior. [Eric Covener]

  *) mod_dir: Don't search for a DirectoryIndex or DirectorySlash on a URL
     that was just rewritten by mod_rewrite. PR53929. [Eric Covener]

  *) mod_session: When we have a session we were unable to decode,
     behave as if there was no session at all. [Thomas Eckert
     <thomas.r.w.eckert gmail com>]

  *) mod_session: Fix problems interpreting the SessionInclude and
     SessionExclude configuration. PR 56038. [Erik Pearson
     <erik adaptations.com>]

  *) mod_authn_core: Allow <AuthnProviderAlias>'es to be seen from auth
     stanzas under virtual hosts. PR 55622. [Eric Covener]

  *) mod_proxy_fcgi: Use apr_socket_timeout_get instead of hard-coded
     30 seconds timeout. [Jan Kaluza]

  *) build: only search for modules (config*.m4) in known subdirectories, see
     build/config-stubs. [Stefan Fritsch]

  *) mod_cache_disk: Fix potential hangs on Windows when using mod_cache_disk.
     PR 55833. [Eric Covener]

  *) mod_ssl: Add support for OpenSSL configuration commands by introducing
     the SSLOpenSSLConfCmd directive. [Stephen Henson, Kaspar Brand]

  *) mod_proxy: Remove (never documented) <Proxy ~ wildcard-url> syntax which
     is equivalent to <ProxyMatch wildcard-url>. [Christophe Jaillet]

  *) mod_authz_user, mod_authz_host, mod_authz_groupfile, mod_authz_dbm,
     mod_authz_dbd, mod_authnz_ldap: Support the expression parser within the
     require directives. [Graham Leggett]

  *) mod_proxy_http: Core dumped under high load. PR 50335.
     [Jan Kaluza <jkaluza redhat.com>]

  *) mod_socache_shmcb.c: Remove arbitrary restriction on shared memory size
     previously limited to 64MB. [Jens Laas <jelaas gmail.com>]

  *) mod_lua: Use binary copy when dealing with uploads through r:parsebody()
     to prevent truncating files. [Daniel Gruno]

Changes with Apache 2.4.7

  *) SECURITY: CVE-2013-4352 (cve.mitre.org)
     mod_cache: Fix a NULL pointer deference which allowed untrusted
     origin servers to crash mod_cache in a forward proxy
     configuration.  [Graham Leggett]

  *) APR 1.5.0 or later is now required for the event MPM.
 
  *) slotmem_shm: Error detection. [Jim Jagielski]

  *) event: Use skiplist data structure. [Jim Jagielski]

  *) event: Fail at startup with message AP02405 if the APR atomic
     implementation is not compatible with the MPM.  [Jim Jagielski]

  *) mpm_unix: Add ap_mpm_podx_* implementation to avoid code duplication
     and align w/ trunk. [Jim Jagielski]

  *) Fix potential rejection of valid MaxMemFree and ThreadStackSize
     directives.  [Mike Rumph <mike.rumph oracle.com>]

  *) mod_proxy_fcgi: Remove 64K limit on encoded length of all envvars.
     An individual envvar with an encoded length of more than 16K will be
     omitted.  [Jeff Trawick]
 
  *) mod_proxy_fcgi: Handle reading protocol data that is split between
     packets.  [Jeff Trawick]

  *) mod_ssl: Improve handling of ephemeral DH and ECDH keys by
     allowing custom parameters to be configured via SSLCertificateFile,
     and by adding standardized DH parameters for 1024/2048/3072/4096 bits.
     Unless custom parameters are configured, the standardized parameters
     are applied based on the certificate's RSA/DSA key size. [Kaspar Brand]

  *) mod_ssl, configure: Require OpenSSL 0.9.8a or later. [Kaspar Brand]

  *) mod_ssl: drop support for export-grade ciphers with ephemeral RSA
     keys, and unconditionally disable aNULL, eNULL and EXP ciphers
     (not overridable via SSLCipherSuite). [Kaspar Brand]

  *) mod_proxy: Added support for unix domain sockets as the
     backend server endpoint [Jim Jagielski, Blaise Tarr
     <blaise tarr gmail com>]

  *) Add experimental cmake-based build system for Windows.  [Jeff Trawick,
     Tom Donovan]

  *) event MPM: Fix possible crashes (third party modules accessing c->sbh)
     or occasional missed mod_status updates for some keepalive requests
     under load. [Eric Covener]

  *) mod_authn_socache: Support optional initialization arguments for
     socache providers.  [Chris Darroch]

  *) mod_session: Reset the max-age on session save. PR 47476. [Alexey
     Varlamov <alexey.v.varlamov gmail com>]

  *) mod_session: After parsing the value of the header specified by the
     SessionHeader directive, remove the value from the response. PR 55279.
     [Graham Leggett]

  *) mod_headers: Allow for format specifiers in the substitution string
     when using Header edit. [Daniel Ruggeri]

  *) mod_dav: dav_resource->uri is treated as unencoded. This was an
     unnecessary ABI changed introduced in 2.4.6. PR 55397.

  *) mod_dav: Don't require lock tokens for COPY source. PR 55306.

  *) core: Don't truncate output when sending is interrupted by a signal,
     such as from an exiting CGI process. PR 55643. [Jeff Trawick]

  *) WinNT MPM: Exit the child if the parent process crashes or is terminated.
     [Oracle Corporation]

  *) Windows: Correct failure to discard stderr in some error log
     configurations.  (Error message AH00093)  [Jeff Trawick]

  *) mod_session_crypto: Allow using exec: calls to obtain session
     encryption key.  [Daniel Ruggeri]

  *) core: Add missing Reason-Phrase in HTTP response headers.
     PR 54946. [Rainer Jung]

  *) mod_rewrite: Make rewrite websocket-aware to allow proxying.
     PR 55598. [Chris Harris <chris.harris kitware com>]

  *) mod_ldap: When looking up sub-groups, use an implicit objectClass=*
     instead of an explicit cn=* filter. [David Hawes <dhawes vt.edu>]

  *) ab: Add wait time, fix processing time, and output write errors only if
     they occurred. [Christophe Jaillet]

  *) worker MPM: Don't forcibly kill worker threads if the child process is
     exiting gracefully.  [Oracle Corporation]

  *) core: apachectl -S prints wildcard name-based virtual hosts twice.
     PR54948 [Eric Covener]

  *) mod_auth_basic: Add AuthBasicUseDigestAlgorithm directive to
     allow migration of passwords from digest to basic authentication.
     [Chris Darroch]

  *) ab: Add a new -l parameter in order not to check the length of the responses.
     This can be useful with dynamic pages.
     PR9945, PR27888, PR42040 [<ccikrs1 cranbrook edu>]
    
  *) Suppress formatting of startup messages written to the console when
     ErrorLogFormat is used.  [Jeff Trawick]

  *) mod_auth_digest: Be more specific when the realm mismatches because the
     realm has not been specified. [Graham Leggett]

  *) mod_proxy: Add a note in the balancer manager stating whether changes
     will or will not be persisted and whether settings are inherited.
     [Daniel Ruggeri, Jim Jagielski]

  *) core: Add util_fcgi.h and associated definitions and support
     routines for FastCGI, based largely on mod_proxy_fcgi.
     [Jeff Trawick]

  *) mod_headers: Add 'Header note header-name note-name' for copying a response
     headers value into a note. [Eric Covener]

  *) mod_headers: Add 'setifempty' command to Header and RequestHeader.
     [Eric Covener]

  *) mod_logio: new format-specifier %S (sum) which is the sum of received
     and sent byte counts.
     PR54015 [Christophe Jaillet]

  *) mod_deflate: Improve error detection when decompressing request bodies
     with trailing garbage: handle case where trailing bytes are in
     the same bucket. [Rainer Jung]

  *) mod_authz_groupfile, mod_authz_user: Reduce severity of AH01671 and AH01663
     from ERROR to DEBUG, since these modules do not know what mod_authz_core
     is doing with their AUTHZ_DENIED return value. [Eric Covener]

  *) mod_ldap: add TRACE5 for LDAP retries. [Eric Covener]

  *) mod_ldap: retry on an LDAP timeout during authn. [Eric Covener]

  *) mod_ldap: Change "LDAPReferrals off" to actually set the underlying LDAP
     SDK option to OFF, and introduce "LDAPReferrals default" to take the SDK
     default, sans rebind authentication callback.
     [Jan Kaluza <kaluze AT redhat.com>]

  *) core: Log a message at TRACE1 when the client aborts a connection.
     [Eric Covener]

  *) WinNT MPM: Don't crash during child process initialization if the
     Listen protocol is unrecognized.  [Jeff Trawick]

  *) modules: Fix some compiler warnings. [Guenter Knauf]

  *) Sync 2.4 and trunk
       - Avoid some memory allocation and work when TRACE1 is not activated
       - fix typo in include guard
       - indent
       - No need to lower the string before removing the path, it is just
         a waste of time...
       - Save a few cycles
     [Christophe Jaillet <christophe.jaillet wanadoo.fr>]

  *) mod_filter: Add "change=no" as a proto-flag to FilterProtocol
     to remove a providers initial flags set at registration time.
     [Eric Covener]

  *) core, mod_ssl: Enable the ability for a module to reverse the sense of
     a poll event from a read to a write or vice versa. This is a step on
     the way to allow mod_ssl taking full advantage of the event MPM.
     [Graham Leggett]

  *) Makefile.win: Install proper pcre DLL file during debug build install.
     PR 55235.  [Ben Reser <ben reser org>]

  *) mod_ldap: Fix a potential memory leak or corruption.  PR 54936.
     [Zhenbo Xu <zhenbo1987 gmail com>]

  *) ab: Fix potential buffer overflows when processing the T and X
     command-line options.  PR 55360.
     [Mike Rumph <mike.rumph oracle.com>]

  *) fcgistarter: Specify SO_REUSEADDR to allow starting a server
     with old connections in TIME_WAIT.  [Jeff Trawick]

  *) core: Add open_htaccess hook which, in conjunction with dirwalk_stat
     and post_perdir_config (introduced in 2.4.5), allows mpm-itk to be
     used without patches to httpd core. [Stefan Fritsch]

  *) support/htdbm: fix processing of -t command line switch. Regression
     introduced in 2.4.4
     PR 55264 [Jo Rhett <jrhett netconsonance com>]

  *) mod_lua: add websocket support via r:wsupgrade, r:wswrite, r:wsread
     and r:wsping. [Daniel Gruno]

  *) mod_lua: add support for writing/reading cookies via r:getcookie and
     r:setcookie. [Daniel Gruno]

  *) mod_lua: If the first yield() of a LuaOutputFilter returns a string, it should
     be prefixed to the response as documented. [Eric Covener]
     Note: Not present in 2.4.7 CHANGES

  *) mod_lua: Remove ETAG, Content-Length, and Content-MD5 when a LuaOutputFilter
     is configured without mod_filter. [Eric Covener]
     Note: Not present in 2.4.7 CHANGES

  *) mod_lua: Register LuaOutputFilter scripts as changing the content and
     content-length by default, when run my mod_filter.  Previously,
     growing or shrinking a response that started with Content-Length set
     would require mod_filter and FilterProtocol change=yes. [Eric Covener]
     Note: Not present in 2.4.7 CHANGES

  *) mod_lua: Return a 500 error if a LuaHook* script doesn't return a
     numeric return code. [Eric Covener]
     Note: Not present in 2.4.7 CHANGES

Changes with Apache 2.4.6

  *) Revert a broken fix for PR54948 that was applied to 2.4.5 (which was
     not released) and found post-2.4.5 tagging.

Changes with Apache 2.4.5

  *) SECURITY: CVE-2013-1896 (cve.mitre.org)
     mod_dav: Sending a MERGE request against a URI handled by mod_dav_svn with
     the source href (sent as part of the request body as XML) pointing to a
     URI that is not configured for DAV will trigger a segfault. [Ben Reser
     <ben reser.org>]

  *) SECURITY: CVE-2013-2249 (cve.mitre.org)
     mod_session_dbd: Make sure that dirty flag is respected when saving
     sessions, and ensure the session ID is changed each time the session
     changes. This changes the format of the updatesession SQL statement.
     Existing configurations must be changed.
     [Takashi Sato, Graham Leggett]

  *) mod_auth_basic: Add a generic mechanism to fake basic authentication
     using the ap_expr parser. AuthBasicFake allows the administrator to
     construct their own username and password for basic authentication based
     on their needs. [Graham Leggett]

  *) mpm_event: Check that AsyncRequestWorkerFactor is not negative. PR 54254.
     [Jackie Zhang <jackie qq zhang gmail com>]

  *) mod_proxy: Ensure we don't attempt to amend a table we are iterating
     through, ensuring that all headers listed by Connection are removed.
     [Graham Leggett, Co-Advisor <coad measurement-factory.com>]

  *) mod_proxy_http: Make the proxy-interim-response environment variable
     effective by formally overriding origin server behaviour. [Graham
     Leggett, Co-Advisor <coad measurement-factory.com>]

  *) mod_proxy: Fix seg-faults when using the global pool on threaded
     MPMs [Thomas Eckert <thomas.r.w.eckert gmail.com>, Graham Leggett,
     Jim Jagielski]

  *) mod_deflate: Remove assumptions as to when an EOS bucket might arrive.
     Gracefully step aside if the body size is zero. [Graham Leggett]

  *) mod_ssl: Fix possible truncation of OCSP responses when reading from the
     server.  [Joe Orton]

  *) core: Support the SINGLE_LISTEN_UNSERIALIZED_ACCEPT optimization
     on Linux kernel versions 3.x and above.  PR 55121.  [Bradley Heilbrun
     <apache heilbrun.org>]

  *) mod_cache_socache: Make sure the CacheSocacheMaxSize directive is merged
     correctly. [Jens Laas <jelaas gmail.com>]

  *) rotatelogs: add -n number-of-files option to rotate through a number
     of fixed-name logfiles. [Eric Covener]

  *) mod_proxy: Support web-socket tunnels via mod_proxy_wstunnel.
     [Jim Jagielski]

  *) mod_cache_socache: Use the name of the socache implementation when performing
     a lookup rather than using the raw arguments. [Martin Ksellmann
     <martin@ksellmann.de>]

  *) core: Add dirwalk_stat hook.  [Jeff Trawick]

  *) core: Add post_perdir_config hook.
     [Steinar Gunderson <sgunderson bigfoot.com>]

  *) proxy_util: NULL terminate the right buffer in 'send_http_connect'.
     [Christophe Jaillet]

  *) mod_remoteip: close file in error path. [Christophe Jaillet]

  *) core: make the "default" parameter of the "ErrorDocument" option case
     insensitive. PR 54419 [Tianyin Xu <tixu cs ucsd edu>]

  *) mod_proxy_html: make the "ProxyHTMLFixups" options case insensitive.
     PR 54420 [Tianyin Xu <tixu cs ucsd edu>]

  *) mod_cache: Make option "CacheDisable" in mod_cache case insensitive.
     PR 54462 [Tianyin Xu <tixu cs ucsd edu>]

  *) mod_cache: If a 304 response indicates an entity not currently cached, then
     the cache MUST disregard the response and repeat the request without the
     conditional. [Graham Leggett, Co-Advisor <coad measurement-factory.com>]

  *) mod_cache: Ensure that we don't attempt to replace a cached response
     with an older response as per RFC2616 13.12. [Graham Leggett, Co-Advisor
     <coad measurement-factory.com>]

  *) core, mod_cache: Ensure RFC2616 compliance in ap_meets_conditions()
     with weak validation combined with If-Range and Range headers. Break
     out explicit conditional header checks to be useable elsewhere in the
     server. Ensure weak validation RFC compliance in the byteranges filter.
     Ensure RFC validation compliance when serving cached entities. PR 16142
     [Graham Leggett, Co-Advisor <coad measurement-factory.com>]

  *) core: Add the ability to do explicit matching on weak and strong ETags
     as per RFC2616 Section 13.3.3. [Graham Leggett, Co-Advisor
     <coad measurement-factory.com>]

  *) mod_cache: Ensure that updated responses to HEAD requests don't get
     mistakenly paired with a previously cached body. Ensure that any existing
     body is removed when a HEAD request is cached. [Graham Leggett,
     Co-Advisor <coad measurement-factory.com>]

  *) mod_cache: Honour Cache-Control: no-store in a request. [Graham Leggett]

  *) mod_cache: Make sure that contradictory entity headers present in a 304
     Not Modified response are caught and cause the entity to be removed.
     [Graham Leggett]

  *) mod_cache: Make sure Vary processing handles multivalued Vary headers and
     multivalued headers referred to via Vary. [Graham Leggett]

  *) mod_cache: When serving from cache, only the last header of a multivalued
     header was taken into account. Fixed. Ensure that Warning headers are
     correctly handled as per RFC2616. [Graham Leggett]

  *) mod_cache: Ignore response headers specified by no-cache=header and
     private=header as specified by RFC2616 14.9.1 What is Cacheable. Ensure
     that these headers are still processed when multiple Cache-Control
     headers are present in the response. PR 54706 [Graham Leggett,
     Yann Ylavic <ylavic.dev gmail.com>]

  *) mod_cache: Invalidate cached entities in response to RFC2616 Section
     13.10 Invalidation After Updates or Deletions. PR 15868 [Graham
     Leggett]

  *) mod_dav: Improve error handling in dav_method_put(), add new
     dav_join_error() function.  PR 54145.  [Ben Reser <ben reser.org>]

  *) mod_dav: Do not fail PROPPATCH when prop namespace is not known.
     PR 52559 [Diego Santa Cruz <diego.santaCruz spinetix.com>]

  *) mod_dav: When a PROPPATCH attempts to remove a non-existent dead
     property on a resource for which there is no dead property in the same
     namespace httpd segfaults. PR 52559 [Diego Santa Cruz
     <diego.santaCruz spinetix.com>]

  *) mod_dav: Sending an If or If-Match header with an invalid ETag doesn't
     result in a 412 Precondition Failed for a COPY operation. PR54610
     [Timothy Wood <tjw omnigroup.com>]

  *) mod_dav: Make sure that when we prepare an If URL for Etag comparison,
     we compare unencoded paths. PR 53910 [Timothy Wood <tjw omnigroup.com>]

  *) mod_deflate: Remove assumptions as to when an EOS bucket might arrive.
     Gracefully step aside if the body size is zero. [Graham Leggett]

  *) 'AuthGroupFile' and 'AuthUserFile' do not accept anymore the optional
     'standard' keyword . It was unused and not documented.
     PR54463 [Tianyin Xu <tixu cs.ucsd.edu> and Christophe Jaillet]

  *) core: Do not over allocate memory within 'ap_rgetline_core' for
     the common case. [Christophe Jaillet]

  *) core: speed up (for common cases) and reduce memory usage of
     ap_escape_logitem(). This should save 70-100 bytes in the request
     pool for a default config. [Christophe Jaillet]

  *) mod_dav: Ensure URI is correctly uriencoded on return. PR 54611
     [Timothy Wood <tjw omnigroup.com>]

  *) mod_proxy: Reject invalid values for Max-Forwards. [Graham Leggett,
     Co-Advisor <coad measurement-factory.com>]

  *) mod_cache: RFC2616 14.9.3 The s-maxage directive also implies the
     semantics of the proxy-revalidate directive. [Graham Leggett]

  *) mod_ssl: add support for subjectAltName-based host name checking
     in proxy mode (SSLProxyCheckPeerName). PR 54030. [Kaspar Brand]

  *) core: Use the proper macro for HTTP/1.1. [Graham Leggett]

  *) event MPM: Provide error handling for ThreadStackSize. PR 54311
     [Tianyin Xu <tixu cs.ucsd.edu>, Christophe Jaillet]

  *) mod_dav: Do not segfault on PROPFIND with a zero length DBM.
     PR 52559 [Diego Santa Cruz <diego.santaCruz spinetix.com>]

  *) core: Improve error message where client's request-line exceeds
     LimitRequestLine. PR 54384 [Christophe Jaillet]

  *) mod_macro: New module that provides macros within configuration files.
     [Fabien Coelho]

  *) mod_cache_socache: New cache implementation backed by mod_socache
     that replaces mod_mem_cache known from httpd 2.2. [Graham
     Leggett]

  *) htpasswd: Add -v option to verify a password. [Stefan Fritsch]

  *) mod_proxy: Add BalancerInherit and ProxyPassInherit to control
     whether Proxy Balancers and Workers are inherited by vhosts
     (default is On). [Jim Jagielski]

  *) mod_authnz_ldap: Allow using exec: calls to obtain LDAP bind
     password.  [Daniel Ruggeri]

  *) Added balancer parameter failontimeout to allow server admin
     to configure an IO timeout as an error in the balancer.
     [Daniel Ruggeri]

  *) mod_auth_digest: Fix crashes if shm initialization failed. [Stefan
     Fritsch]

  *) htpasswd, htdbm: Fix password generation. PR 54735. [Stefan Fritsch]

  *) core: Add workaround for gcc bug on sparc/64bit. PR 52900.
     [Stefan Fritsch]

  *) mod_setenvif: Fix crash in case SetEnvif and SetEnvIfExpr are used
     together. PR 54881. [Ruediger Pluem]

  *) htdigest: Fix buffer overflow when reading digest password file
     with very long lines. PR 54893. [Rainer Jung]

  *) ap_expr: Add the ability to base64 encode and base64 decode
     strings and to generate their SHA1 and MD5 hash.
     [Graham Leggett, Stefan Fritsch]

  *) mod_log_config: Fix crash when logging request end time for a failed
     request.  PR 54828 [Rainer Jung]

  *) mod_ssl: Catch missing, mismatched or encrypted client cert/key pairs
     with SSLProxyMachineCertificateFile/Path directives. PR 52212, PR 54698.
     [Keith Burdis <keith burdis.org>, Joe Orton, Kaspar Brand]

  *) mod_ssl: Quiet FIPS mode weak keys disabled and FIPS not selected emits
     in the error log to debug level.  [William Rowe]

  *) mod_cache_disk: CacheMinFileSize and CacheMaxFileSize were always
     using compiled in defaults of 1000000/1 respectively. [Eric Covener]

  *) mod_lbmethod_heartbeat, mod_heartmonitor: Respect DefaultRuntimeDir/
     DEFAULT_REL_RUNTIMEDIR for the heartbeat storage file.  [Jeff Trawick]

  *) mod_include: Use new ap_expr for 'elif', like 'if',
     if legacy parser is not specified.  PR 54548 [Tom Donovan]

  *) mod_lua: Add some new functions: r:htpassword(), r:mkdir(), r:mkrdir(),
     r:rmdir(), r:touch(), r:get_direntries(), r.date_parse_rfc().
     [Guenter Knauf]

  *) mod_lua: Add multipart form data handling. [Daniel Gruno]

  *) mod_lua: If a LuaMapHandler doesn't return any value, log a warning
     and treat it as apache2.OK. [Eric Covener]

  *) mod_lua: Add bindings for apr_dbd/mod_dbd database access
     [Daniel Gruno]

  *) mod_lua: Add LuaInputFilter/LuaOutputFilter for creating content
     filters in Lua [Daniel Gruno]

  *) mod_lua: Allow scripts handled by the lua-script handler to return
     a status code to the client (such as a 302 or a 500) [Daniel Gruno]

  *) mod_lua: Decline handling 'lua-script' if the file doesn't exist,
     rather than throwing an internal server error. [Daniel Gruno]

  *) mod_lua: Add functions r:flush and r:sendfile as well as additional
     request information to the request_rec structure. [Daniel Gruno]

  *) mod_lua: Add a server scope for Lua states, which creates a pool of
     states with manageable minimum and maximum size. [Daniel Gruno]

  *) mod_lua: Add new directive, LuaMapHandler, for dynamically mapping
     URIs to Lua scripts and functions using regular expressions.
     [Daniel Gruno]

  *) mod_lua: Add new directive LuaCodeCache for controlling in-memory
     caching of lua scripts. [Daniel Gruno]

Changes with Apache 2.4.4

  *) SECURITY: CVE-2012-3499 (cve.mitre.org)
     Various XSS flaws due to unescaped hostnames and URIs HTML output in
     mod_info, mod_status, mod_imagemap, mod_ldap, and mod_proxy_ftp.
     [Jim Jagielski, Stefan Fritsch, Niels Heinen <heinenn google com>]

  *) SECURITY: CVE-2012-4558 (cve.mitre.org)
     XSS in mod_proxy_balancer manager interface. [Jim Jagielski,
     Niels Heinen <heinenn google com>]

  *) mod_dir: Add support for the value 'disabled' in FallbackResource.
     [Vincent Deffontaines]

  *) mod_proxy_connect: Don't keepalive the connection to the client if the
     backend closes the connection. PR 54474. [Pavel Mateja <pavel netsafe cz>]

  *) mod_lua: Add bindings for mod_dbd/apr_dbd database access.
     [Daniel Gruno]

  *) mod_proxy: Allow for persistence of local changes made via the
     balancer-manager between graceful/normal restarts and power
     cycles. [Jim Jagielski]

  *) mod_proxy: Fix startup crash with mis-defined balancers.
     PR 52402. [Jim Jagielski]

  *) --with-module: Fix failure to integrate them into some existing
     module directories.  PR 40097.  [Jeff Trawick]

  *) htcacheclean: Fix potential segfault if "-p" is omitted.  [Joe Orton]

  *) mod_proxy_http: Honour special value 0 (unlimited) of LimitRequestBody
     PR 54435.  [Pavel Mateja <pavel netsafe.cz>]

  *) mod_proxy_ajp: Support unknown HTTP methods. PR 54416.
     [Rainer Jung]

  *) htcacheclean: Fix list options "-a" and "-A".
     [Rainer Jung]

  *) mod_slotmem_shm: Fix mistaken reset of num_free for restored shm.
     [Jim Jagielski]

  *) mod_proxy: non-existence of byrequests is not an immediate error.
     [Jim Jagielski]

  *) mod_proxy_balancer: Improve output of balancer-manager (re: Drn,
     Dis, Ign, Stby). PR 52478 [Danijel <dt-ng rbfh de>]
 
  *) configure: Fix processing of --disable-FEATURE for various features.
     [Jeff Trawick]

  *) mod_dialup/mod_http: Prevent a crash in mod_dialup in case of internal
     redirect. PR 52230.

  *) various modules, rotatelogs: Replace use of apr_file_write() with
     apr_file_write_full() to prevent incomplete writes. PR 53131.
     [Nicolas Viennot <apache viennot biz>, Stefan Fritsch]

  *) ab: Support socket timeout (-s timeout).
     [Guido Serra <zeph fsfe org>]

  *) httxt2dbm: Correct length computation for the 'value' stored in the
     DBM file. PR 47650 [jon buckybox com]

  *) core: Be more correct about rejecting directives that cannot work in <If>
     sections. [Stefan Fritsch]

  *) core: Fix directives like LogLevel that need to know if they are invoked
     at virtual host context or in Directory/Files/Location/If sections to
     work properly in If sections that are not in a Directory/Files/Location.
     [Stefan Fritsch]

  *) mod_xml2enc: Fix problems with charset conversion altering the
     Content-Length. [Micha Lenk <micha lenk info>]

  *) ap_expr: Add req_novary function that allows HTTP header lookups
     without adding the name to the Vary header. [Stefan Fritsch]

  *) mod_slotmem_*: Add in new fgrab() function which forces a grab and
     slot allocation on a specified slot. Allow for clearing of inuse
     array. [Jim Jagielski]

  *) mod_proxy_ftp: Fix segfaults on IPv4 requests to hosts with DNS
     AAAA records. PR  40841. [Andrew Rucker Jones <arjones simultan
     dyndns org>, <ast domdv de>, Jim Jagielski]

  *) mod_auth_form: Make sure that get_notes_auth() sets the user as does
     get_form_auth() and get_session_auth(). Makes sure that REMOTE_USER
     does not vanish during mod_include driven subrequests. [Graham
     Leggett]

  *) mod_cache_disk: Resolve errors while revalidating disk-cached files on
     Windows ("...rename tempfile to datafile failed..."). PR 38827
     [Eric Covener]

  *) mod_proxy_balancer: Bring XML output up to date. [Jim Jagielski]

  *) htpasswd, htdbm: Optionally read passwords from stdin, as more
     secure alternative to -b.  PR 40243. [Adomas Paltanavicius <adomas
     paltanavicius gmail com>, Stefan Fritsch]

  *) htpasswd, htdbm: Add support for bcrypt algorithm (requires
     apr-util 1.5 or higher). PR 49288. [Stefan Fritsch]

  *) htpasswd, htdbm: Put full 48bit of entropy into salt, improve
     error handling. Add some of htpasswd's improvements to htdbm,
     e.g. warn if password is truncated by crypt(). [Stefan Fritsch]

  *) mod_auth_form: Support the expr parser in the
     AuthFormLoginRequiredLocation, AuthFormLoginSuccessLocation and
     AuthFormLogoutLocation directives. [Graham Leggett]

  *) mod_ssl: Add support for TLS-SRP (Secure Remote Password key exchange
     for TLS, RFC 5054). PR 51075. [Quinn Slack <sqs cs stanford edu>,
     Christophe Renou, Peter Sylvester]

  *) mod_rewrite: Stop mergeing RewriteBase down to subdirectories
     unless new option 'RewriteOptions MergeBase' is configured.
     PR 53963. [Eric Covener]

  *) mod_header: Allow for exposure of loadavg and server load using new
     format specifiers %l, %i, %b [Jim Jagielski]
 
  *) core: Make ap_regcomp() return AP_REG_ESPACE if out of memory.  Make
     ap_pregcomp() abort if out of memory. This raises the minimum PCRE
     requirement to version 6.0. [Stefan Fritsch]

  *) mod_proxy: Add ability to configure the sticky session separator.
     PR 53893. [<inu inusasha de>, Jim Jagielski]

  *) mod_dumpio: Correctly log large messages
     PR 54179 [Marek Wianecki <mieszek2 interia pl>]

  *) core: Don't fail at startup with AH00554 when Include points to
     a directory without any wildcard character. [Eric Covener]

  *) core: Fail startup if the argument to ServerTokens is unrecognized.
     [Jackie Zhang  <jackie.qq.zhang gmail.com>]

  *) mod_log_forensic: Don't log a spurious "-" if a request has been rejected
     before mod_log_forensic could attach its id to it. [Stefan Fritsch]

  *) rotatelogs: Omit the second argument for the first invocation of
     a post-rotate program when -p is used, per the documentation.
     [Joe Orton]

  *) mod_session_dbd: fix a segmentation fault in the function dbd_remove.
     PR 53452. [<rebanerebane gmail com>, Reimo Rebane]

  *) core: Functions to provide server load values: ap_get_sload() and
     ap_get_loadavg(). [Jim Jagielski, Jan Kaluza <jkaluza redhat.com>,
     Jeff Trawick]

  *) mod_ldap: Fix regression in handling "server unavailable" errors on
     Windows.  PR 54140.  [Eric Covener]

  *) syslog logging: Remove stray ", referer" at the end of some messages.
     [Jeff Trawick]

  *) "Iterate" directives: Report an error if no arguments are provided.
     [Jeff Trawick]

  *) mod_ssl: Change default for SSLCompression to off, as compression
     causes security issues in most setups. (The so called "CRIME" attack).
     [Stefan Fritsch]

  *) ab: add TLS1.1/TLS1.2 options to -f switch, and adapt output
     to more accurately report the negotiated protocol. PR 53916.
     [Nicolas Pernas Maradei <nico emutex com>, Kaspar Brand]

  *) core: ErrorDocument now works for requests without a Host header.
     PR 48357.  [Jeff Trawick]

  *) prefork: Avoid logging harmless errors during graceful stop.
     [Joe Orton, Jeff Trawick]

  *) mod_proxy: When concatting for PPR, avoid cases where we
     concat ".../" and "/..." to create "...//..." [Jim Jagielski]

  *) mod_cache: Wrong content type and character set when
     mod_cache serves stale content because of a proxy error.
     PR 53539.  [Rainer Jung, Ruediger Pluem]

  *) mod_proxy_ajp: Fix crash in packet dump code when logging
     with LogLevel trace7 or trace8.  PR 53730.  [Rainer Jung]

  *) httpd.conf: Removed the configuration directives setting a bad_DNT
     environment introduced in 2.4.3. The actual directives are commented
     out in the default conf file.

  *) core: Apply length limit when logging Status header values.
     [Jeff Trawick, Chris Darroch]

  *) mod_proxy_balancer: The nonce is only derived from the UUID iff
     not set via the 'nonce' balancer param. [Jim Jagielski]

  *) mod_ssl: Match wildcard SSL certificate names in proxy mode. 
     PR 53006.  [Joe Orton]

  *) Windows: Fix output of -M, -L, and similar command-line options
     which display information about the server configuration.
     [Jeff Trawick]

Changes with Apache 2.4.3

  *) SECURITY: CVE-2012-3502  (cve.mitre.org)
     mod_proxy_ajp, mod_proxy_http: Fix an issue in back end
     connection closing which could lead to privacy issues due
     to a response mixup. PR 53727. [Rainer Jung]

  *) SECURITY: CVE-2012-2687 (cve.mitre.org)
     mod_negotiation: Escape filenames in variant list to prevent a
     possible XSS for a site where untrusted users can upload files to
     a location with MultiViews enabled. [Niels Heinen <heinenn google.com>]

  *) mod_authnz_ldap: Don't try a potentially expensive nested groups
     search before exhausting all AuthLDAPGroupAttribute checks on the
     current group. PR 52464 [Eric Covener]

  *) mod_lua: Add new directive LuaAuthzProvider to allow implementing an
     authorization provider in lua. [Stefan Fritsch]

  *) core: Be less strict when checking whether Content-Type is set to
     "application/x-www-form-urlencoded" when parsing POST data,
     or we risk losing data with an appended charset. PR 53698
     [Petter Berntsen <petterb gmail.com>]

  *) httpd.conf: Added configuration directives to set a bad_DNT environment
     variable based on User-Agent and to remove the DNT header field from
     incoming requests when a match occurs. This currently has the effect of
     removing DNT from requests by MSIE 10.0 because it deliberately violates
     the current specification of DNT semantics for HTTP. [Roy T. Fielding]

  *) mod_socache_shmcb: Fix bus error due to a misalignment
     in some 32 bit builds, especially on Solaris Sparc.
     PR 53040.  [Rainer Jung]

  *) mod_cache: Set content type in case we return stale content.
     [Ruediger Pluem]

  *) Windows: Fix SSL failures on windows with AcceptFilter https none.
     PR 52476.  [Jeff Trawick]

  *) ab: Fix read failure when targeting SSL server.  [Jeff Trawick]

  *) The following now respect DefaultRuntimeDir/DEFAULT_REL_RUNTIMEDIR:
     - mod_auth_digest: shared memory file
     [Jeff Trawick]

  *) htpasswd: Use correct file mode for checking if file is writable.
     PR 45923. [Stefan Fritsch]

  *) mod_rewrite: Fix crash with dbd RewriteMaps. PR 53663. [Mikhail T.
     <mi apache aldan algebra com>]

  *) mod_ssl: Add new directive SSLCompression to disable TLS-level
     compression. PR 53219. [Bjorn Jacke <bjoern j3e de>, Stefan Fritsch]

  *) mod_lua: Add a few missing request_rec fields. Rename remote_ip to
     client_ip to match conn_rec. [Stefan Fritsch]

  *) mod_lua: Change prototype of vm_construct, to work around gcc bug which
     causes a segfault. PR 52779. [Dick Snippe <Dick Snippe tech omroep nl>]

  *) mpm_event: Don't count connections in lingering close state when
     calculating how many additional connections may be accepted.
     [Stefan Fritsch]

  *) mod_ssl: If exiting during initialization because of a fatal error,
     log a message to the main error log pointing to the appropriate
     virtual host error log. [Stefan Fritsch]

  *) mod_proxy_ajp: Reduce memory usage in case of many keep-alive requests on
     one connection. PR 52275. [Naohiro Ooiwa <naohiro ooiwa miraclelinux com>]

  *) mod_proxy_balancer: Restore balancing after a failed worker has
     recovered when using lbmethod_bybusyness.  PR 48735.  [Jeff Trawick]

  *) mod_setenvif: Compile some global regex only once during startup.
     This should save some memory, especially with .htaccess.
     [Stefan Fritsch]

  *) core: Add the port number to the vhost's name in the scoreboard.
     [Stefan Fritsch]

  *) mod_proxy: Fix ProxyPassReverse for balancer configurations.
     PR 45434.  [Joe Orton]

  *) mod_lua: Add the parsebody function for parsing POST data. PR 53064.
     [Daniel Gruno]

  *) apxs: Use LDFLAGS from config_vars.mk in addition to CFLAGS and CPPFLAGS.
     [Stefan Fritsch]

  *) mod_proxy: Fix memory leak or possible corruption in ProxyBlock
     implementation.  [Ruediger Pluem, Joe Orton]

  *) mod_proxy: Check hostname from request URI against ProxyBlock list,
     not forward proxy, if ProxyRemote* is configured.  [Joe Orton]

  *) mod_proxy_connect: Avoid DNS lookup on hostname from request URI
     if ProxyRemote* is configured.  PR 43697.  [Joe Orton]

  *) mpm_event, mpm_worker: Remain active amidst prevalent child process
     resource shortages.  [Jeff Trawick]

  *) Add "strict" and "warnings" pragmas to Perl scripts.  [Rich Bowen]

  *) The following now respect DefaultRuntimeDir/DEFAULT_REL_RUNTIMEDIR:
     - core: the scoreboard (ScoreBoardFile), pid file (PidFile), and
       mutexes (Mutex)
     [Jim Jagielski]

  *) ab: Fix bind() errors.  [Joe Orton]

  *) mpm_event: Don't do a blocking write when starting a lingering close
     from the listener thread. PR 52229. [Stefan Fritsch]

  *) mod_so: If a filename without slashes is specified for LoadFile or
     LoadModule and the file cannot be found in the server root directory,
     try to use the standard dlopen() search path. [Stefan Fritsch]

  *) mpm_event, mpm_worker: Fix cases where the spawn rate wasn't reduced
     after child process resource shortages.  [Jeff Trawick]

  *) mpm_prefork: Reduce spawn rate after a child process exits due to
     unexpected poll or accept failure.  [Jeff Trawick]

  *) core: Log value of Status header line in script responses rather
     than the fixed header name.  [Chris Darroch]

  *) mod_ssl: Fix handling of empty response from OCSP server.
     [Jim Meyering <meyering redhat.com>, Joe Orton]

  *) mpm_event: Fix handling of MaxConnectionsPerChild. [Stefan Fritsch]

  *) mod_authz_core: If an expression in "Require expr" returns denied and
     references %{REMOTE_USER}, trigger authentication and retry. PR 52892.
     [Stefan Fritsch]

  *) core: Always log if LimitRequestFieldSize triggers.  [Stefan Fritsch]

  *) mod_deflate: Skip compression if compression is enabled at SSL level.
     [Stefan Fritsch]

  *) core: Add missing HTTP status codes registered with IANA.
     [Julian Reschke <julian.reschke gmx.de>, Rainer Jung]

  *) mod_ldap: Treat the "server unavailable" condition as a transient
     error with all LDAP SDKs.  [Filip Valder <filip.valder vsb.cz>]

  *) core: Fix spurious "not allowed here" error returned when the Options
     directive is used in .htaccess and "AllowOverride Options" (with no
     specific options restricted) is configured.  PR 53444. [Eric Covener]

  *) mod_authz_core: Fix parsing of Require arguments in <AuthzProviderAlias>.
     PR 53048. [Stefan Fritsch]

  *) mod_log_config: Fix %{abc}C truncating cookie values at first "=".
     PR 53104. [Greg Ames]

  *) mod_ext_filter: Fix error_log spam when input filters are configured. 
     [Joe Orton]

  *) mod_rewrite: Add "AllowAnyURI" option. PR 52774. [Joe Orton]

  *) htdbm, htpasswd: Don't crash if crypt() fails (e.g. with FIPS enabled).
     [Paul Wouters <pwouters redhat.com>, Joe Orton]

  *) core: Use a TLS 1.0 close_notify alert for internal dummy connection if
     the chosen listener is configured for https. [Joe Orton]

  *) mod_proxy: Use the the same hostname for SNI as for the HTTP request when
     forwarding to SSL backends. PR 53134.
     [Michael Weiser <michael weiser.dinsnail.net>, Ruediger Pluem]

  *) mod_info: Display all registered providers. [Stefan Fritsch]

  *) mod_ssl: Send the error message for speaking http to an https port using
     HTTP/1.0 instead of HTTP/0.9, and omit the link that may be wrong when
     using SNI. PR 50823. [Stefan Fritsch]

  *) core: Fix segfault in logging if r->useragent_addr or c->client_addr is
     unset. PR 53265. [Stefan Fritsch]

  *) log_server_status: Bring Perl style forward to the present, use
     standard modules, update for new format of server-status output.
     PR 45424. [Richard Bowen, Dave Brondsema, and others]

  *) mod_sed, mod_log_debug, mod_rewrite: Symbol namespace cleanups.
     [Joe Orton, Andre Malo]

  *) core: Prevent "httpd -k restart" from killing server in presence of
     config error. [Joe Orton]

  *) mod_proxy_fcgi: If there is an error reading the headers from the
     backend, send an error to the client. PR 52879. [Stefan Fritsch]

Changes with Apache 2.4.2

  *) SECURITY: CVE-2012-0883 (cve.mitre.org)
     envvars: Fix insecure handling of LD_LIBRARY_PATH that could lead to the
     current working directory to be searched for DSOs. [Stefan Fritsch]

  *) mod_slotmem_shm: Honor DefaultRuntimeDir [Jim Jagielski]

  *) mod_ssl: Fix crash with threaded MPMs due to race condition when
     initializing EC temporary keys. [Stefan Fritsch]

  *) mod_rewrite: Fix RewriteCond integer checks to be parsed correctly.
     PR 53023. [Axel Reinhold <apache freakout.de>, Andre Malo]

  *) mod_proxy: Add the forcerecovery balancer parameter that determines if
     recovery for balancer workers is enforced. [Ruediger Pluem]

  *) Fix MPM DSO load failure on AIX.  [Jeff Trawick]

  *) mod_proxy: Correctly set up reverse proxy worker. PR 52935.
     [Petter Berntsen <petterb gmail.com>]

  *) mod_sed: Don't define PATH_MAX to a potentially undefined value, causing
     compile problems on GNU hurd. [Stefan Fritsch]

  *) core: Add ap_runtime_dir_relative() and DefaultRuntimeDir.
     [Jeff Trawick]

  *) core: Fix breakage of Listen directives with MPMs that use a
     per-directory config. PR 52904. [Stefan Fritsch]

  *) core: Disallow directives in AllowOverrideList which are only allowed
     in VirtualHost or server context. These are usually not prepared to be
     called in .htaccess files. [Stefan Fritsch]

  *) core: In AllowOverrideList, do not allow 'None' together with other
     directives. PR 52823. [Stefan Fritsch]

  *) mod_slotmem_shm: Support DEFAULT_REL_RUNTIMEDIR for file-based shm.
     [Jim Jagielski]

  *) core: Fix merging of AllowOverrideList and ContentDigest.
     [Stefan Fritsch]

  *) mod_request: Fix validation of the KeptBodySize argument so it
     doesn't always throw a configuration error. PR 52981 [Eric Covener]

  *) core: Add filesystem paths to access denied / access failed messages
     AH00035 and AH00036. [Eric Covener]

  *) mod_dumpio: Properly handle errors from subsequent input filters.
     PR 52914. [Stefan Fritsch]

  *) Unix MPMs: Fix small memory leak in parent process if connect()
     failed when waking up children.  [Joe Orton]

  *) "DirectoryIndex disabled" now undoes DirectoryIndex settings in
     the current configuration section, not just previous config sections.
     PR 52845. [Eric Covener]

  *) mod_xml2enc: Fix broken handling of EOS buckets which could lead to
     response headers not being sent. PR 52766. [Stefan Fritsch]

  *) mod_ssl: Properly free the GENERAL_NAMEs. PR 32652. [Kaspar Brand]

  *) core: Check during config test that directories for the access
     logs actually exist. PR 29941. [Stefan Fritsch]

  *) mod_xml2enc, mod_proxy_html: Enable per-module loglevels.
     [Stefan Fritsch]

  *) mod_filter: Fix segfault with AddOutputFilterByType. PR 52755.
     [Stefan Fritsch]

  *) mod_session: Sessions are encoded as application/x-www-form-urlencoded
     strings, however we do not handle the encoding of spaces properly.
     Fixed. [Graham Leggett]

  *) Configuration: Example in comment should use a path consistent
     with the default configuration. PR 52715.
     [Rich Bowen, Jens Schleusener, Rainer Jung]

  *) Configuration: Switch documentation links from trunk to 2.4.
     [Rainer Jung]

  *) configure: Fix out of tree build using apr and apr-util in srclib.
     [Rainer Jung]

Changes with Apache 2.4.1

  *) SECURITY: CVE-2012-0053 (cve.mitre.org)
     Fix an issue in error responses that could expose "httpOnly" cookies
     when no custom ErrorDocument is specified for status code 400. 
     [Eric Covener]

  *) mod_proxy_balancer: Fix crash on Windows. PR 52402 [Mladen Turk]

  *) core: Check during configtest that the directories for error logs exist.
     PR 29941 [Stefan Fritsch]

  *) Core configuration: add AllowOverride option to treat syntax
     errors in .htaccess as non-fatal. PR 52439 [Nick Kew, Jim Jagielski]

  *) core: Fix memory consumption in core output filter with streaming
     bucket types like CGI or PIPE.  [Joe Orton, Stefan Fritsch]

  *) configure: Disable modules at configure time if a prerequisite module
     is not enabled. PR 52487. [Stefan Fritsch]

  *) Rewrite and proxy now decline what they don't support rather
     than fail the request. [Joe Orton]

  *) Fix building against external apr plus apr-util if apr is not installed
     in a system default path. [Rainer Jung]

  *) Doxygen fixes and improvements. [Joe Orton, Igor Galic]

  *) core: Fix building against PCRE 8.30 by switching from the obsolete
     pcre_info() to pcre_fullinfo(). PR 52623 [Ruediger Pluem, Rainer Jung]

Changes with Apache 2.4.0

  *) SECURITY: CVE-2012-0031 (cve.mitre.org)
     Fix scoreboard issue which could allow an unprivileged child process
     to cause the parent to crash at shutdown rather than terminate
     cleanly.  [Joe Orton]

  *) mod_ssl: Fix compilation with xlc on AIX. PR 52394. [Stefan Fritsch]

  *) SECURITY: CVE-2012-0021 (cve.mitre.org)
     mod_log_config: Fix segfault (crash) when the '%{cookiename}C' log format
     string is in use and a client sends a nameless, valueless cookie, causing
     a denial of service. The issue existed since version 2.2.17 and 2.3.3.
     PR 52256.  [Rainer Canavan <rainer-apache 7val com>]

  *) mod_ssl: when compiled against OpenSSL 1.0.1 or later, allow explicit
     control of TLSv1.1 and TLSv1.2 through the SSLProtocol directive.
     [Kaspar Brand]

  *) mod_ssl: set OPENSSL_NO_SSL_INTERN when compiling against OpenSSL 1.0.1
     or later, to improve binary compatibility with future OpenSSL releases.
     [Kaspar Brand]

  *) mod_mime: Don't arbitrarily bypass AddOutputFilter during a ProxyPass,
     but then allow AddOutputFilter during a RewriteRule [P]. Make mod_mime
     behave identically in both cases. PR52342. [Graham Leggett]

  *) Move ab, logresolve, httxt2dbm and apxs to bin from sbin, along with
     corresponding man pages. [Graham Leggett]

  *) Distinguish properly between the bindir and sbindir directories when
     installing binaries. Previously all binaries were silently installed to
     sbindir, whether they were system administration commands or not.
     [Graham Leggett]

Changes with Apache 2.3.16

  *) SECURITY: CVE-2011-4317 (cve.mitre.org)
     Resolve additional cases of URL rewriting with ProxyPassMatch or
     RewriteRule, where particular request-URIs could result in undesired
     backend network exposure in some configurations.
     [Joe Orton]

  *) core: Limit line length in .htaccess to 8K like in 2.2.x, to avoid
     additional DoS potential. [Stefan Fritsch]

  *) core, all modules: Add unique tag to most error log messages. [Stefan
     Fritsch]

  *) mod_socache_memcache: Change provider name from "mc" to "memcache" to
     match module name. [Stefan Fritsch]

  *) mod_slotmem_shm: Change provider name from "shared" to "shm" to match
     module name. [Stefan Fritsch]

  *) mod_ldap: Fix segfault with Solaris LDAP when enabling ldaps. This
     requires an apr-util fix in which is available in apr-util >= 1.4.0.
     PR 42682. [Stefan Fritsch]

  *) mod_rewrite: Add the AllowNoSlash RewriteOption, which makes it possible
     for RewriteRules to be placed in .htaccess files that match the directory
     with no trailing slash. PR 48304.
     [Matthew Byng-Maddick <matthew byng-maddick bbc.co.uk>]

  *) mod_session_crypto: Add a SessionCryptoPassphraseFile directive so that
     the administrator can hide the keys from the configuration. [Graham
     Leggett]

  *) Introduce a per request version of the remote IP address, which can be
     optionally modified by a module when the effective IP of the client
     is not the same as the real IP of the client (such as a load balancer).
     Introduce a per connection "peer_ip" and a per request "client_ip" to
     distinguish between the raw IP address of the connection and the effective
     IP address of the request. [Graham Leggett]

  *) ap_pass_brigade_fchk() function added. [Jim Jagielski]

  *) core: Pass ap_errorlog_info struct to error log hook. [Stefan Fritsch]

  *) mod_cache_disk: Make sure we check return codes on all writes and
     attempts to close, and clean up after ourselves in these cases.
     PR43589. [Graham Leggett]

  *) mod_cache_disk: Remove the unnecessary intermediate brigade while
     writing to disk. Fixes a problem where mod_disk_cache was leaving
     buckets in the intermediate brigade and not passing them to out on
     exit. [Florian S. <f_los_ch yahoo.com>, Graham Leggett]

  *) mod_ssl: use a shorter setting for SSLCipherSuite in the default
     default configuration file, and add some more information about
     configuring a speed-optimized alternative.
     [Kaspar Brand]

  *) mod_ssl: drop support for the SSLv2 protocol. [Kaspar Brand]

  *) mod_lua: Stop losing track of all but the most specific LuaHook* directives
     when multiple per-directory config sections are used.  Adds LuaInherit
     directive to control how parent sections are merged.  [Eric Covener]

  *) Server directive display (-L): Include directives of DSOs.
     [Jeff Trawick]

  *) mod_cache: Make sure we merge headers correctly when we handle a
     non cacheable conditional response. PR52120. [Graham Leggett]

  *) Pre GA removal of components that will not be included:
     - mod_noloris was superseded by mod_reqtimeout
     - mod_serf
     - mpm_simple
     [Rainer Jung]

  *) core: Set MaxMemFree 2048 by default. [Stefan Fritsch]

  *) mpm_event: Fix assertion failure during very high load. [Stefan Fritsch]

  *) configure: Additional modules loaded by default: mod_headers.
     Modules moved from module set "few" to "most" and no longer loaded
     by default: mod_actions, mod_allowmethods, mod_auth_form, mod_buffer,
     mod_cgi(d), mod_include, mod_negotiation, mod_ratelimit, mod_request,
     mod_userdir. [Rainer Jung]

  *) mod_lua: Use the right lua scope when used as a hook. [Rainer Jung]

  *) configure: Only load the really imporant modules (i.e. those enabled by
     the 'few' selection) by default. Don't handle modules enabled with
     --enable-foo specially. [Stefan Fritsch]

  *) end-generation hook: Fix false notification of end-of-generation for
     temporary intervals with no active MPM children.  [Jeff Trawick]

  *) mod_ssl: Add support for configuring persistent TLS session ticket
     encryption/decryption keys (useful for clustered environments).
     [Paul Querna, Kaspar Brand]

  *) mod_usertrack: Use random value instead of remote IP address.
     [Stefan Fritsch]

Changes with Apache 2.3.15

  *) SECURITY: CVE-2011-3348 (cve.mitre.org)
     mod_proxy_ajp: Respond with HTTP_NOT_IMPLEMENTED when the method is not
     recognized.  [Jean-Frederic Clere]

  *) SECURITY: CVE-2011-3192 (cve.mitre.org)
     core: Fix handling of byte-range requests to use less memory, to avoid
     denial of service. If the sum of all ranges in a request is larger than
     the original file, ignore the ranges and send the complete file.
     PR 51714. [Stefan Fritsch, Jim Jagielski, Ruediger Pluem, Eric Covener,
     <lowprio20 gmail.com>]

  *) SECURITY: CVE-2011-3607 (cve.mitre.org)
     core: Fix integer overflow in ap_pregsub. This can be triggered e.g.
     with mod_setenvif via a malicious .htaccess. [Stefan Fritsch]

  *) SECURITY: CVE-2011-3368 (cve.mitre.org)
     Reject requests where the request-URI does not match the HTTP
     specification, preventing unexpected expansion of target URLs in
     some reverse proxy configurations.  [Joe Orton]

  *) configure: Load all modules in the generated default configuration
     when using --enable-load-all-modules. [Rainer Jung]

  *) mod_reqtimeout: Change the default to set some reasonable timeout
     values. [Stefan Fritsch]

  *) core, mod_dav_fs: Change default ETag to be "size mtime", i.e. remove
     the inode. PR 49623. [Stefan Fritsch]

  *) mod_lua: Expose SSL variables via r:ssl_var_lookup().  [Eric Covener]

  *) mod_lua: LuaHook{AccessChecker,AuthChecker,CheckUserID,TranslateName}
     can now additionally be run as "early" or "late" relative to other modules.
     [Eric Covener]

  *) configure: By default, only load those modules that are either required
     or explicitly selected by a configure --enable-foo argument. The
     LoadModule statements for modules enabled by --enable-mods-shared=most
     and friends will be commented out. [Stefan Fritsch]

  *) mod_lua: Prevent early Lua hooks (LuaHookTranslateName and
     LuaHookQuickHandler) from being configured in <Directory>, <Files>,
     and htaccess where the configuration would have been ignored.
     [Eric Covener]

  *) mod_lua: Resolve "attempt to index local 'r' (a userdata value)" errors
     in LuaMapHandler scripts [Eric Covener]

  *) mod_log_debug: Rename optional argument from if= to expr=, to be more
     in line with other config directives. [Stefan Fritsch]

  *) mod_headers: Require an expression to be specified with expr=, to be more
     in line with other config directives. [Stefan Fritsch]

  *) mod_substitute: To prevent overboarding memory usage, limit line length
     to 1MB. [Stefan Fritsch]

  *) mod_lua: Make the query string (r.args) writable. [Eric Covener]

  *) mod_include: Add support for application/x-www-form-urlencoded encoding
     and decoding. [Graham Leggett]

  *) rotatelogs: Add -c option to force logfile creation in every rotation
     interval, even if empty.  [Jan Kaluza <jkaluza redhat.com>]

  *) core: Limit ap_pregsub() to 64K, add ap_pregsub_ex() for longer strings.
     [Stefan Fritsch]

  *) mod_session_crypto: Refactor to support the new apr_crypto API.
     [Graham Leggett]

  *) http: Add missing Location header if local URL-path is used as
     ErrorDocument for 30x. [Stefan Fritsch]

  *) mod_buffer: Make sure we step down for subrequests, but not for internal
     redirects triggered by mod_rewrite. [Graham Leggett]

  *) mod_lua: add r:construct_url as a wrapper for ap_construct_url.
     [Eric Covener]

  *) mod_remote_ip: Fix configuration of internal proxies. PR 49272.
     [Jim Riggs <jim riggs me>]

  *) mpm_winnt: Handle AcceptFilter 'none' mode correctly; resolve specific
     server IP endpoint and remote client IP upon connection.  [William Rowe]

  *) mod_setenvif: Remove OID match which is obsoleted by SetEnvIfExpr with
     PeerExtList(). [Stefan Fritsch]

  *) mpm_prefork, mpm_worker, mpm_event: If a child is created just before
     graceful restart and then exits because of a missing lock file, don't
     shutdown the whole server. PR 39311. [Shawn Michael
     <smichael rightnow com>]

  *) mpm_event: Check the return value from ap_run_create_connection.
     PR 41194. [Davi Arnaut]

  *) mod_mime_magic: Add signatures for PNG and SWF to the example config.
     PR 48352. [Jeremy Wagner-Kaiser <jwagner-kaiser adknowledge com>]

  *) core, unixd: Add -D DUMP_RUN_CFG option to dump some configuration items
     from the parsed (or default) config. This is useful for init scripts that
     need to setup temporary directories and permissions. [Stefan Fritsch]

  *) core, mod_actions, mod_asis: Downgrade error log messages which accompany
     a 404 request status from loglevel error to info. PR 35768. [Stefan
     Fritsch]

  *) core: Fix hook sorting with Perl modules. PR 45076. [Torsten Foertsch
     <torsten foertsch gmx net>]

  *) core: Enforce LimitRequestFieldSize after multiple headers with the same
     name have been merged. [Stefan Fritsch]

  *) mod_ssl: If MaxMemFree is set, ask OpenSSL >= 1.0.0 to reduce memory
     usage.  PR 51618. [Cristian Rodriguez <crrodriguez opensuse org>,
     Stefan Fritsch]

  *) mod_ssl: At startup, when checking a server certificate whether it
     matches the configured ServerName, also take dNSName entries in the
     subjectAltName extension into account. PR 32652, PR 47051. [Kaspar Brand]

  *) mod_substitute: Reduce memory usage and copying of data. PR 50559.
     [Stefan Fritsch]

  *) mod_ssl/proxy: enable the SNI extension for backend TLS connections
     [Kaspar Brand]

  *) Add wrappers for malloc, calloc, realloc that check for out of memory
     situations and use them in many places. PR 51568, PR 51569, PR 51571.
     [Stefan Fritsch]

  *) Fix cross-compilation of mod_cgi/mod_cgid when APR_HAVE_STRUCT_RLIMIT is
     false but RLIMIT_* are defined.  PR51371. [Eric Covener]

  *) core: Correctly obey ServerName / ServerAlias if the Host header from the
     request matches the VirtualHost address.
     PR 51709. [Micha Lenk <micha lenk.info>]

  *) mod_unique_id: Use random number generator to initialize counter.
     PR 45110. [Stefan Fritsch]

  *) core: Add convenience API for apr_random. [Stefan Fritsch]

  *) core: Add MaxRangeOverlaps and MaxRangeReversals directives to control
     the number of overlapping and reversing ranges (respectively) permitted
     before returning the entire resource, with a default limit of 20.
     [Jim Jagielski]

  *) mod_ldap: Optional function uldap_ssl_supported(r) always returned false
     if called from a virtual host with mod_ldap directives in it.  Did not
     affect mod_authnz_ldap's usage of mod_ldap.  [Eric Covener]

  *) mod_filter: Instead of dropping the Accept-Ranges header when a filter
     registered with AP_FILTER_PROTO_NO_BYTERANGE is present,
     set the header value to "none". [Eric Covener, Ruediger Pluem]

  *) core: Allow MaxRanges none|unlimited|default and set 'Accept-Ranges: none'
     in the case Ranges are being ignored with MaxRanges none.
     [Eric Covener]

  *) mod_ssl: revamp CRL-based revocation checking when validating
     certificates of clients or proxied servers. Completely delegate
     CRL processing to OpenSSL, and add a new [Proxy]CARevocationCheck
     directive for controlling the revocation checking mode. [Kaspar Brand]

  *) core: Add MaxRanges directive to control the number of ranges permitted
     before returning the entire resource, with a default limit of 200.
     [Eric Covener]

  *) mod_cache: Ensure that CacheDisable can correctly appear within
     a LocationMatch. [Graham Leggett]

  *) mod_cache: Fix the moving of the CACHE filter, which erroneously
     stood down if the original filter was not added by configuration.
     [Graham Leggett]

  *) mod_ssl: improve certificate error logging. PR 47408. [Kaspar Brand]

  *) mod_authz_groupfile: Increase length limit of lines in the group file to
     16MB. PR 43084. [Stefan Fritsch]

  *) core: Increase length limit of lines in the configuration file to 16MB.
     PR 45888. PR 50824. [Stefan Fritsch]

  *) core: Add API for resizable buffers. [Stefan Fritsch]

  *) mod_ldap: Enable LDAPConnectionTimeout for LDAP toolkits that have
     LDAP_OPT_CONNECT_TIMEOUT instead of LDAP_OPT_NETWORK_TIMEOUT, such
     as Tivoli Directory Server 6.3 and later. [Eric Covener]

  *) mod_ldap: Change default number of retries from 10 to 3, and add
     an LDAPRetries and LDAPRetryDelay directives. [Eric Covener]

  *) mod_authnz_ldap: Don't retry during authentication, because this just
     multiplies the ample retries already being done by mod_ldap. [Eric Covener]

  *) configure: Allow to explicitly disable modules even with module selection
     'reallyall'. [Stefan Fritsch]

  *) mod_rewrite: Check validity of each internal (int:) RewriteMap even if the
     RewriteEngine is disabled in server context, avoiding a crash while
     referencing the invalid int: map at runtime. PR 50994.
     [Ben Noordhuis <info noordhuis nl>]

  *) mod_ssl, configure: require OpenSSL 0.9.7 or later. [Kaspar Brand]

  *) mod_ssl: remove ssl_toolkit_compat layer. [Kaspar Brand]

  *) mod_ssl, configure, ab: drop support for RSA BSAFE SSL-C toolkit.
     [Kaspar Brand]

  *) mod_usertrack: Run mod_usertrack earlier in the fixups hook to ensure the
     cookie is set when modules such as mod_rewrite trigger a redirect. Also
     use r->err_headers_out for the cookie, for the same reason.  PR29755.
     [Sami J. Makinen <sjm almamedia fi>, Eric Covener]

  *) mod_proxy_http, mod_proxy_connect: Add 'proxy-status' and
     'proxy-source-port' request notes for logging. PR 30195. [Stefan Fritsch]

  *) configure: Enable ldap modules in 'all' and 'most' selections if ldap
     is compiled into apr-util. [Stefan Fritsch]

  *) core: Add ap_check_cmd_context()-check if a command is executed in
     .htaccess file. [Stefan Fritsch]

  *) mod_deflate: Fix endless loop if first bucket is metadata. PR 51590.
     [Torsten Foertsch <torsten foertsch gmx net>]

  *) mod_authn_socache: Fix to work in .htaccess if not configured anywhere
     in httpd.conf, and introduce an AuthnCacheEnable directive.
     PR 51991 [Nick Kew]

  *) mod_xml2enc: new (formerly third-party) module supporting
     internationalisation for filters via smart charset sniffing
     and conversion. [Nick Kew]

  *) mod_proxy_html: new (formerly third-party) module to fix up
     HTML links in a reverse proxy situation, where a backend
     generates URLs that are not resolvable by Clients. [Nick Kew]

Changes with Apache 2.3.14

  *) mod_proxy_ajp: Improve trace logging.  [Rainer Jung]

  *) mod_proxy_ajp: Respect "reuse" flag in END_REPONSE packets.
     [Rainer Jung]

  *) mod_proxy: enable absolute URLs to be rewritten with ProxyPassReverse,
     e.g. to reverse proxy "Location: https://other-internal-server/login"
     [Nick Kew]

  *) prefork, worker, event: Make sure crashes are logged to the error log if
     httpd has already detached from the console. [Stefan Fritsch]

  *) prefork, worker, event: Reduce period during startup/restart where a
     successive signal may be lost. PR 43696. [Arun Bhalla <arun shme net>]

  *) mod_allowmethods: Correct Merging of "reset" and do not allow an
     empty parameter list for the AllowMethods directive. [Rainer Jung]

  *) configure: Update selection of modules for 'all' and 'most'. 'all' will
     now enable all modules except for example and test modules. Make the
     selection for 'most' more useful (including ssl and proxy). Both 'all'
     and 'most' will now disable modules if dependencies are missing instead
     of aborting. If a specific module is requested with --enable-XXX=yes,
     missing dependencies will still cause configure to exit with an error.
     [Stefan Fritsch]

  *) mod_ldap: Revert the integration of apr-ldap as ap_ldap which was done
     in 2.3.13. [Stefan Fritsch]

  *) core: For '*' or '_default_' vhosts, use a wildcard address of any
     address family, rather than IPv4 only.  [Joe Orton]

  *) core, mod_rewrite, mod_ssl, mod_nw_ssl: Make the SERVER_NAME variable
     include [ ] for literal IPv6 addresses, as mandated by RFC 3875.
     PR 26005. [Stefan Fritsch]

  *) mod_negotiation: Fix parsing of Content-Length in type maps. PR 42203.
     [Nagae Hidetake <nagae eagan jp>]

  *) core: Add more logging to ap_scan_script_header_err* functions. Add
     ap_scan_script_header_err*_ex functions that take a module index for
     logging.
     mod_cgi, mod_cgid, mod_proxy_fcgi, mod_proxy_scgi, mod_isapi: Use the
     new functions in order to make logging configurable per-module.
     [Stefan Fritsch]

  *) mod_dir: Add DirectoryIndexRedirect to send an external redirect to
     the proper index.  [Eric Covener]

  *) mod_deflate: Don't try to compress requests with a zero sized body.
     PR 51350. [Stefan Fritsch]

  *) core: Fix startup on IPv6-only systems. PR 50592. [Joe Orton,
     <root linkage white-void net>]

  *) suexec: Add environment variables CONTEXT_DOCUMENT_ROOT, CONTEXT_PREFIX,
     REDIRECT_ERROR_NOTES, REDIRECT_SCRIPT_FILENAME, REQUEST_SCHEME to the
     whitelist in suexec. PR 51499. [Graham Laverty <graham reg ca>,
     Stefan Fritsch]

  *) mod_rewrite: Fix regexp RewriteCond with NoCase. [Stefan Fritsch]

  *) mod_log_debug: New module that allows to log custom messages at various
     phases in the request processing. [Stefan Fritsch]

  *) mod_ssl: Add some debug logging when loading server certificates.
     PR 37912. [Nick Burch <nick burch alfresco com>]

  *) configure: Support reallyall option also for --enable-mods-static.
     [Rainer Jung]

  *) mod_socache_dc: add --with-distcache to configure for choosing
     the distcache installation directory. [Rainer Jung]

  *) mod_socache_dc: use correct build variable MOD_SOCACHE_DC_LDADD
     instead of MOD_SOCACHE_LDADD in build macro. [Rainer Jung]

  *) mod_lua, mod_deflate: respect platform specific runpath linker
     flag. [Rainer Jung]

  *) configure: Only link the httpd binary against PCRE. No other support
     binary needs PCRE. [Rainer Jung]

  *) configure: tolerate dependency checking failures for modules if
     they have been enabled implicitly. [Rainer Jung]

  *) configure: Allow to specify module specific custom linker flags via
     the MOD_XXX_LDADD variables. [Rainer Jung]

Changes with Apache 2.3.13

  *) ab: Support specifying the local address to use. PR 48930.
     [Peter Schuller <scode spotify com>]

  *) core: Add support to ErrorLogFormat for logging the system unique
     thread id under Linux. [Stefan Fritsch]

  *) event: New AsyncRequestWorkerFactor directive to influence how many
     connections will be accepted per process. [Stefan Fritsch]

  *) prefork, worker, event: Rename MaxClients to MaxRequestWorkers which
     describes more accurately what it does. [Stefan Fritsch]

  *) rotatelogs: Add -p argument to specify custom program to invoke
     after a log rotation.  PR 51285. [Sven Ulland <sveniu ifi.uio.no>,
     Joe Orton]

  *) mod_ssl: Don't do OCSP checks for valid self-issued certs. [Kaspar Brand]

  *) mod_ssl: Avoid unnecessary renegotiations with SSLVerifyDepth 0.
     PR 48215. [Kaspar Brand]

  *) mod_status: Display information about asynchronous connections in the
     server-status. PR 44377. [Stefan Fritsch]

  *) mpm_event: If the number of connections of a process is very high, or if
     all workers are busy, don't accept new connections in that process.
     [Stefan Fritsch]

  *) mpm_event: Process lingering close asynchronously instead of tying up
     worker threads. [Jeff Trawick, Stefan Fritsch]

  *) mpm_event: If MaxMemFree is set, limit the number of pools that is kept
     around. [Stefan Fritsch]

  *) mpm_event: Fix graceful restart aborting connections. PR 43359.
     [Takashi Sato <takashi lans-tv com>]

  *) mod_ssl: Disable AECDH ciphers in example config. PR 51363.
     [Rob Stradling <rob comodo com>]

  *) core: Introduce new function ap_get_conn_socket() to access the socket of
     a connection. [Stefan Fritsch]

  *) mod_data: Introduce a filter to support RFC2397 data URLs. [Graham
     Leggett]

  *) mod_userdir/mod_alias/mod_vhost_alias: Correctly set DOCUMENT_ROOT,
     CONTEXT_DOCUMENT_ROOT, CONTEXT_PREFIX. PR 26052. PR 46198.
     [Stefan Fritsch]

  *) core: Allow to override document_root on a per-request basis. Introduce
     new context_document_root and context_prefix which provide information
     about non-global URI-to-directory mappings (from e.g. mod_userdir or
     mod_alias) to scripts. PR 49705. [Stefan Fritsch]

  *) core: Add <ElseIf> and <Else> to complement <If> sections.
     [Stefan Fritsch]

  *) mod_ext_filter: Remove DebugLevel option in favor of per-module loglevel.
     [Stefan Fritsch]

  *) mod_include: Make the "#if expr" element use the new "ap_expr" expression
     parser. The old parser can still be used by setting the new directive
     SSILegacyExprParser. [Stefan Fritsch]

  *) core: Add some features to ap_expr for use by mod_include: a restricted
     mode that does not allow to bypass request access restrictions; new
     variables DOCUMENT_URI (alias for REQUEST_URI), LAST_MODIFIED; -A as an
     alias for -U; an additional data entry in ap_expr_eval_ctx_t for use by
     the consumer; an extensible ap_expr_exec_ctx() API that allows to use that
     data entry. [Stefan Fritsch]

  *) mod_include: Merge directory configs instead of one SSI* config directive
     causing all other per-directory SSI* config directives to be reset.
     [Stefan Fritsch]

  *) mod_charset_lite: Remove DebugLevel option in favour of per-module
     loglevel. [Stefan Fritsch]

  *) core: Add ap_regexec_len() function that works with non-null-terminated
     strings. PR 51231. [Yehezkel Horowitz <horowity checkpoint com>]

  *) mod_authnz_ldap: If the LDAP server returns constraint violation,
     don't treat this as an error but as "auth denied". [Stefan Fritsch]

  *) mod_proxy_fcgi|scgi: Add support for "best guess" of PATH_INFO
     for SCGI/FCGI. PR 50880, 50851. [Mark Montague <mark catseye.org>,
     Jim Jagielski]

  *) mod_cache: When content is served stale, and there is no means to
     revalidate the content using ETag or Last-Modified, and we have
     mandated no stale-on-error behaviour, stand down and don't cache.
     Saves a cache write that will never be read.
     [Graham Leggett]

  *) mod_reqtimeout: Fix a timed out connection going into the keep-alive
     state after a timeout when discarding a request body. PR 51103.
     [Stefan Fritsch]

  *) core: Add various file existence test operators to ap_expr.
     [Stefan Fritsch]

  *) mod_proxy_express: New mass reverse-proxy switch extension for
     mod_proxy. [Jim Jagielski]

  *) configure: Fix script error when configuring module set "reallyall".
     [Rainer Jung]

Changes with Apache 2.3.12

  *) configure, core: Provide easier support for APR's hook probe
     capability. [Jim Jagielski, Jeff Trawick]

  *) Silence autoconf 2.68 warnings.  [Rainer Jung]

  *) mod_authnz_ldap: Resolve crash when LDAP is used for authorization only
     [Scott Hill <shill genscape.com>]

  *) support: Make sure check_forensic works with mod_unique_id loaded
     [Joe Schaefer]

  *) Add child_status hook for tracking creation/termination of MPM child
     processes.  Add end_generation hook for notification when the last
     MPM child of a generation exits. [Jeff Trawick]

  *) mod_ldap: Make LDAPSharedCacheSize 0 create a non-shared-memory cache per
     process as opposed to disabling caching completely. This allows to use
     the non-shared-memory cache as a workaround for the shared memory cache
     not being available during graceful restarts. PR 48958. [Stefan Fritsch]

  *) Add new ap_reserve_module_slots/ap_reserve_module_slots_directive API,
     necessary if a module (like mod_perl) registers additional modules late
     in the startup phase. [Stefan Fritsch]

  *) core: Prevent segfault if DYNAMIC_MODULE_LIMIT is reached. PR 51072.
     [Torsten Fortsch <torsten foertsch gmx net>]

  *) WinNT MPM: Improve robustness under heavy load.  [Jeff Trawick]

  *) MinGW build improvements.  PR 49535.  [John Vandenberg
     <jayvdb gmail.com>, Jeff Trawick]

  *) core: Support module names with colons in loglevel configuration.
     [Torsten Fortsch <torsten foertsch gmx net>]

  *) mod_ssl, ab: Support OpenSSL compiled without SSLv2 support.
     [Stefan Fritsch]

  *) core: Abort if the MPM is changed across restart.  [Jeff Trawick]

  *) mod_proxy_ajp: Add support for 'ProxyErrorOverride on'. PR 50945.
     [Peter Pramberger <peter pramberger.at>, Jim Jagielski]

  *) mod_proxy_fcgi: Add support for 'ProxyErrorOverride on'. PR 50913.
     [Mark Montague <mark catseye.org>, Jim Jagielski]

  *) core: Change the APIs of ap_cfg_getline() and ap_cfg_getc() to return an
     error code. Abort with a nice error message if a config line is too long.
     Partial fix for PR 50824. [Stefan Fritsch]

  *) mod_info: Dump config to stdout during startup if -DDUMP_CONFIG is
     specified. PR 31956. [Stefan Fritsch]

  *) Restore visibility of DEFAULT_PIDLOG to core and modules.  MPM
     helper function ap_remove_pid() added.  [Jeff Trawick]

  *) Enable DEFAULT_REL_RUNTIMEDIR on Windows and NetWare.  [various]

  *) Correct C++ incompatibility with http_log.h.  [Stefan Fritsch, Jeff
     Trawick]

  *) mod_log_config: Prevent segfault. PR 50861. [Torsten Fortsch
     <torsten.foertsch gmx.net>]

  *) core: AllowEncodedSlashes new option NoDecode to allow encoded slashes
     in request URL path info but not decode them. Change behavior of option
     "On" to decode the encoded slashes as 2.0 and 2.2 do.  PR 35256,
     PR 46830.  [Dan Poirier]

  *) mod_ssl: Check SNI hostname against Host header case-insensitively.
     PR 49491.  [Mayank Agrawal <magrawal.08 gmail.com>]

  *) mod_ldap: Add LDAPConnectionPoolTTL to give control over lifetime
     of bound backend LDAP connections.  PR47634 [Eric Covener]

  *) mod_cache: Make CacheEnable and CacheDisable configurable per
     directory in addition to per server, making them work from within
     a LocationMatch. [Graham Leggett]

  *) worker, event, prefork: Correct several issues when built as
     DSOs; most notably, the scoreboard was reinitialized during graceful
     restart, such that processes of the previous generation were not
     observable.  [Jeff Trawick]

Changes with Apache 2.3.11

  *) mod_win32: Added shebang check for '! so that .vbs scripts work as CGI.
     Win32's cscript interpreter can only use a single quote as comment char.
     [Guenter Knauf]

  *) mod_proxy: balancer-manager now uses POST instead of GET.
     [Jim Jagielski]

  *) core: new util function: ap_parse_form_data(). Previously,
     this capability was tucked away in mod_request. [Jim Jagielski]

  *) core: new hook: ap_run_pre_read_request. [Jim Jagielski]

  *) modules: Fix many modules that were not correctly initializing if they
     were not active during server startup but got enabled later during a
     graceful restart. [Stefan Fritsch]

  *) core: Create new ap_state_query function that allows modules to determine
     if the current configuration run is the initial one at server startup,
     and if the server is started for testing/config dumping only.
     [Stefan Fritsch]

  *) mod_proxy: Runtime configuration of many parameters for existing
     balancers via the balancer-manager. [Jim Jagielski]

  *) mod_proxy: Runtime addition of new workers (BalancerMember) for existing
     balancers via the balancer-manager. [Jim Jagielski]

  *) mod_cache: When a bad Expires date is present, we need to behave as if
     the Expires is in the past, not as if the Expires is missing. PR 16521.
     [Co-Advisor <coad measurement-factory.com>]

  *) mod_cache: We must ignore quoted-string values that appear in a
     Cache-Control header. PR 50199. [Graham Leggett]

  *) mod_dav: Revert change to send 501 error if unknown Content-* header is
    received for a PUT request. PR 42978. [Stefan Fritsch]

  *) mod_cache: Respect s-maxage as described by RFC2616 14.9.3, which must
     take precedence if present. PR 35247. [Graham Leggett]

  *) mod_ssl: Fix a possible startup failure if multiple SSL vhosts
     are configured with the same ServerName and private key file.
     [Masahiro Matsuya <mmatsuya redhat.com>, Joe Orton]

  *) mod_socache_dc: Make module compile by fixing some typos.
     PR 50735 [Mark Montague <mark catseye.org>]

  *) prefork: Update MPM state in children during a graceful stop or
     restart.  PR 41743.  [Andrew Punch <andrew.punch 247realmedia.com>]

  *) mod_mime: Ignore leading dots when looking for mime extensions.
     PR 50434 [Stefan Fritsch]

  *) core: Add support to set variables with the 'Define' directive. The
     variables that can then be used in the config using the ${VAR} syntax
     known from envvar interpolation. [Stefan Fritsch]

  *) mod_proxy_http: make adding of X-Forwarded-* headers configurable.
     ProxyAddHeaders defaults to On. [Vincent Deffontaines]

  *) mod_slotmem_shm: Increase memory alignment for slotmem data.
     [Rainer Jung]

  *) mod_ssl: Add config options for OCSP: SSLOCSPResponderTimeout,
     SSLOCSPResponseMaxAge, SSLOCSPResponseTimeSkew.
     [Kaspar Brand <httpd-dev.2011 velox.ch>]

  *) mod_ssl: Revamp output buffering to reduce network overhead for
     output fragmented into many buckets, such as chunked HTTP responses.
     [Joe Orton]

  *) core: Apply <If> sections to all requests, not only to file base requests.
     Allow to use <If> inside <Directory>, <Location>, and <Files> sections.
     The merging of <If> sections now happens after the merging of <Location>
     sections, even if an <If> section is embedded inside a <Directory> or
     <Files> section.  [Stefan Fritsch]

  *) mod_proxy: Refactor usage of shared data by dropping the scoreboard
     and using slotmem. Create foundation for dynamic growth/changes of
     members within a balancer. Remove BalancerNonce in favor of a
     per-balancer 'nonce' parameter. [Jim Jagielski]

  *) mod_status: Don't show slots which are disabled by MaxClients as open.
     PR 47022 [Jordi Prats <jordi prats gmail com>, Stefan Fritsch]

  *) mpm_prefork: Fix ap_mpm_query results for AP_MPMQ_MAX_DAEMONS and
     AP_MPMQ_MAX_THREADS.

  *) mod_authz_core: Fix bug in merging logic if user-based and non-user-based
     authorization directives were mixed. [Stefan Fritsch]

  *) mod_authn_socache: change directive name from AuthnCacheProvider
     to AuthnCacheProvideFor.  The term "provider" is overloaded in
     this module, and we should avoid confusion between the provider
     of a backend (AuthnCacheSOCache) and the authn provider(s) for
     which this module provides cacheing (AuthnCacheProvideFor).
     [Nick Kew]

  *) mod_proxy_http: Allocate the fake backend request from a child pool
     of the backend connection, instead of misusing the pool of the frontend
     request. Fixes a thread safety issue where buckets set aside in the
     backend connection leak into other threads, and then disappear when
     the frontend request is cleaned up, in turn causing corrupted buckets
     to make other threads spin. [Graham Leggett]

  *) mod_ssl: Change the format of the SSL_{CLIENT,SERVER}_{I,S}_DN variables
     to be RFC 2253 compatible, convert non-ASCII characters to UTF8, and
     escape other special characters with backslashes. The old format can
     still be used with the LegacyDNStringFormat argument to SSLOptions.

  *) core, mod_rewrite: Make the REQUEST_SCHEME variable available to
     scripts and mod_rewrite. [Stefan Fritsch]

  *) mod_rewrite: Allow to use arbitrary boolean expressions (ap_expr) in
     RewriteCond. [Stefan Fritsch]

  *) mod_rewrite: Allow to unset environment variables using E=!VAR.
     PR 49512. [Mark Drayton <mark markdrayton info>, Stefan Fritsch]

  *) mod_headers: Restore the 2.3.8 and earlier default for the first
     argument of the Header directive ("onsuccess").  [Eric Covener]

  *) core: Disallow the mixing of relative and absolute Options PR 33708.
     [Sonke Tesch <st kino-fahrplan.de>]

  *) core: When exporting request headers to HTTP_* environment variables,
     drop variables whose names contain invalid characters. Describe in the
     docs how to restore the old behaviour. [Malte S. Stretz <mss apache org>]

  *) core: When selecting an IP-based virtual host, favor an exact match for
     the port over a wildcard (or omitted) port instead of favoring the one
     that came first in the configuration file. [Eric Covener]

  *) core: Overlapping virtual host address/port combinations  now implicitly
     enable name-based virtual hosting for that address.  The NameVirtualHost
     directive has no effect, and _default_ is interpreted the same as "*".
     [Eric Covener]

  *) core: In the absence of any Options directives, the default is now
     "FollowSymlinks" instead of "All".  [Igor Galic]

  *) rotatelogs: Add -e option to write logs through to stdout for optional
     further processing. [Graham Leggett]

  *) mod_ssl: Correctly read full lines in input filter when the line is
     incomplete during first read. PR 50481. [Ruediger Pluem]

  *) mod_authz_core: Add AuthzSendForbiddenOnFailure directive to allow
     sending '403 FORBIDDEN' instead of '401 UNAUTHORIZED' if authorization
     fails for an authenticated user. PR 40721. [Stefan Fritsch]

Changes with Apache 2.3.10

  *) mod_rewrite: Don't implicitly URL-escape the original query string
     when no substitution has changed it. PR 50447. [Eric Covener]

  *) core: Honor 'AcceptPathInfo OFF' during internal redirects,
     such as per-directory mod_rewrite substitutions.  PR 50349.
     [Eric Covener]

  *) mod_rewrite: Add 'RewriteOptions InheritBefore' to put the base
     rules/conditions before the overridden rules/conditions.  PR 39313.
     [Jerome Grandjanny <jerome.grandjanny cea.fr>]

  *) mod_autoindex: add IndexIgnoreReset to reset the list of IndexIgnored
     filenames in higher precedence configuration sections.  PR 24243.
     [Eric Covener]

  *) mod_cgid: RLimit* directive support for mod_cgid.  PR 42135
     [Eric Covener]

  *) core: Fail startup when the argument to ServerName looks like a glob
     or a regular expression instead of a hostname (*?[]).  PR 39863
     [Rahul Nair <rahul.g.nair gmail.com>]

  *) mod_userdir: Add merging of enable, disable, and filename arguments
     to UserDir directive, leaving enable/disable of userlists unmerged.
     PR 44076 [Eric Covener]

  *) httpd: When no -k option is provided on the httpd command line, the server
     was starting without checking for an existing pidfile.  PR 50350
     [Eric Covener]

  *) mod_proxy: Put the worker in error state if the SSL handshake with the
     backend fails. PR 50332.
     [Daniel Ruggeri <DRuggeri primary.net>, Ruediger Pluem]

  *) mod_cache_disk: Fix Windows build which was broken after renaming
     the module. [Gregg L. Smith]

Changes with Apache 2.3.9

  *) SECURITY: CVE-2010-1623 (cve.mitre.org)
     Fix a denial of service attack against mod_reqtimeout.
     [Stefan Fritsch]

  *) mod_headers: Change default first argument of Header directive
     from "onsuccess" to "always". [Eric Covener]

  *) mod_include: Add the onerror attribute to the include element,
     allowing an URL to be specified to include on error. [Graham
     Leggett]

  *) mod_cache_disk: mod_disk_cache renamed to mod_cache_disk, to be
     consistent with the naming of other modules. [Graham Leggett]

  *) mod_setenvif: Add SetEnvIfExpr directive to set env var depending on
     expression. [Stefan Fritsch]

  *) mod_proxy: Fix ProxyPassInterpolateEnv directive. PR 50292.
     [Stefan Fritsch]

  *) suEXEC: Add Suexec directive to disable suEXEC without renaming the
     binary (Suexec Off), or force startup failure if suEXEC is required
     but not supported (Suexec On).  Change SuexecUserGroup to fail
     startup instead of just printing a warning if suEXEC is disabled.
     [Jeff Trawick]

  *) core: Add Error directive for aborting startup or htaccess processing
     with a specified error message.  [Jeff Trawick]

  *) mod_rewrite: Fix the RewriteEngine directive to work within a
     location. Previously, once RewriteEngine was switched on globally,
     it was impossible to switch off. [Graham Leggett]

  *) core, mod_include, mod_ssl: Move the expression parser derived from
     mod_include back into mod_include. Replace ap_expr with a parser
     derived from mod_ssl's parser. Make mod_ssl use the new parser. Rework
     ap_expr's public interface and provide hooks for modules to add variables
     and functions. [Stefan Fritsch]

  *) core: Do the hook sorting earlier so that the hooks are properly sorted
     for the pre_config hook and during parsing the config. [Stefan Fritsch]

  *) core: In the absence of any AllowOverride directives, the default is now
     "None" instead of "All".  PR49823 [Eric Covener]

  *) mod_proxy: Don't allow ProxyPass or ProxyPassReverse in
     <Directory> or <Files>. PR47765 [Eric Covener]

  *) prefork/worker/event MPMS: default value (when no directive is present)
     of MaxConnectionsPerChild/MaxRequestsPerChild is changed to 0 from 10000
     to match default configuration and manual. PR47782 [Eric Covener]

  *) proxy_connect: Don't give up in the middle of a CONNECT tunnel
     when the child process is starting to exit.  PR50220. [Eric Covener]

  *) mod_autoindex: Fix inheritance of mod_autoindex directives into
     contexts that don't have any mod_autoindex directives. PR47766.
     [Eric Covener]

  *) mod_rewrite: Add END flag for RewriteRule to prevent further rounds
     of rewrite processing when a per-directory substitution occurs.
     [Eric Covener]

  *) mod_ssl: Make sure to always log an error if loading of CA certificates
     fails. PR 40312. [Paul Tiemann <issues apache org ourdetour com>]

  *) mod_dav: Send 501 error if unknown Content-* header is received for a PUT
     request (RFC 2616 9.6). PR 42978. [Stefan Fritsch]

  *) mod_dav: Send 400 error if malformed Content-Range header is received for
     a put request (RFC 2616 14.16). PR 49825. [Stefan Fritsch]

  *) mod_proxy: Release the backend connection as soon as EOS is detected,
     so the backend isn't forced to wait for the client to eventually
     acknowledge the data. [Graham Leggett]

  *) mod_proxy: Optimise ProxyPass within a Location so that it is stored
     per-directory, and chosen during the location walk. Make ProxyPass
     work correctly from within a LocationMatch. [Graham Leggett]

  *) core: Fix segfault if per-module LogLevel is on virtual host
     scope. PR 50117. [Stefan Fritsch]

  *) mod_proxy: Move the ProxyErrorOverride directive to have per
     directory scope. [Graham Leggett]

  *) mod_allowmethods: New module to deny certain HTTP methods without
     interfering with authentication/authorization. [Paul Querna,
     Igor Galic, Stefan Fritsch]

  *) mod_ssl: Log certificate information and improve error message if client
     cert verification fails. PR 50093, PR 50094. [Lassi Tuura <lat cern ch>,
     Stefan Fritsch]

  *) htcacheclean: Teach htcacheclean to limit cache size by number of
     inodes in addition to size of files. Prevents a cache disk from
     running out of space when many small files are cached.
     [Graham Leggett]

  *) core: Rename MaxRequestsPerChild to MaxConnectionsPerChild, which
     describes more accurately what the directive does. The old name
     still works but logs a warning. [Stefan Fritsch]

  *) mod_cache: Optionally serve stale data when a revalidation returns a
     5xx response, controlled by the CacheStaleOnError directive.
     [Graham Leggett]

  *) htcacheclean: Allow the listing of valid URLs within the cache, with
     the option to list entry metadata such as sizes and times. [Graham
     Leggett]

  *) mod_cache: correctly parse quoted strings in cache headers.
     PR 50199 [Nick Kew]

  *) mod_cache: Allow control over the base URL of reverse proxied requests
     using the CacheKeyBaseURL directive, so that the cache key can be
     calculated from the endpoint URL instead of the server URL. [Graham
     Leggett]

  *) mod_cache: CacheLastModifiedFactor, CacheStoreNoStore, CacheStorePrivate,
     CacheStoreExpired, CacheIgnoreNoLastMod, CacheDefaultExpire,
     CacheMinExpire and CacheMaxExpire can be set per directory/location.
     [Graham Leggett]

  *) mod_disk_cache: CacheMaxFileSize, CacheMinFileSize, CacheReadSize and
     CacheReadTime can be set per directory/location. [Graham Leggett]

  *) core: Speed up config parsing if using a very large number of config
     files. PR 50002 [andrew cloudaccess net]

  *) mod_cache: Support the caching of HEAD requests. [Graham Leggett]

  *) htcacheclean: Allow the option to round up file sizes to a given
     block size, improving the accuracy of disk usage. [Graham Leggett]

  *) mod_ssl: Add authz providers for use with mod_authz_core and its
     RequireAny/RequireAll containers: 'ssl' (equivalent to SSLRequireSSL),
     'ssl-verify-client' (for use with 'SSLVerifyClient optional'), and
     'ssl-require' (expressions with same syntax as SSLRequire).
     [Stefan Fritsch]

  *) mod_ssl: Make the ssl expression parser thread-safe. It now requires
     bison instead of yacc. [Stefan Fritsch]

  *) mod_disk_cache: Change on-disk header file format to support the
     link of the device/inode of the data file to the matching header
     file, and to support the option of not writing a data file when
     the data file is empty. [Graham Leggett]

  *) core/mod_unique_id: Add generate_log_id hook to allow to use
     the ID generated by mod_unique_id as error log ID for requests.
     [Stefan Fritsch]

  *) mod_cache: Make sure that we never allow a 304 Not Modified response
     that we asked for to leak to the client should the 304 response be
     uncacheable. PR45341 [Graham Leggett]

  *) mod_cache: Add the cache_status hook to register the final cache
     decision hit/miss/revalidate. Add optional support for an X-Cache
     and/or an X-Cache-Detail header to add the cache status to the
     response. PR48241 [Graham Leggett]

  *) mod_authz_host: Add 'local' provider that matches connections originating
     on the local host. PR 19938. [Stefan Fritsch]

  *) Event MPM: Fix crash accessing pollset on worker thread when child
     process is exiting.  [Jeff Trawick]

  *) core: For process invocation (cgi, fcgid, piped loggers and so forth)
     pass the system library path (LD_LIBRARY_PATH or platform-specific
     variables) along with the system PATH, by default.  Both should be
     overridden together as desired using PassEnv etc; see mod_env.
     [William Rowe]

  *) mod_cache: Introduce CacheStoreExpired, to allow administrators to
     capture a stale backend response, perform If-Modified-Since requests
     against the backend, and serving from the cache all 304 responses.
     This restores pre-2.2.4 cache behavior.  [William Rowe]

  *) mod_rewrite: Introduce <=, >= string comparison operators, and integer
     comparators -lt, -le, -eq, -ge, and -gt.  To help bash users and drop
     the ambiguity of the symlink test "-ltest", introduce -h or -L as
     symlink test operators.  [William Rowe]

  *) mod_cache: Give the cache provider the opportunity to choose to cache
     or not cache based on the buckets present in the brigade, such as the
     presence of a FILE bucket.
     [Graham Leggett]

  *) mod_authz_core: Allow authz providers to check args while reading the
     config and allow to cache parsed args. Move 'all' and 'env' authz
     providers from mod_authz_host to mod_authz_core. Add 'method' authz
     provider depending on the HTTP method.  [Stefan Fritsch]

  *) mod_include: Move the request_rec within mod_include to be
     exposed within include_ctx_t. [Graham Leggett]

  *) mod_include: Reinstate support for UTF-8 character sets by allowing a
     variable being echoed or set to be decoded and then encoded as separate
     steps. PR47686 [Graham Leggett]

  *) mod_cache: Add a discrete commit_entity() provider function within the
     mod_cache provider interface which is called to indicate to the
     provider that caching is complete, giving the provider the opportunity
     to commit temporary files permanently to the cache in an atomic
     fashion. Replace the inconsistent use of error cleanups with a formal
     set of pool cleanups attached to a subpool, which is destroyed on error.
     [Graham Leggett]

  *) mod_cache: Change the signature of the store_body() provider function
     within the mod_cache provider interface to support an "in" brigade
     and an "out" brigade instead of just a single input brigade. This
     gives a cache provider the option to consume only part of the brigade
     passed to it, rather than the whole brigade as was required before.
     This fixes an out of memory and a request timeout condition that would
     occur when the original document was a large file. Introduce
     CacheReadSize and CacheReadTime directives to mod_disk_cache to control
     the amount of data to attempt to cache at a time. [Graham Leggett]

  *) core: Add ErrorLogFormat to allow configuring error log format, including
     additional information that is logged once per connection or request. Add
     error log IDs for connections and request to allow correlating error log
     lines and the corresponding access log entry. [Stefan Fritsch]

  *) core: Disable sendfile by default. [Stefan Fritsch]

  *) mod_cache: Check the request to determine whether we are allowed
     to return cached content at all, and respect a "Cache-Control:
     no-cache" header from a client. Previously, "no-cache" would
     behave like "max-age=0". [Graham Leggett]

  *) mod_cache: Use a proper filter context to hold filter data instead
     of misusing the per-request configuration. Fixes a segfault on trunk
     when the normal handler is used. [Graham Leggett]

  *) mod_cgid: Log a warning if the ScriptSock path is truncated because
     it is too long. PR 49388.  [Stefan Fritsch]

  *) vhosts: Do not allow _default_ in NameVirtualHost, or mixing *
     and non-* ports on NameVirtualHost, or multiple NameVirtualHost
     directives for the same address:port, or NameVirtualHost
     directives with no matching VirtualHosts, or multiple ip-based
     VirtualHost sections for the same address:port.  These were
     previously accepted with a warning, but the behavior was
     undefined.  [Dan Poirier]

  *) mod_remoteip: Fix a segfault when using mod_remoteip in conjunction with
     Allow/Deny. PR 49838.  [Andrew Skalski <voltara gmail.com>]

  *) core: DirectoryMatch can now match on the end of line character ($),
     and sub-directories of matched directories are no longer implicitly
     matched.  PR49809 [Eric Covener]

  *) Regexps: introduce new higher-level regexp utility including parsing
     and executing perl-style regexp ops (e.g s/foo/bar/i) and regexp memory
     [Nick Kew]

  *) Proxy: support setting source address.  PR 29404
     [Multiple contributors iterating through bugzilla,
      Aron Ujvari <xanco nikhok.hu>, Aleksey Midenkov <asm uezku.kemsu.ru>,
      <dan listening-station.net; trunk version Nick Kew]

  *) HTTP protocol: return 400 not 503 if we have to abort due to malformed
     chunked encoding. [Nick Kew]

Changes with Apache 2.3.8

  *) suexec: Support large log files. PR 45856. [Stefan Fritsch]

  *) core: Abort with sensible error message if no or more than one MPM is
     loaded. [Stefan Fritsch]

  *) mod_proxy: Rename erroronstatus to failonstatus.
     [Daniel Ruggeri <DRuggeri primary.net>]

  *) mod_dav_fs: Fix broken "creationdate" property.
     Regression in version 2.3.7. [Rainer Jung]

Changes with Apache 2.3.7

  *) SECURITY: CVE-2010-1452 (cve.mitre.org)
     mod_dav, mod_cache, mod_session: Fix Handling of requests without a path
     segment. PR 49246 [Mark Drayton, Jeff Trawick]

  *) mod_ldap: Properly check the result returned by apr_ldap_init. PR 46076.
     [Stefan Fritsch]

  *) mod_rewrite: Log errors if rewrite map files cannot be opened. PR 49639.
     [Stefan Fritsch]

  *) mod_proxy_http: Support the 'ping' property for backend HTTP/1.1 servers
     via leveraging 100-Continue as the initial "request".
     [Jim Jagielski]

  *) core/mod_authz_core: Introduce new access_checker_ex hook that enables
     mod_authz_core to bypass authentication if access should be allowed by
     IP address/env var/... [Stefan Fritsch]

  *) core: Introduce note_auth_failure hook to allow modules to add support
     for additional auth types. This makes ap_note_auth_failure() work with
     mod_auth_digest again. PR 48807. [Stefan Fritsch]

  *) socache modules: return APR_NOTFOUND when a lookup is not found [Nick Kew]

  *) mod_authn_socache: new module [Nick Kew]

  *) configure: Add reallyall option for --enable-mods-shared. [Stefan Fritsch]

  *) Fix Windows build when using VC6. [Gregg L. Smith <lists glewis com>]

  *) mod_rewrite: Allow to set environment variables without explicitly
     giving a value. [Rainer Jung]

  *) mod_rewrite: Remove superfluous EOL from rewrite logging. [Rainer Jung]

  *) mod_include: recognise "text/html; parameters" as text/html
     PR 49616 [Andrey Chernov <ache nagual.pp.ru>]

  *) CGI vars: allow PATH to be set by SetEnv, consistent with LD_LIBRARY_PATH
     PR 43906 [Nick Kew]

  *) Core: Extra robustness: don't try authz and segfault if authn
     fails to set r->user.  Log bug and return 500 instead.
     PR 42995 [Nick Kew]

  *) HTTP protocol filter: fix handling of longer chunk extensions
     PR 49474 [<tee.bee gmx.de>]

  *) Update SSL cipher suite and add example for SSLHonorCipherOrder.
     [Lars Eilebrecht, Rainer Jung]

  *) move AddOutputFilterByType from core to mod_filter.  This should
     fix nasty side-effects that happen when content_type is set
     more than once in processing a request, and make it fully
     compatible with dynamic and proxied contents. [Nick Kew]

  *) mod_log_config: Implement logging for sub second timestamps and
     request end time.  [Rainer Jung]

Changes with Apache 2.3.6

  *) SECURITY: CVE-2009-3555 (cve.mitre.org)
     mod_ssl: Comprehensive fix of the TLS renegotiation prefix injection
     attack when compiled against OpenSSL version 0.9.8m or later. Introduces
     the 'SSLInsecureRenegotiation' directive to reopen this vulnerability
     and offer unsafe legacy renegotiation with clients which do not yet
     support the new secure renegotiation protocol, RFC 5746.
     [Joe Orton, and with thanks to the OpenSSL Team]

  *) SECURITY: CVE-2009-3555 (cve.mitre.org)
     mod_ssl: A partial fix for the TLS renegotiation prefix injection attack
     by rejecting any client-initiated renegotiations. Forcibly disable
     keepalive for the connection if there is any buffered data readable. Any
     configuration which requires renegotiation for per-directory/location
     access control is still vulnerable, unless using OpenSSL >= 0.9.8l.
     [Joe Orton, Ruediger Pluem, Hartmut Keil <Hartmut.Keil adnovum.ch>]

  *) SECURITY: CVE-2010-0408 (cve.mitre.org)
     mod_proxy_ajp: Respond with HTTP_BAD_REQUEST when the body is not sent
     when request headers indicate a request body is incoming; not a case of
     HTTP_INTERNAL_SERVER_ERROR.  [Niku Toivola <niku.toivola sulake.com>]

  *) SECURITY: CVE-2010-0425 (cve.mitre.org)
     mod_isapi: Do not unload an isapi .dll module until the request
     processing is completed, avoiding orphaned callback pointers.
     [Brett Gervasoni <brettg senseofsecurity.com>, Jeff Trawick]

  *) core: Filter init functions are now run strictly once per request
     before handler invocation.  The init functions are no longer run
     for connection filters.  PR 49328.  [Joe Orton]

  *) core: Adjust the output filter chain correctly in an internal
     redirect from a subrequest, preserving filters from the main
     request as necessary.  PR 17629.  [Joe Orton]

  *) mod_cache: Explicitly allow cache implementations to cache a 206 Partial
     Response if they so choose to do so. Previously an attempt to cache a 206
     was arbitrarily allowed if the response contained an Expires or
     Cache-Control header, and arbitrarily denied if both headers were missing.
     [Graham Leggett]

  *) core: Add microsecond timestamp fractions, process id and thread id
     to the error log. [Rainer Jung]

  *) configure: The "most" module set gets build by default.  [Rainer Jung]

  *) configure: Building dynamic modules (DSO) by default.  [Rainer Jung]

  *) configure: Fix broken VPATH build when using included APR.
     [Rainer Jung]

  *) mod_session_crypto: Fix configure problem when building
     with APR 2 and for VPATH builds with included APR.
     [Rainer Jung]

  *) mod_session_crypto: API compatibility with APR 2 crypto and
     APR Util 1.x crypto. [Rainer Jung]

  *) ab: Fix memory leak with -v2 and SSL. PR 49383.
     [Pavel Kankovsky <peak argo troja mff cuni cz>]

  *) core: Add per-module and per-directory loglevel configuration.
           Add some more trace logging.
     mod_rewrite: Replace RewriteLog/RewriteLogLevel with trace log levels.
     mod_ssl: Replace LogLevelDebugDump with trace log levels.
     mod_ssl/mod_proxy*: Adjust loglevels to be less verbose at levels info
           and debug.
     mod_dumpio:  Replace DumpIOLogLevel with trace log levels.
     [Stefan Fritsch]

  *) mod_ldap: LDAP caching was suppressed (and ldap-status handler returns
     title page only) when any mod_ldap directives were used in VirtualHost
     context.  [Eric Covener]

  *) mod_disk_cache: Decline the opportunity to cache if the response is
     a 206 Partial Content. This stops a reverse proxied partial response
     from becoming cached, and then being served in subsequent responses.
     [Graham Leggett]

  *) mod_deflate: avoid the risk of forwarding data before headers are set.
     PR 49369 [Matthew Steele <mdsteele google.com>]

  *) mod_authnz_ldap: Ensure nested groups are checked when the
     top-level group doesn't have any direct non-group members
     of attributes in AuthLDAPGroupAttribute. [Eric Covener]

  *) mod_authnz_ldap: Search or Comparison during authorization phase
     can use the credentials from the authentication phase
     (AuthLDAPSearchAsUSer,AuthLDAPCompareAsUser).
     PR 48340 [Domenico Rotiroti, Eric Covener]

  *) mod_authnz_ldap: Allow the initial DN search during authentication
     to use the HTTP username/pass instead of an anonymous or hard-coded
     LDAP id (AuthLDAPInitialBindAsUser, AuthLDAPInitialBindPattern).
     [Eric Covener]

  *) mod_authnz_ldap: Publish requested LDAP data with an AUTHORIZE_ prefix
     when this module is used for authorization. See AuthLDAPAuthorizePrefix.
     PR 45584 [Eric Covener]

  *) apxs -q: Stop filtering out ':' characters from the reported values.
     PR 45343.  [Bill Cole]

  *) prefork MPM: Work around possible crashes on child exit in APR reslist
     cleanup code.  PR 43857.  [Tom Donovan]

  *) ab: fix number of requests sent by ab when keepalive is enabled.  PR 48497.
     [Bryn Dole <dole blekko.com>]

  *) Log an error for failures to read a chunk-size, and return 408 instead of
     413 when this is due to a read timeout.  This change also fixes some cases
     of two error documents being sent in the response for the same scenario.
     [Eric Covener] PR49167

  *) mod_proxy_balancer: Add new directive BalancerNonce to allow admin
     to control/set the nonce used in the balancer-manager application.
     [Jim Jagielski]

  *) mod_proxy_connect: Support port ranges in AllowConnect. PR 23673.
     [Stefan Fritsch]

  *) Proxy balancer: support setting error status according to HTTP response
     code from a backend.  PR 48939.  [Daniel Ruggeri <DRuggeri primary.net>]

  *) htcacheclean: Introduce the ability to clean specific URLs from the
     cache, if provided as an optional parameter on the command line.
     [Graham Leggett]

  *) core: Introduce the IncludeStrict directive, which explicitly fails
     server startup if no files or directories match a wildcard path.
     [Graham Leggett]

  *) htcacheclean: Report additional statistics about entries deleted.
     PR 48944. [Mark Drayton mark markdrayton.info]

  *) Introduce SSLFIPS directive to support OpenSSL FIPS_mode; permits all
     builds of mod_ssl to use 'SSLFIPS off' for portability, but the proper
     build of openssl is required for 'SSLFIPS on'.  PR 46270.
     [Dr Stephen Henson <steve openssl.org>, William Rowe]

  *) mod_proxy_http: Log the port of the remote server in various messages.
     PR 48812. [Igor Galic <i galic brainsware org>]

  *) mod_reqtimeout: Do not wrongly enforce timeouts for mod_proxy's backend
     connections and other protocol handlers (like mod_ftp). [Stefan Fritsch]

  *) mod_proxy_ajp: Really regard the operation a success, when the client
     aborted the connection. In addition adjust the log message if the client
     aborted the connection. [Ruediger Pluem]

  *) mod_ssl: Add the 'SSLInsecureRenegotiation' directive, which
     allows insecure renegotiation with clients which do not yet
     support the secure renegotiation protocol.  [Joe Orton]

  *) mod_ssl: Fix a potential I/O hang if a long list of trusted CAs
     is configured for client cert auth. PR 46952.  [Joe Orton]

  *) core: Only log a 408 if it is no keepalive timeout. PR 39785
     [Ruediger Pluem,  Mark Montague <markmont umich.edu>]

  *) support/rotatelogs: Add -L option to create a link to the current
     log file.  PR 48761 [<lyndon orthanc.ca>, Dan Poirier]

  *) mod_ldap: Update LDAPTrustedClientCert to consistently be a per-directory
     setting only, matching most of the documentation and examples.
     PR 46541 [Paul Reder, Eric Covener]

  *) mod_ldap: LDAPTrustedClientCert now accepts CA_DER/CA_BASE64 argument
     types previously allowed only in LDAPTrustedGlobalCert. [Eric Covener]

  *) mod_negotiation: Preserve query string over multiviews negotiation.
     This buglet was fixed for type maps in 2.2.6, but the same issue
     affected multiviews and was overlooked.
     PR 33112 [Joergen Thomsen <apache jth.net>]

  *) mod_ldap: Eliminate a potential crash with multiple LDAPTrustedClientCert
     when some are not password-protected. [Eric Covener]

  *) Fix startup segfault when the Mutex directive is used but no loaded
     modules use httpd mutexes.  PR 48787.  [Jeff Trawick]

  *) Proxy: get the headers right in a HEAD request with
     ProxyErrorOverride, by checking for an overridden error
     before not after going into a catch-all code path.
     PR 41646.  [Nick Kew, Stuart Children]

  *) support/rotatelogs: Support the simplest log rotation case, log
     truncation. Useful when the log is being processed in real time
     using a command like tail. [Graham Leggett]

  *) support/htcacheclean: Teach it how to write a pid file (modelled on
     httpd's writing of a pid file) so that it becomes possible to run
     more than one instance of htcacheclean on the same machine.
     [Graham Leggett]

  *) Log command line on startup, so there's a record of command line
     arguments like -f.  PR 48752.  [Dan Poirier]

  *) Introduce mod_reflector, a handler capable of reflecting POSTed
     request bodies back within the response through the output filter
     stack. Can be used to turn an output filter into a web service.
     [Graham Leggett]

  *) mod_proxy_http: Make sure that when an ErrorDocument is served
     from a reverse proxied URL, that the subrequest respects the status
     of the original request. This brings the behaviour of proxy_handler
     in line with default_handler. PR 47106. [Graham Leggett]

  *) Support wildcards in both the directory and file components of
     the path specified by the Include directive. [Graham Leggett]

  *) mod_proxy, mod_proxy_http: Support remote https proxies
     by using HTTP CONNECT.  PR 19188.
     [Philippe Dutrueux <lilas evidian.com>, Rainer Jung]

  *) apxs: Fix -A and -a options to ignore whitespace in httpd.conf
     [Philip M. Gollucci]

  *) worker: Don't report server has reached MaxClients until it has.
     Add message when server gets within MinSpareThreads of MaxClients.
     PR 46996.  [Dan Poirier]

  *) mod_session: Session expiry was being initialised, but not updated
     on each session save, resulting in timed out sessions when there
     should not have been. Fixed. [Graham Leggett]

  *) mod_log_config: Add the R option to log the handler used within the
     request. [Christian Folini <christian.folini netnea com>]

  *) mod_include: Allow fine control over the removal of Last-Modified and
     ETag headers within the INCLUDES filter, making it possible to cache
     responses if desired. Fix the default value of the SSIAccessEnable
     directive.  [Graham Leggett]

  *) Add new UnDefine directive to undefine a variable. PR 35350.
     [Stefan Fritsch]

  *) Make ap_pregsub(), used by AliasMatch and friends, use the same syntax
     for regex backreferences as mod_rewrite and mod_include: Remove the use
     of '&' as an alias for '$0' and allow to escape any character with a
     backslash. PR 48351. [Stefan Fritsch]

  *) mod_authnz_ldap: If AuthLDAPCharsetConfig is set, also convert the
     password to UTF-8. PR 45318.
     [Johannes Muller <joh_m gmx.de>, Stefan Fritsch]

  *) ab: Fix calculation of requests per second in HTML output. PR 48594.
     [Stefan Fritsch]

  *) mod_authnz_ldap: Failures to map a username to a DN, or to check a user
     password now result in an informational level log entry instead of
     warning level.  [Eric Covener]

Changes with Apache 2.3.5

  *) SECURITY: CVE-2010-0434 (cve.mitre.org)
     Ensure each subrequest has a shallow copy of headers_in so that the
     parent request headers are not corrupted.  Eliminates a problematic
     optimization in the case of no request body.  PR 48359
     [Jake Scott, William Rowe, Ruediger Pluem]

  *) Turn static function get_server_name_for_url() into public
     ap_get_server_name_for_url() and use it where appropriate. This
     fixes mod_rewrite generating invalid URLs for redirects to IPv6
     literal addresses. [Stefan Fritsch]

  *) mod_ldap: Introduce new config option LDAPTimeout to set the timeout
     for LDAP operations like bind and search. [Stefan Fritsch]

  *) mod_proxy, mod_proxy_ftp: Move ProxyFtpDirCharset from mod_proxy to
     mod_proxy_ftp. [Takashi Sato]

  *) mod_proxy, mod_proxy_connect: Move AllowCONNECT from mod_proxy to
     mod_proxy_connect. [Takashi Sato]

  *) mod_cache: Do an exact match of the keys defined by
     CacheIgnoreURLSessionIdentifiers against the querystring instead of
     a partial match.  PR 48401.
     [Dodou Wang <wangdong.08 gmail.com>, Ruediger Pluem]

  *) mod_proxy_balancer: Fix crash in balancer-manager. [Rainer Jung]

  *) Core HTTP: disable keepalive when the Client has sent
     Expect: 100-continue
     but we respond directly with a non-100 response.
     Keepalive here led to data from clients continuing being treated as
     a new request.
     PR 47087 [Nick Kew]

  *) Core: reject NULLs in request line or request headers.
     PR 43039 [Nick Kew]

  *) Core: (re)-introduce -T commandline option to suppress documentroot
     check at startup.
     PR 41887 [Jan van den Berg <janvdberg gmail.com>]

  *) mod_autoindex: support XHTML as equivalent to HTML in IndexOptions,
                    ScanHTMLTitles, ReadmeName, HeaderName
     PR 48416 [Dmitry Bakshaev <dab18 izhnet.ru>, Nick Kew]

  *) Proxy: Fix ProxyPassReverse with relative URL
     Derived (slightly erroneously) from PR 38864 [Nick Kew]

  *) mod_headers: align Header Edit with Header Set when used on Content-Type
     PR 48422 [Cyril Bonte <cyril.bonte free.fr>, Nick Kew>]

  *) mod_headers: Enable multi-match-and-replace edit option
     PR 46594 [Nick Kew]

  *) mod_filter: enable it to act on non-200 responses.
     PR 48377 [Nick Kew]

Changes with Apache 2.3.4

  *) Replace AcceptMutex, LockFile, RewriteLock, SSLMutex, SSLStaplingMutex,
     and WatchdogMutexPath with a single Mutex directive.  Add APIs to
     simplify setup and user customization of APR proc and global mutexes.
     (See util_mutex.h.)  Build-time setting DEFAULT_LOCKFILE is no longer
     respected; set DEFAULT_REL_RUNTIMEDIR instead.  [Jeff Trawick]

  *) http_core: KeepAlive no longer accepts other than On|Off.
     [Takashi Sato]

  *) mod_dav: Remove errno from dav_error interface.  Calls to dav_new_error()
     and dav_new_error_tag() must be adjusted to add an apr_status_t parameter.
     [Jeff Trawick]

  *) mod_authnz_ldap: Add AuthLDAPBindAuthoritative to allow Authentication to
     try other providers in the case of an LDAP bind failure.
     PR 46608 [Justin Erenkrantz, Joe Schaefer, Tony Stevenson]

  *) Build: fix --with-module to work as documented
     PR 43881 [Gez Saunders <gez.saunders virgin.net>]

Changes with Apache 2.3.3

  *) SECURITY: CVE-2009-3095 (cve.mitre.org)
     mod_proxy_ftp: sanity check authn credentials.
     [Stefan Fritsch <sf fritsch.de>, Joe Orton]

  *) SECURITY: CVE-2009-3094 (cve.mitre.org)
     mod_proxy_ftp: NULL pointer dereference on error paths.
     [Stefan Fritsch <sf fritsch.de>, Joe Orton]

  *) mod_ssl: enable support for ECC keys and ECDH ciphers.  Tested against
     OpenSSL 1.0.0b3.  [Vipul Gupta <vipul.gupta sun.com>, Sander Temme]

  *) mod_dav: Include uri when logging a PUT error due to connection abort.
     PR 38149. [Stefan Fritsch]

  *) mod_dav: Return 409 instead of 500 for a LOCK request if the parent
     resource does not exist or is not a collection. PR 43465. [Stefan Fritsch]

  *) mod_dav_fs: Return 409 instead of 500 for Litmus test case copy_nodestcoll
     (a COPY request where the parent of the destination resource does not
     exist). PR 39299. [Stefan Fritsch]

  *) mod_dav_fs: Don't delete the whole file if a PUT with content-range failed.
     PR 42896. [Stefan Fritsch]

  *) mod_dav_fs: Make PUT create files atomically and no longer destroy the
     old file if the transfer aborted. PR 39815. [Paul Querna, Stefan Fritsch]

  *) mod_dav_fs: Remove inode keyed locking as this conflicts with atomically
     creating files. On systems with inode numbers, this is a format change of
     the DavLockDB. The old DavLockDB must be deleted on upgrade.
     [Stefan Fritsch]

  *) mod_log_config: Make ${cookie}C correctly match whole cookie names
     instead of substrings. PR 28037. [Dan Franklin <dan dan-franklin.com>,
     Stefan Fritsch]

  *) vhost: A purely-numeric Host: header should not be treated as a port.
     PR 44979 [Nick Kew]

  *) mod_ldap: Avoid 500 errors with "Unable to set LDAP_OPT_REFHOPLIMIT option to 5"
     when built against openldap by using SDK LDAP_OPT_REFHOPLIMIT defaults unless
     LDAPReferralHopLimit is explicitly configured.
     [Eric Covener]

  *) mod_charset_lite: Honor 'CharsetOptions NoImplicitAdd'.
     [Eric Covener]

  *) mod_ssl: Add support for OCSP Stapling.  PR 43822.
     [Dr Stephen Henson <shenson oss-institute.org>]

  *) mod_socache_shmcb: Allow parens in file name if cache size is given.
     Fixes SSLSessionCache directive mis-parsing parens in pathname.
     PR 47945. [Stefan Fritsch]

  *) htpasswd: Improve out of disk space handling. PR 30877. [Stefan Fritsch]

  *) htpasswd: Use MD5 hash by default on all platforms. [Stefan Fritsch]

  *) mod_sed: Reduce memory consumption when processing very long lines.
     PR 48024 [Basant Kumar Kukreja <basant.kukreja sun.com>]

  *) ab: Fix segfault in case the argument for -n is a very large number.
     PR 47178. [Philipp Hagemeister <oss phihag.de>]

  *) Allow ProxyPreserveHost to work in <Proxy> sections. PR 34901.
     [Stefan Fritsch]

  *) configure: Fix THREADED_MPMS so that mod_cgid is enabled again
     for worker MPM. [Takashi Sato]

  *) mod_dav: Provide a mechanism to obtain the request_rec and pathname
     from the dav_resource. [Jari Urpalainen <jari.urpalainen nokia.com>,
     Brian France <brian brianfrance.com>]

  *) Build: Use install instead of cp if available on installing
     modules to avoid segmentation fault. PR 47951. [hirose31 gmail.com]

  *) mod_cache: correctly consider s-maxage in cacheability
     decisions.  [Dan Poirier]

  *) mod_logio/core: Report more accurate byte counts in mod_status if
     mod_logio is loaded. PR 25656. [Stefan Fritsch]

  *) mod_ldap: If LDAPSharedCacheSize is too small, try harder to purge
     some cache entries and log a warning. Also increase the default
     LDAPSharedCacheSize to 500000. This is a more realistic size suitable
     for the default values of 1024 for LdapCacheEntries/LdapOpCacheEntries.
     PR 46749. [Stefan Fritsch]

  *) mod_rewrite: Make sure that a hostname:port isn't fully qualified if
     the request is a CONNECT request. [Bill Zajac <billz consultla.com>]

  *) mod_cache: Teach CacheEnable and CacheDisable to work from within a
     Location section, in line with how ProxyPass works. [Graham Leggett]

  *) mod_reqtimeout: New module to set timeouts and minimum data rates for
     receiving requests from the client. [Stefan Fritsch]

  *) core: Fix potential memory leaks by making sure to not destroy
     bucket brigades that have been created by earlier filters.
     [Stefan Fritsch]

  *) core, mod_deflate, mod_sed: Reduce memory usage by reusing bucket
     brigades in several places. [Stefan Fritsch]

  *) mod_cache: Fix uri_meets_conditions() so that CacheEnable will
     match by scheme, or by a wildcarded hostname. PR 40169
     [Peter Grandi <pg_asf asf.for.sabi.co.uk>, Graham Leggett]

  *) suxec: Allow to log an error if exec fails by setting FD_CLOEXEC
     on the log file instead of closing it. PR 10744. [Nicolas Rachinsky]

  *) mod_mime: Make RemoveType override the info from TypesConfig.
     PR 38330. [Stefan Fritsch]

  *) mod_cache: Introduce the option to run the cache from within the
     normal request handler, and to allow fine grained control over
     where in the filter chain content is cached. Adds CacheQuickHandler
     directive.  [Graham Leggett]

  *) core: Treat timeout reading request as 408 error, not 400.
     Log 408 errors in access log as was done in Apache 1.3.x.
     PR 39785 [Nobutaka Mantani <nobutaka nobutaka.org>,
     Stefan Fritsch <sf fritsch.de>, Dan Poirier]

  *) mod_ssl: Reintroduce SSL_CLIENT_S_DN, SSL_CLIENT_I_DN, SSL_SERVER_S_DN,
     SSL_SERVER_I_DN back to the environment variables to be set by mod_ssl.
     [Peter Sylvester <peter.sylvester edelweb.fr>]

  *) mod_disk_cache: don't cache incomplete responses, per RFC 2616, 13.8.
     PR15866.  [Dan Poirier]

  *) ab: ab segfaults in verbose mode on https sites
     PR46393.  [Ryan Niebur]

  *) mod_dav: Allow other modules to become providers and add resource types
     to the DAV response. [Jari Urpalainen <jari.urpalainen nokia.com>,
     Brian France <brian brianfrance.com>]

  *) mod_dav: Allow other modules to add things to the DAV or Allow headers
     of an OPTIONS request. [Jari Urpalainen <jari.urpalainen nokia.com>,
     Brian France <brian brianfrance.com>]

  *) core: Lower memory usage of core output filter.
     [Stefan Fritsch <sf sfritsch.de>]

  *) mod_mime: Detect invalid use of MultiviewsMatch inside Location and
     LocationMatch sections.  PR47754. [Dan Poirier]

  *) mod_request: Make sure the KeptBodySize directive rejects values
     that aren't valid numbers. [Graham Leggett]

  *) mod_session_crypto: Sanity check should the potentially encrypted
     session cookie be too short. [Graham Leggett]

  *) mod_session.c: Prevent a segfault when session is added but not
     configured. [Graham Leggett]

  *) htcacheclean: 19 ways to fail, 1 error message. Fixed. [Graham Leggett]

  *) mod_auth_digest: Fail server start when nonce count checking
     is configured without shared memory, or md5-sess algorithm is
     configured. [Dan Poirier]

  *) mod_proxy_connect: The connect method doesn't work if the client is
     connecting to the apache proxy through an ssl socket. Fixed.
     PR29744. [Brad Boyer, Mark Cave-Ayland, Julian Gilbey, Fabrice Durand,
     David Gence, Tim Dodge, Per Gunnar Hans, Emmanuel Elango,
     Kevin Croft, Rudolf Cardinal]

  *) mod_ssl: The error message when SSLCertificateFile is missing should
     at least give the name or position of the problematic virtual host
     definition. [Stefan Fritsch sf sfritsch.de]

  *) mod_auth_digest: Fix null pointer when qop=none. [Dan Poirier]

  *) Add support for HTTP PUT to ab. [Jeff Barnes <jbarnesweb yahoo.com>]

  *) mod_headers: generalise the envclause to support expression
     evaluation with ap_expr parser [Nick Kew]

  *) mod_cache: Introduce the thundering herd lock, a mechanism to keep
     the flood of requests at bay that strike a backend webserver as
     a cached entity goes stale. [Graham Leggett]

  *) mod_auth_digest: Fix usage of shared memory and re-enable it.
     PR 16057 [Dan Poirier]

  *) Preserve Port information over internal redirects
     PR 35999 [Jonas Ringh <jonas.ringh cixit.se>]

  *) Proxy: unable to connect to a backend is SERVICE_UNAVAILABLE,
     rather than BAD_GATEWAY or (especially) NOT_FOUND.
     PR 46971 [evanc nortel.com]

  *) Various modules: Do better checking of pollset operations in order to
     avoid segmentation faults if they fail. PR 46467
     [Stefan Fritsch <sf sfritsch.de>]

  *) mod_autoindex: Correctly create an empty cell if the description
     for a file is missing. PR 47682 [Peter Poeml <poeml suse.de>]

  *) ab: Fix broken error messages after resolver or connect() failures.
     [Jeff Trawick]

  *) SECURITY: CVE-2009-1890 (cve.mitre.org)
     Fix a potential Denial-of-Service attack against mod_proxy in a
     reverse proxy configuration, where a remote attacker can force a
     proxy process to consume CPU time indefinitely.  [Nick Kew, Joe Orton]

  *) SECURITY: CVE-2009-1191 (cve.mitre.org)
     mod_proxy_ajp: Avoid delivering content from a previous request which
     failed to send a request body. PR 46949 [Ruediger Pluem]

  *) htdbm: Fix possible buffer overflow if dbm database has very
     long values.  PR 30586 [Dan Poirier]

  *) core: Return APR_EOF if request body is shorter than the length announced
     by the client. PR 33098 [ Stefan Fritsch <sf sfritsch.de>]

  *) mod_suexec: correctly set suexec_enabled when httpd is run by a
     non-root user and may have insufficient permissions.
     PR 42175 [Jim Radford <radford blackbean.org>]

  *) mod_ssl: Fix SSL_*_DN_UID variables to use the 'userID' attribute
     type.  PR 45107.  [Michael Stroder <michael stroeder.com>,
     Peter Sylvester <peter.sylvester edelweb.fr>]

  *) mod_proxy_http: fix case sensitivity checking transfer encoding
     PR 47383 [Ryuzo Yamamoto <ryuzo.yamamoto gmail.com>]

  *) mod_alias: ensure Redirect issues a valid URL.
     PR 44020 [Hakon Stordahl <hakon stordahl.org>]

  *) mod_dir: add FallbackResource directive, to enable admin to specify
     an action to happen when a URL maps to no file, without resorting
     to ErrorDocument or mod_rewrite.  PR 47184 [Nick Kew]

  *) mod_cgid: Do not leak the listening Unix socket file descriptor to the
     CGI process. PR 47335 [Kornel Pal <kornelpal gmail.com>]

  *) mod_rewrite: Remove locking for writing to the rewritelog.
     PR 46942 [Dan Poirier <poirier pobox.com>]

  *) mod_alias: check sanity in Redirect arguments.
     PR 44729 [Sonke Tesch <st kino-fahrplan.de>, Jim Jagielski]

  *) mod_proxy_http: fix Host: header for literal IPv6 addresses.
     PR 47177 [Carlos Garcia Braschi <cgbraschi gmail.com>]

  *) mod_cache: Add CacheIgnoreURLSessionIdentifiers directive to ignore
     defined session identifiers encoded in the URL when caching.
     [Ruediger Pluem]

  *) mod_rewrite: Fix the error string returned by RewriteRule.
     RewriteRule returned "RewriteCond: bad flag delimiters" when the 3rd
     argument of RewriteRule was not started with "[" or not ended with "]".
     PR 45082 [Vitaly Polonetsky <m_vitaly topixoft.com>]

  *) Windows: Fix usage message.
     [Rainer Jung]

  *) apachectl: When passing through arguments to httpd in
     non-SysV mode, use the "$@" syntax to preserve arguments.
     [Eric Covener]

  *) mod_dbd: add DBDInitSQL directive to enable SQL statements to
     be run when a connection is opened.  PR 46827
     [Marko Kevac <mkevac gmail.com>]

  *) mod_cgid: Improve handling of long AF_UNIX socket names (ScriptSock).
     PR 47037.  [Jeff Trawick]

  *) mod_proxy_ajp: Check more strictly that the backend follows the AJP
     protocol. [Mladen Turk]

  *) mod_proxy_ajp: Forward remote port information by default.
     [Rainer Jung]

  *) Allow MPMs to be loaded dynamically, as with most other modules.  Use
     --enable-mpms-shared={list|"all"} to enable.  This required changes to
     the MPM interfaces.  Removed: mpm.h, mpm_default.h (as an installed
     header), APACHE_MPM_DIR, MPM_NAME, ap_threads_per_child,
     ap_max_daemons_limit, ap_my_generation, etc.  ap_mpm_query() can't be
     called until after the register-hooks phase.  [Jeff Trawick]

  *) mod_ssl: Add SSLProxyCheckPeerExpire and SSLProxyCheckPeerCN directives
     to enable stricter checking of remote server certificates.
     [Ruediger Pluem]

  *) ab: Fix a 100% CPU loop on platforms where a failed non-blocking connect
     returns EINPROGRESS and a subsequent poll() returns only POLLERR.
     Observed on HP-UX.  [Eric Covener]

  *) Remove broken support for BeOS, TPF, and even older platforms such
     as A/UX, Next, and Tandem.  [Jeff Trawick]

  *) mod_proxy_ftp: Add ProxyFtpListOnWildcard directive to allow files with
     globbing characters to be retrieved instead of converted into a
     directory listing.  PR 46789 [Dan Poirier <poirier pobox.com>]

  *) Provide ap_retained_data_create()/ap_retained_data_get() for preservation
     of module state across unload/load.  [Jeff Trawick]

  *) mod_substitute: Fix a memory leak. PR 44948
     [Dan Poirier <poirier pobox.com>]

Changes with Apache 2.3.2

  *) mod_mime_magic: Fix detection of compressed content. [Rainer Jung]

  *) mod_negotiation: Escape paths of filenames in 406 responses to avoid
     HTML injections and HTTP response splitting.  PR 46837.
     [Geoff Keating <geoffk apple.com>]

  *) mod_ssl: add support for type-safe STACK constructs in OpenSSL
     development HEAD.  PR 45521.  [Kaspar Brand, Sander Temme]

  *) ab: Fix maintenance of the pollset to resolve EALREADY errors
     with kqueue (BSD/OS X) and excessive CPU with event ports (Solaris).
     PR 44584.  Use APR_POLLSET_NOCOPY for better performance with some
     pollset implementations.  [Jeff Trawick]

  *) mod_disk_cache: The module now turns off sendfile support if
     'EnableSendfile off' is defined globally. [Lars Eilebrecht]

  *) mod_deflate: Adjust content metadata before bailing out on 304
     responses so that the metadata does not differ from 200 response.
     [Roy T. Fielding]

  *) mod_deflate: Fix creation of invalid Etag headers. We now make sure
     that the Etag value is properly quoted when adding the gzip marker.
     PR 39727, 45023. [Lars Eilebrecht, Roy T. Fielding]

  *) Added 20x22 icons for ODF, SVG, and XML documents.  PR 37185.
     [Peter Harlow]

  *) Disabled DefaultType directive and removed ap_default_type()
     from core.  We now exclude Content-Type from responses for which
     a media type has not been configured via mime.types, AddType,
     ForceType, or some other mechanism. PR 13986. [Roy T. Fielding]

  *) mod_rewrite: Add IPV6 variable to RewriteCond
     [Ryan Phillips <ryan-apache trolocsis.com>]

  *) core: Enhance KeepAliveTimeout to support a value in milliseconds.
     PR 46275. [Takashi Sato]

  *) rotatelogs: Allow size units B, K, M, G and combination of
     time and size based rotation. [Rainer Jung]

  *) rotatelogs: Add flag for verbose (debug) output. [Rainer Jung]

  *) mod_ssl: Fix merging of SSLRenegBufferSize directive. PR 46508
     [<tlhackque yahoo.com>]

  *) core: Translate the the status line to ASCII on EBCDIC platforms in
     ap_send_interim_response() and for locally generated "100 Continue"
     responses.  [Eric Covener]

  *) prefork: Fix child process hang during graceful restart/stop in
     configurations with multiple listening sockets.  PR 42829.  [Joe Orton,
     Jeff Trawick]

  *) mod_session_crypto: Ensure that SessionCryptoDriver can only be
     set in the global scope. [Graham Leggett]

  *) mod_ext_filter: We need to detect failure to startup the filter
     program (a mangled response is not acceptable).  Fix to detect
     failure, and offer configuration option either to abort or
     to remove the filter and continue.
     PR 41120 [Nick Kew]

  *) mod_session_crypto: Rewrite the session_crypto module against the
     apr_crypto API. [Graham Leggett]

  *) mod_auth_form: Fix a pool lifetime issue, don't remove the subrequest
     until the main request is cleaned up. [Graham Leggett]

Changes with Apache 2.3.1

  *) ap_slotmem: Add in new slot-based memory access API impl., including
     2 providers (mod_sharedmem and mod_plainmem) [Jim Jagielski,
     Jean-Frederic Clere, Brian Akins <brian.akins turner.com>]

  *) mod_include: support generating non-ASCII characters as entities in SSI
     PR 25202 [Nick Kew]

  *) core/utils: Enhance ap_escape_html API to support escaping non-ASCII chars
     PR 25202 [Nick Kew]

  *) mod_rewrite: fix "B" flag breakage by reverting r5589343
    PR 45529 [Bob Ionescu <bobsiegen googlemail.com>]

  *) CGI: return 504 (Gateway timeout) rather than 500 when a script
     times out before returning status line/headers.
     PR 42190 [Nick Kew]

  *) mod_cgid: fix segfault problem on solaris.
     PR 39332 [Masaoki Kobayashi <masaoki techfirm.co.jp>]

  *) mod_proxy_scgi: Added. [Andre Malo]

  *) mod_cache: Introduce 'no-cache' per-request environment variable
     to prevent the saving of an otherwise cacheable response.
     [Eric Covener]

  *) mod_rewrite: Introduce DiscardPathInfo|DPI flag to stop the troublesome
     way that per-directory rewrites append the previous notion of PATH_INFO
     to each substitution before evaluating subsequent rules.
     PR 38642 [Eric Covener]

  *) mod_cgid: Do not add an empty argument when calling the CGI script.
     PR 46380 [Ruediger Pluem]

  *) scoreboard: Remove unused sb_type from process_score.
     [Torsten Foertsch <torsten.foertsch gmx.net>, Chris Darroch]

  *) mod_ssl: Add SSLRenegBufferSize directive to allow changing the
     size of the buffer used for the request-body where necessary
     during a per-dir renegotiation.  PR 39243.  [Joe Orton]

  *) mod_proxy_fdpass: New module to pass a client connection over to a separate
     process that is reading from a unix daemon socket.

  *) mod_ssl: Improve environment variable extraction to be more
     efficient and to correctly handle DNs with duplicate tags.
     PR 45975.  [Joe Orton]

  *) Remove the obsolete serial attribute from the RPM spec file. Compile
     against the external pcre. Add missing binaries fcgistarter, and
     mod_socache* and mod_session*. [Graham Leggett]

Changes with Apache 2.3.0

  *) mod_ratelimit: New module to do bandwidth rate limiting. [Paul Querna]

  *) Remove X-Pad header which was added as a work around to a bug in
     Netscape 2.x to 4.0b2. [Takashi Sato <takashi lans-tv.com>]

  *) Add DTrace Statically Defined Tracing (SDT) probes.
    [Theo Schlossnagle <jesus omniti.com>, Paul Querna]

  *) mod_proxy_balancer: Move all load balancing implementations
     as individual, self-contained mod_proxy submodules under
     modules/proxy/balancers [Jim Jagielski]

  *) Rename APIs to include ap_ prefix:
        find_child_by_pid -> ap_find_child_by_pid
        suck_in_APR -> ap_suck_in_APR
        sys_privileges_handlers -> ap_sys_privileges_handlers
        unixd_accept -> ap_unixd_accept
        unixd_config -> ap_unixd_config
        unixd_killpg -> ap_unixd_killpg
        unixd_set_global_mutex_perms -> ap_unixd_set_global_mutex_perms
        unixd_set_proc_mutex_perms -> ap_unixd_set_proc_mutex_perms
        unixd_set_rlimit -> ap_unixd_set_rlimit
     [Paul Querna]

  *) mod_lbmethod_heartbeat: New module to load balance mod_proxy workers
     based on heartbeats. [Paul Querna]

  *) mod_heartmonitor: New module to collect heartbeats, and write out a file
     so that other modules can load balance traffic as needed. [Paul Querna]

  *) mod_heartbeat: New module to generate multicast heartbeats to know if a
     server is online. [Paul Querna]

  *) mod_buffer: Honour the flush bucket and flush the buffer in the
     input filter. Make sure that metadata buckets are written to
     the buffer, not to the final brigade. [Graham Leggett]

  *) mod_buffer: Optimise the buffering of heap buckets when the heap
     buckets stay exactly APR_BUCKET_BUFF_SIZE long. [Graham Leggett,
     Ruediger Pluem]

  *) mod_buffer: Optional support for buffering of the input and output
     filter stacks. Can collapse many small buckets into fewer larger
     buckets, and prevents excessively small chunks being sent over
     the wire. [Graham Leggett]

  *) mod_privileges: new module to make httpd on Solaris privileges-aware
     and to enable different virtualhosts to run with different
     privileges and Unix user/group IDs [Nick Kew]

  *) mod_mem_cache: this module has been removed. [William Rowe]

  *) authn/z: Remove mod_authn_default and mod_authz_default.
     [Chris Darroch]

  *) authz: Fix handling of authz configurations, make default authz
     logic replicate 2.2.x authz logic, and replace <Satisfy*>, Reject,
     and AuthzMergeRules directives with Match, <Match*>, and AuthzMerge
     directives.  [Chris Darroch]

  *) mod_authn_core: Prevent crash when provider alias created to
     provider which is not yet registered.  [Chris Darroch]

  *) mod_authn_core: Add AuthType of None to support disabling
     authentication.  [Chris Darroch]

  *) core: Allow <Limit> and <LimitExcept> directives to nest, and
     constrain their use to conform with that of other access control
     and authorization directives.  [Chris Darroch]

  *) unixd: turn existing code into a module, and turn the set user/group
     and chroot into a child_init function. [Nick Kew]

  *) mod_dir: Support "DirectoryIndex disabled"
     Suggested By Andre Warnier <aw ice-sa.com> [Eric Covener]

  *) mod_ssl: Send Content-Type application/ocsp-request for POST requests to
     OSCP responders. PR 46014 [Dr Stephen Henson <steve openssl.org>]

  *) mod_authnz_ldap: don't return NULL-valued environment variables to
     other modules.  PR 39045 [Francois Pesce <francois.pesce gmail.com>]

  *) Don't adjust case in pathname components that are not of interest
     to mod_mime.  Fixes mod_negotiation's use of such components.
     PR 43250 [Basant Kumar Kukreja <basant.kukreja sun.com>]

  *) Be tolerant in what you accept - accept slightly broken
     status lines from a backend provided they include a valid status code.
     PR 44995 [Rainer Jung <rainer.jung kippdata.de>]

  *) New module mod_sed: filter Request/Response bodies through sed
     [Basant Kumar Kukreja <basant.kukreja sun.com>]

  *) mod_auth_form: Make sure that basic authentication is correctly
     faked directly after login. [Graham Leggett]

  *) mod_session_cookie, mod_session_dbd: Make sure cookies are set both
     within the output headers and error output headers, so that the
     session is maintained across redirects. [Graham Leggett]

  *) mod_auth_form: Make sure the logged in user is populated correctly
     after a form login. Fixes a missing REMOTE_USER variable directly
     following a login. [Graham Leggett]

  *) mod_session_cookie: Make sure that cookie attributes are correctly
     included in the blank cookie when cookies are removed. This fixes an
     inability to log out when using mod_auth_form. [Graham Leggett]

  *) mod_session: Prevent a segfault when a CGI script sets a cookie with a
     null value. [David Shane Holden <dpejesh apache.org>]

  *) core, authn/z: Determine registered authn/z providers directly in
     ap_setup_auth_internal(), which allows optional functions that just
     wrapped ap_list_provider_names() to be removed from authn/z modules.
     [Chris Darroch]

  *) authn/z: Convert common provider version strings to macros.
     [Chris Darroch]

  *) core: When testing for slash-terminated configuration paths in
     ap_location_walk(), don't look past the start of an empty string
     such as that created by a <Location ""> directive.
     [Chris Darroch]

  *) core, mod_proxy: If a kept_body is present, it becomes safe for
     subrequests to support message bodies. Make sure that safety
     checks within the core and within the proxy are not triggered
     when kept_body is present. This makes it possible to embed
     proxied POST requests within mod_include. [Graham Leggett]

  *) mod_auth_form: Make sure the input filter stack is properly set
     up before reading the login form. Make sure the kept body filter
     is correctly inserted to ensure the body can be read a second
     time safely should the authn be successful. [Graham Leggett,
     Ruediger Pluem]

  *) mod_request: Insert the KEPT_BODY filter via the insert_filter
     hook instead of during fixups. Add a safety check to ensure the
     filters cannot be inserted more than once. [Graham Leggett,
     Ruediger Pluem]

  *) ap_cache_cacheable_headers_out() will (now) always
     merge an error headers _before_ clearing them and _before_
     merging in the actual entity headers and doing normal
     hop-by-hop cleansing. [Dirk-Willem van Gulik].

  *) cache: retire ap_cache_cacheable_hdrs_out() which was used
     for both in- and out-put headers; and replace it by a single
     ap_cache_cacheable_headers() wrapped in a in- and out-put
     specific ap_cache_cacheable_headers_in()/out(). The latter
     which will also merge error and ensure content-type. To keep
     cache modules consistent with ease. This API change bumps
     up the minor MM by one [Dirk-Willem van Gulik].

  *) Move the KeptBodySize directive, kept_body filters and the
     ap_parse_request_body function out of the http module and into a
     new module called mod_request, reducing the size of the core.
     [Graham Leggett]

  *) mod_dbd: Handle integer configuration directive parameters with a
     dedicated function.

  *) Change the directives within the mod_session* modules to be valid
     both inside and outside the location/directory sections, as
     suggested by wrowe. [Graham Leggett]

  *) mod_auth_form: Add a module capable of allowing end users to log
     in using an HTML form, storing the credentials within mod_session.
     [Graham Leggett]

  *) Add a function to the http filters that is able to parse an HTML
     form request with the type of application/x-www-form-urlencoded.
     [Graham Leggett]

  *) mod_session_crypto: Initialise SSL in the post config hook.
     [Ruediger Pluem, Graham Leggett]

  *) mod_session_dbd: Add a session implementation capable of storing
     session information in a SQL database via the dbd interface. Useful
     for sites where session privacy is important. [Graham Leggett]

  *) mod_session_crypto: Add a session encoding implementation capable
     of encrypting and decrypting sessions wherever they may be stored.
     Introduces a level of privacy when sessions are stored on the
     browser. [Graham Leggett]

  *) mod_session_cookie: Add a session implementation capable of storing
     session information within cookies on the browser. Useful for high
     volume sites where server bound sessions are too resource intensive.
     [Graham Leggett]

  *) mod_session: Add a generic session interface to unify the different
     attempts at saving persistent sessions across requests.
     [Graham Leggett]

  *) core, authn/z: Avoid calling access control hooks for internal requests
     with configurations which match those of initial request.  Revert to
     original behaviour (call access control hooks for internal requests
     with URIs different from initial request) if any access control hooks or
     providers are not registered as permitting this optimization.
     Introduce wrappers for access control hook and provider registration
     which can accept additional mode and flag data.  [Chris Darroch]

  *) Introduced ap_expr API for expression evaluation.
     This is adapted from mod_include, which is the first module
     to use the new API.
     [Nick Kew]

  *) mod_authz_dbd: When redirecting after successful login/logout per
     AuthzDBDRedirectQuery, do not report authorization failure, and use
     first row returned by database query instead of last row.
     [Chris Darroch]

  *) mod_ldap: Correctly return all requested attribute values
     when some attributes have a null value.
     PR 44560 [Anders Kaseorg <anders kaseorg.com>]

  *) core: check symlink ownership if both FollowSymlinks and
     SymlinksIfOwnerMatch are set [Nick Kew]

  *) core: fix origin checking in SymlinksIfOwnerMatch
     PR 36783 [Robert L Mathews <rob-apache.org.bugs tigertech.net>]

  *) Activate mod_cache, mod_file_cache and mod_disk_cache as part of the
     'most' set for '--enable-modules' and '--enable-shared-mods'. Include
     mod_mem_cache in 'all' as well. [Dirk-Willem van Gulik]

  *) Also install mod_so.h, mod_rewrite.h and mod_cache.h; as these
     contain public function declarations which are useful for
     third party module authors. PR 42431 [Dirk-Willem van Gulik].

  *) mod_dir, mod_negotiation: pass the output filter information
     to newly created sub requests; as these are later on used
     as true requests with an internal redirect. This allows for
     mod_cache et.al. to trap the results of the redirect.
     [Dirk-Willem van Gulik, Ruediger Pluem]

  *) mod_ldap: Add support (taking advantage of the new APR capability)
     for ldap rebind callback while chasing referrals. This allows direct
     searches on LDAP servers (in particular MS Active Directory 2003+)
     using referrals without the use of the global catalog.
     PRs 26538, 40268, and 42557 [Paul J. Reder]

  *) ApacheMonitor.exe: Introduce --kill argument for use by the
     installer.  This will permit the installation tool to remove
     all running instances before attempting to remove the .exe.
     [William Rowe]

  *) mod_ssl: Add support for OCSP validation of client certificates.
     PR 41123.  [Marc Stern <marc.stern approach.be>, Joe Orton]

  *) mod_serf: New module for Reverse Proxying. [Paul Querna]

  *) core: Add the option to keep aside a request body up to a certain
     size that would otherwise be discarded, to be consumed by filters
     such as mod_include. When enabled for a directory, POST requests
     to shtml files can be passed through to embedded scripts as POST
     requests, rather being downgraded to GET requests. [Graham Leggett]

  *) mod_ssl: Fix TLS upgrade (RFC 2817) support.  PR 41231.  [Joe Orton]

  *) scoreboard: Correctly declare ap_time_process_request.
     PR 43789 [Tom Donovan <Tom.Donovan acm.org>]

  *) core; scoreboard: ap_get_scoreboard_worker(sbh) now takes the sbh member
     from the connection rec, ap_get_scoreboard_worker(proc, thread) will now
     provide the unusual legacy lookup.  [William Rowe]

  *) mpm winnt: fix null pointer dereference
     PR 42572 [Davi Arnaut]

  *) mod_authnz_ldap, mod_authn_dbd: Tidy up the code to expose authn
     parameters to the environment. Improve portability to
     EBCDIC machines by using apr_toupper(). [Martin Kraemer]

  *) mod_ldap, mod_authnz_ldap: Add support for nested groups (i.e. the ability
     to authorize an authenticated user via a "require ldap-group X" directive
     where the user is not in group X, but is in a subgroup contained in X.
     PR 42891 [Paul J. Reder]

  *) mod_ssl: Add support for caching SSL Sessions in memcached. [Paul Querna]

  *) apxs: Enhance -q flag to print all known variables and their values
     when invoked without variable name(s).
     [William Rowe, Sander Temme]

  *) apxs: Eliminate run-time check for mod_so.  PR 40653.
     [David M. Lee <dmlee crossroads.com>]

  *) beos MPM: Create pmain pool and run modules' child_init hooks when
     entering ap_mpm_run(), then destroy pmain when exiting ap_mpm_run().
     [Chris Darroch]

  *) netware MPM: Destroy pmain pool when exiting ap_mpm_run() so that
     cleanups registered in modules' child_init hooks are performed.
     [Chris Darroch]

  *) Fix issue which could cause error messages to be written to access logs
     on Win32.  PR 40476.  [Tom Donovan <Tom.Donovan acm.org>]

  *) The LockFile directive, which specifies the location of
     the accept() mutex lockfile, is deprecated. Instead, the
     AcceptMutex directive now takes an optional lockfile
     location parameter, ala SSLMutex. [Jim Jagielski]

  *) mod_authn_dbd: Export any additional columns queried in the SQL select
     into the environment with the name AUTHENTICATE_<COLUMN>. This brings
     mod_authn_dbd behaviour in line with mod_authnz_ldap. [Graham Leggett]

  *) mod_dbd: Key the storage of prepared statements on the hex string
     value of server_rec, rather than the server name, as the server name
     may change (eg when the server name is set) at any time, causing
     weird behaviour in modules dependent on mod_dbd. [Graham Leggett]

  *) mod_proxy_fcgi: Added win32 build. [Mladen Turk]

  *) sendfile_nonblocking() takes the _brigade_ as an argument, gets
     the first bucket from the brigade, finds it not to be a FILE
     bucket and barfs. The fix is to pass a bucket rather than a brigade.
     [Niklas Edmundsson <nikke acc.umu.se>]

  *) mod_rewrite: support rewritemap by SQL query [Nick Kew]

  *) ap_get_server_version() has been removed.  Third-party modules must
     now use ap_get_server_banner() or ap_get_server_description().
     [Jeff Trawick]

  *) All MPMs: Introduce a check_config phase between pre_config and
     open_logs, to allow modules to review interdependent configuration
     directive values and adjust them while messages can still be logged
     to the console.  Handle relevant MPM directives during this phase
     and format messages for both the console and the error log, as
     appropriate.  [Chris Darroch]

  *) core: Do not allow internal redirects like the DirectoryIndex of mod_dir
     to circumvent the symbolic link checks imposed by FollowSymLinks and
     SymLinksIfOwnerMatch. [Nick Kew, Ruediger Pluem, William Rowe]

  *) New SSLLogLevelDebugDump [ None (default) | IO (not bytes) | Bytes ]
     configures the I/O Dump of SSL traffic, when LogLevel is set to Debug.
     The default is none as this is far greater debugging resolution than
     the typical administrator is prepared to untangle.  [William Rowe]

  *) mod_disk_cache: If possible, check if the size of an object to cache is
     within the configured boundaries before actually saving data.
     [Niklas Edmundsson <nikke acc.umu.se>]

  *) Worker and event MPMs: Remove improper scoreboard updates which were
     performed in the event of a fork() failure.  [Chris Darroch]

  *) Add support for fcgi:// proxies to mod_rewrite.
     [Markus Schiegl <ms schiegl.com>]

  *) Remove incorrect comments from scoreboard.h regarding conditional
     loading of worker_score structure with mod_status, and remove unused
     definitions relating to old life_status field.
     [Chris Darroch <chrisd pearsoncmg.com>]

  *) Remove allocation of memory for unused array of lb_score pointers
     in ap_init_scoreboard().  [Chris Darroch <chrisd pearsoncmg.com>]

  *) Add mod_proxy_fcgi, a FastCGI back end for mod_proxy.
     [Garrett Rooney, Jim Jagielski, Paul Querna]

  *) Event MPM: Fill in the scoreboard's tid field. PR 38736.
     [Chris Darroch <chrisd pearsoncmg.com>]

  *) mod_charset_lite: Remove Content-Length when output filter can
     invalidate it.  Warn when input filter can invalidate it.
     [Jeff Trawick]

  *) Authz: Add the new module mod_authn_core that will provide common
     authn directives such as 'AuthType', 'AuthName'.  Move the directives
     'AuthType' and 'AuthName' out of the core module and merge mod_authz_alias
     into mod_authn_core. [Brad Nicholes]

  *) Authz: Move the directives 'Order', 'Allow', 'Deny' and 'Satisfy'
     into the new module mod_access_compat which can be loaded to provide
     support for these directives.
     [Brad Nicholes]

  *) Authz: Move the 'Require' directive from the core module as well as
     add the directives '<SatisfyAll>', '<SatisfyOne>', '<RequireAlias>'
     and 'Reject' to mod_authz_core. The new directives introduce 'AND/OR'
     logic into the authorization processing. [Brad Nicholes]

  *) Authz: Add the new module mod_authz_core which acts as the
     authorization provider vector and contains common authz
     directives. [Brad Nicholes]

  *) Authz: Renamed mod_authz_dbm authz providers from 'group' and
     'file-group' to 'dbm-group' and 'dbm-file-group'. [Brad Nicholes]

  *) Authz: Added the new authz providers 'env', 'ip', 'host', 'all' to handle
     host-based access control provided by mod_authz_host and invoked
     through the 'Require' directive. [Brad Nicholes]

  *) Authz: Convert all of the authz modules from hook based to
     provider based. [Brad Nicholes]

  *) mod_cache: Add CacheMinExpire directive to set the minimum time in
     seconds to cache a document.
     [Brian Akins <brian.akins turner.com>, Ruediger Pluem]

  *) mod_authz_dbd: SQL authz with Login/Session support [Nick Kew]

  *) Fix typo in ProxyStatus syntax error message.
     [Christophe Jaillet <christophe.jaillet wanadoo.fr>]

  *) Asynchronous write completion for the Event MPM.  [Brian Pane]

  *) Added an End-Of-Request bucket type.  The logging of a request and
     the freeing of its pool are now done when the EOR bucket is destroyed.
     This has the effect of delaying the logging until right after the last
     of the response is sent; ap_core_output_filter() calls the access logger
     indirectly when it destroys the EOR bucket.  [Brian Pane]

  *) Rewrite of logresolve support utility: IPv6 addresses are now supported
     and the format of statistical output has changed. [Colm MacCarthaigh]

  *) Rewrite of ap_coreoutput_filter to do nonblocking writes  [Brian Pane]

  *) Added new connection states for handler and write completion
     [Brian Pane]

  *) mod_cgid: Refuse to work on Solaris 10 due to OS bugs.  PR 34264.
     [Justin Erenkrantz]

  *) Teach mod_ssl to use arbitrary OIDs in an SSLRequire directive,
     allowing string-valued client certificate attributes to be used for
     access control, as in: SSLRequire "value" in OID("1.3.6.1.4.1.18060.1")
     [Martin Kraemer, David Reid]

  [Apache 2.3.0-dev includes those bug fixes and changes with the
   Apache 2.2.xx tree as documented, and except as noted, below.]

Changes with Apache 2.2.x and later:

  *) http://svn.apache.org/viewvc/httpd/httpd/branches/2.2.x/CHANGES?view=markup

Changes with Apache 2.0.x and later:

  *) http://svn.apache.org/viewvc/httpd/httpd/branches/2.0.x/CHANGES?view=markup

